(function(w){
    window.$API = window.$API || {}
    // 规格尺码相关api
    $API.product = {
        // 获取多个商品颜色尺码
        qryColorSizeUnitByProductIds(data){
            return request({
                url: 'scm/product/qryColorSizeUnitByProductIds.json',
                method: 'post',
                data: data
            })
        },
        // 获取多个的主辅单位
        qryUnitListByProductIds(data){
            return request({
                url: 'sso/unit/qryUnitListByProductIds.json',
                method: 'post',
                data: data
            })
        },
        // 获取商品id的主辅单位
        qryUnitListByProductId(data){
            return request({
                url: 'sso/unit/qryUnitListByProductId.json',
                method: 'post',
                data: data
            })
        },
        // 查询所有库房
        qryDepotAll(){
            return request({
                url: 'scm/depot/list.json',
                method: 'get',
            })
        },
        // 查询一级分类
        qryAllLevelOneCategory(){
            return request({
                url: 'scm/productcategory/qryAllLevelOneCategory.json',
                method: 'get',
            })
        },
        // 查询二级分类
        qryAllLevelTwoCategory(data){
            return request({
                url: 'scm/productcategory/qryAllLevelTwoCategory.json',
                method: 'post',
                data: data
            })
        },
        // 批量查询商品信息
        qryOpByIdProduct(data){
            return request({
                url: 'scm/product/qryOpByIds.json',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 商品列表查询
        qryOpByModelOrName(data){
            return request({
                url: 'scm/product/qryOpByModelOrName.json',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 查询商品图片
        qryProductPicturesById(data){
            return request({
                url: 'scm/product/qryProductPicturesById',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 查询商品库存信息
        qryProductionBatchList(data) {
            return request({
                url: 'scm/productionbatch/dataGrid.json',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 查询商品信息
        qryProduct(data) {
            return request({
                url: 'scm/product/qryOp.json',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 查询批次批次记录列表
        qryProductionBatchDataGridBNTracking(data) {
            return request({
                url: 'scm/productionbatch/dataGridBNTracking.json',
                method: 'post',
                timeout: 20000,
                data: data
            })
        },
        // 批量查询ColorSizeIds
        qryColorSizeIdsByProductIds(data) {
            return request({
                url: 'scm/product/qryColorSizeIdsByProductIds.json',
                method: 'post',
                timeout: 10000,
                data: data
            })
        },
        // 删除批次号
        deleteBatch(data){
            return request({
                url: 'scm/productionbatch/delete.json',
                method: 'post',
                timeout: 10000,
                data: data
            })
        }
    }
})(window)
