(function (w){
    const baseUrl = severUrl
    w.request = function (options){
        let _baseUrl = options.baseUrl || baseUrl
        let paramsSrt = ''
        if (options.params){
            paramsSrt += '?'
            for(let key in options.params){
                if(options.params.hasOwnProperty(key))
                paramsSrt += key + '=' + options.params[key] + '&'
            }
            paramsSrt = paramsSrt.substring(0,  paramsSrt.length - 1)
        }
        return new Promise(function (resolve, reject){
            mui.ajax({
                url: _baseUrl + options.url + paramsSrt,
                type: options.method || 'get',
                dataType: 'json', // 预期服务器返回的数据类型；如果不指定，mui将自动根据HTTP包的MIME头信息自动判断
                timeout: options.timeout || 30000, //超时时间
                xhrFields: {
                    withCredentials: true
                },
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                data: options.data || '',
                success: function (res,type,xhr) {
                    if(res && intercept(res))return;
                    if(res && res.success){
                        success(res)
                    }else{
                        error(res,type,xhr)
                    }
                },
                error: error,
                complete: function (){
                    options.complete && options.complete()
                }
            })
            function success(res){
                options.success && options.success(res)
                resolve(res)
                // mui.toast(res.msg)
            }
            function error(data,type,xhr){
                console.error('requestError:',arguments)
                options.error && options.error(data,type,xhr)
                reject({data:data,type:type,xhr:xhr})
                if(data && data.msg && !options.notToast){
                    mui.toast(data.msg)
                }
            }
        })
    }
    function intercept(res){
        // 登录失效
        if(res.status === 10101 || res.status === 10102) {
            if(logOut){
                logOut(res.msg)
                return true // 终止返回
            }else{
                mui.toast(res.msg)
            }
        }
    }
})(window)