const EVENTLISTENER = {
    addKeyboardEventListener(cbFn){
        if(mui){
            mui.plusReady(function(){
                if(plus.os.name === 'iOS'){
                    EVENTLISTENER.addKeyboardEventListenerIOS(cbFn)
                }else{
                    EVENTLISTENER.addKeyboardEventListenerAndroid(cbFn)
                }
            })
        }
    },
    // android 键盘收回
     addKeyboardEventListenerAndroid(cbFn){
        let originHeight = window.innerHeight;
        window.addEventListener('resize',function (){
            let currHeight = window.innerHeight;

            if(currHeight < originHeight){
                //当软键盘弹起，在此处操作
                cbFn&&cbFn('show')
            }else{
                //当软键盘收起，在此处操作
                cbFn&&cbFn('hide')
            }

        })
    },
    // ios 键盘收回
    addKeyboardEventListenerIOS(cbFn){
        document.body.addEventListener('focusin', () => {
            cbFn&&cbFn('show')
        })
        document.body.addEventListener('focusout', () => {
            cbFn&&cbFn('hide')
        })
    }
}