// 暂时只做了 ios new Payment()pay('type').then()
function Payment(){
    this.restoreFlag = false
    this.channel = null
    this.config = {
        payType: {
          ios: {
              ids: ['1','14','13','11','12','7','8','9','10'],
              'premium': {name: '高级版年费', price: 388, id: '1'},
              'edition': {name: '基础版一次性购买费用', price: 318, id: '14'},
              'depot': {name: '添加一个仓库或店铺', price: 118, id: '13'},
              'product': {name: '添加100款商品', price: 60, id: '11'},
              'staff': {name: '添加一个员工', price: 60, id: '12'},
              'miniEdition': {name: '小程序上商城基础版首年年费', price: 998, id: '7'},
              'miniPremium': {name: '小程序上商城高级版首年年费', price: 1998, id: '8'},
              'miniPremiumRenewal': {name: '小程序上商城高级版次年年费', price: 318, id: '9'},
              'miniEditionRenewal': {name: '小程序上商城基础版次年年费', price: 218, id: '10'},
              // 'supplier': {name: '添加10个供应商', price: 60, id: '10'},// TODO 未提供
              // 'customer': {name: '添加50个客户', price: 60, id: '10'}// TODO 未提供
          },
          android: {}
        }
    }
}
Payment.prototype.pay = function(options) {
    options = options || {}
    let type = options.type, user = options.user, payment = options.payment, quantity = options.quantity;
    let _this = this
    return new Promise(function(resolve, reject) {
        mui.plusReady(function() {
            // ios = appleiap
            _this._getChannels('appleiap').then(function(channel) {
                _this.channel = channel
                return _this._requestOrder(channel)
            }).then(function(channel) {
                return _this._request(channel, type, user, quantity)
            }).then(resolve).catch(reject)
        })

    })
}
Payment.prototype.restoreRequest = function (type){
    // 恢复购买方法（获取已购的非消耗性商品和订阅商品及丢单的商品包括消耗类型商品）
    // 如果用户在支付过程中退出了App，或其他情况造成的丢单的消耗类型商品在支付完成后，首次调用该接口可返回支付凭证
    this.channel.restoreComplateRequest({}, function(results) {
        console.log('type:', type)
        console.log('results:', JSON.stringify(results))
        // results 格式为数组存放恢复的IAP商品交易信息对象 IAPTransaction，需要将返回的支付凭证传给后端进行二次认证
    });
    this.restoreFlag = false
}
// 获取支付通道
Payment.prototype._getChannels = function(id){
    return new Promise(function (resolve, reject){
        plus.payment.getChannels(function(channels) {
            for (let i in channels) {
                let channel = channels[i];
                if (channel.id === id) {
                    resolve(channel)
                    break
                }
            }
        }, reject);
    })
}
// 请求支付订单
Payment.prototype._requestOrder = function(channel) {
    let _this = this
    plus.nativeUI.showWaiting('检测支付环境...');
    return new Promise(function(resolve, reject) {
        channel.requestOrder(_this.config.payType.ios.ids, function(e) {
            plus.nativeUI.closeWaiting();
            resolve(channel)
        }, function(e) {
            plus.nativeUI.closeWaiting();
            plus.nativeUI.alert("错误信息：" + e.message, null, "支付失败：" + e.code);
            reject(e)
        });
    })
}
// 调起支付
Payment.prototype._request = function(channel, type, user, quantity){
    let productid = this.config.payType.ios[type].id
    let _this = this
    _this.restoreFlag = true
    return new Promise(function (resolve, reject) {
        plus.nativeUI.showWaiting('请稍后...');
        plus.payment.request(channel, {
            productid: productid,
            username: user || '',
            quantity: quantity || 1,
            optimize: true
        }, function(result) {
            _this.restoreFlag = false
            plus.nativeUI.closeWaiting();
            resolve(result)
            // plus.nativeUI.alert("支付成功！", function() {
            //     console.log('_request-results:', JSON.stringify(result))
            // });
        }, function(e) {
            plus.nativeUI.closeWaiting();
            console.error('_request-results:', JSON.stringify(e))
            _this.restoreRequest('request')
            plus.nativeUI.alert("错误信息：" + e.message, null, "支付失败：" + e.code);
            reject(e)
        });
    })

}

/**
 * 设置vue实例上的支付显示变量
 * @param v
 */
function setVuePaymentType(v){
    // test
    // v.$set(v, 'isIosOne', true)
    // v.$set(v, 'isIosPayment', true)
    // end
    if(mui.os.ios === true && localStorage.getItem('open_pay_ios') === '1'){
        v.$set(v, 'isIosOne', true)
    }else if(mui.os.ios === true && localStorage.getItem('open_pay_ios') === '2'){
        v.$set(v, 'isIosOne', true)
        v.$set(v, 'isIosPayment', true)
    }
}

let payment = null
// 支付时跳出app后返回
document.addEventListener('resume',function(){
    if(payment && payment.restoreFlag) { // 需要恢复支付结果
        payment.restoreRequest('resume')
    }
},false);
function fixedEncodeURIComponent (str) {
    return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
        return '%' + c.charCodeAt(0).toString(16).toUpperCase();
    });
}

(function(w){
    window.$API = window.$API || {}
    // 单据相关api
    $API.payment = {
        updatePermissionForIOSPay(data){
            return request({
                url: 'sso/company/updatePermissionForIOSPay.json',
                method: 'post',
                data: data,
                timeout: 10000,
            })
        },
    }
})(window)