(function() {
    var TOUCHSTART, TOUCHMOVE, TOUCHEND;
    if(typeof(window.ontouchstart) != 'undefined') {
        TOUCHSTART = 'touchstart';
        TOUCHEND = 'touchend';
        TOUCHMOVE = 'touchmove';

    } else if(typeof(window.onmspointerdown) != 'undefined') {
        TOUCHSTART = 'MSPointerDown';
        TOUCHEND = 'MSPointerUp';
        TOUCHMOVE = 'MSPointerMove';
    } else {
        TOUCHSTART = 'mousedown';
        TOUCHEND = 'mouseup';
        TOUCHMOVE = 'mousemove';
    }

    function tap(node) {
        var intval,timeOutEvent;
        node.oncontextmenu = function() {
            return false;
        };
        node.addEventListener(TOUCHSTART, function(e) {
            intval=setTimeout(function(){
            	e.target.dispatchEvent(new CustomEvent('longtap', {
                    'detail': e
                }));
            },1000);
        });
		    node.addEventListener(TOUCHMOVE, function(e) {
            clearTimeout(intval);
        });
        node.addEventListener(TOUCHEND, function(e) {
            clearTimeout(intval);
        });
    }

    tap(document);
})();