const record_type = {
    1: '采购',
    2: '采购订单',
    3: '采购(已撤销)',
    4: '销售',
    5: '销售订单',
    6: '销售(已撤销)',
    7: '盘点',
    8: '盘点草稿',
    9: '调拨',
}

const VM = new Vue({
    el: '#associatRecordVM',
    data: {
        listInfo:[],
        //权限相关
        positionName:false,
        stockManager:false,
        purchaseManager:false,
        companySetIndustry:true,
        labelPprinter:false,
        faAccount:true,
        is_advanced:0,
        company_name:'',
        company_id:'',
        user_id:'',
        jifenshow:false,
        bindDepot:-1,
        //--------------------
        // 进度条DOM
        progressbar: null,
        progressbarBox: null,
        progressbarMsg: null,
        // 停止删除
        stopDelete: false

    },
    methods: {
        getPurview :function(){//获取权限
            var _this = this;
            mui.ajax(severUrl + "sso/user/qryOp.json", {
                data : {
                    id : ''
                },
                headers : {
                    'Content-Type' : 'application/x-www-form-urlencoded'
                },
                xhrFields : {
                    withCredentials : true
                },
                dataType : 'json',
                type : 'post',
                timeout : 30000,
                async : false,
                success : function(res) {
                    if (res.success) {
                        // var position_name = res.data.position_name;
                        _this.company_name = res.data.company_name;
                        _this.company_id = res.data.company_id;
                        _this.bindDepot = res.data.manage_depot_id;
                        _this.user_id = res.data.id;
                        var code = res.data.position,permission = code.permission;
                        if(permission.indexOf('A11_1_O') >=0 || permission.indexOf('A11_1_E') >=0){
                            _this.positionName = true
                        }else{
                            _this.positionName = false
                        }
                        permission.indexOf('A4_1_E') >=0?_this.stockManager = true:_this.stockManager = false;
                        permission.indexOf('FA_ACC') >=0?_this.faAccount = true:_this.faAccount = false;
                        permission.indexOf('LOOK_PURCHASE') >=0?_this.purchaseManager = true:_this.purchaseManager = false;
                        permission.indexOf('ONLY_PRINT') >=0?_this.labelPprinter = true:_this.labelPprinter = false;
                        'RFRk,eYVo,y0oa,mVbc,pqrB,pDAY,CCP2,Oo4T,LfTY'.indexOf(_this.company_id) >=0?_this.jifenshow = true:_this.jifenshow=false
                        _this.companySetIndustry = res.data.company_set_industry;
                    }

                }
            });
        },
        // 撤销跳转
        delete_jump:function(item){
            var listSend = {};
            switch (item.record_type) {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                    listSend.id = item.order_id;
                    listSend.type =(item.record_type === 1 || item.record_type === 2 || item.record_type === 3 )?'supplier':'customer';
                    listSend.htmlType = 'associatRecord';
                    if(item.record_type === 2 || item.record_type === 3 || item.record_type === 5 || item.record_type === 6){
                        if(item.record_type === 2 || item.record_type === 5){
                            listSend.openType = 'associatRecord'
                        }
                        listSend.delOperation = true
                    }
                    viewHandle.viewFire('customerDebets.html','customerDebets',listSend);
                    viewHandle.openWindow('customerDebets.html','customerDebets.html',JSON.stringify(listSend));
                    break;
                case 7:
                case 8:
                    listSend.realname = item.creater_name;
                    listSend.histDetail_id = item.id;
                    listSend.htmlType = 'associatRecord';
                    if(item.record_type === 8){
                        listSend.delOperation = true;
                    }
                    viewHandle.viewFire('historyXQ.html','historyXQ',listSend);
                    viewHandle.openWindow('historyXQ.html','historyXQ.html',JSON.stringify(listSend));
                    break;
                case 9:
                    listSend.realname = item.creater_name;
                    listSend.alltDetail_id = item.id;
                    listSend.htmlType = 'associatRecord';
                    viewHandle.viewFire('allocationXQ.html','allocationXQ',listSend);
                    viewHandle.openWindow('allocationXQ.html','allocationXQ.html',JSON.stringify(listSend));
                    break;
            }
        },
        // 点击删除
        product_del:function (item) {
            var _this = this;
            mui.confirm("是否确认删除？", "警告", ["取消", "确定"], function (e) {
                if (e.index === 1 && buttonClick) {
                    buttonClick = false;
                    var url = ''
                    if (item.record_type === 8) {
                        url = 'scm/stockCheck/del.json'
                    } else {
                        url = 'scm/order/del.json'
                    }
                    del(url)
                }
            }, 'div')
            function del(val) {
                mui.ajax(severUrl + val, {
                    data: {
                        id: item.order_id || item.id,
                    },
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    xhrFields: {
                        withCredentials: true
                    },
                    dataType: 'json',
                    type: 'post',
                    timeout: 60000,
                    success: function (res) {
                        if (res.success) {
                            mui.toast(res.msg);
                            setTimeout(function () {
                                buttonClick = true;
                                _this.delete_splice((item.order_id || item.id),item.record_type)
                            }, 500);
                        } else {
                            buttonClick = true;
                            mui.toast(res.msg);
                        }
                    }
                });
            }
        },
        delete_splice:function(id,type){
            var _this = this;
            mui.each(_this.listInfo,function(i,v){
                if(type !=''){
                    if((v.id == id || v.order_id == id) && v.record_type == type){
                        _this.listInfo.splice(i,1);
                        return false
                    }
                }else{
                    if(v.id == id || v.order_id == id){
                        _this.listInfo.splice(i,1);
                        return false
                    }
                }
            })
        },
        // 全部删除
        deleteAll() {
            if(!this.listInfo.length) return mui.toast('没有可删除的数据')
            let _this = this
            mui.confirm('撤销单据将使库存数量发生变动！\n批量撤销如遇关联财务信息单据将直接撤销！\n确定撤销并删除全部单据？','警告',['取消','确定'],function (e) {
                if(e.index === 1) _this.createTask()
            },'div')
        },
        createTask(){
            let _this = this
            let list = this.listInfo
            let setProgressbar = this.showProgressbar(list.length,this.taskSuccess)
            let i = 0
            subtask(list,i)
            function subtask(list, i){
                if(_this.stopDelete){
                    _this.stopDelete = false
                    setProgressbar('stop')
                    return
                }
                let item = list[i]
                setProgressbar()
                // 如果已经撤销（或不用撤销）则直接调用删除
                if(item.record_type === 3 || item.record_type === 6 || item.record_type === 2 || item.record_type === 5 || item.record_type === 8 ){
                    // 已经撤销
                    _deleteOrder(item)
                    return
                }
                _this.revokeOrder(item).then(function(e){
                    _this.dispatchEvent('product_update',{id: item.id || item.order_id})
                    _deleteOrder(item)
                }).catch(function(e){
                    VM.taskDiscontinue(e)
                })

                function _deleteOrder(item){
                    setProgressbar()
                    function next(){
                        _this.dispatchEvent('product_del',{id: item.id || item.order_id})
                        // i++;
                        if (i === list.length){
                            setProgressbar('hide')
                            return
                        }
                        setTimeout(function(){
                            subtask(list,i)
                        }, 400)
                    }
                    // 盘点 调拨 不用删除
                    if(item.record_type === 7 || item.record_type === 9){
                        next()
                        return
                    }
                    _this.deleteOrder(item)
                        .then(function(){
                            next()
                        })
                        .catch(function(e){
                            item.record_type === 1 && (item.record_type = 3)
                            item.record_type === 4 && (item.record_type = 6)
                            VM.taskDiscontinue(e)}
                        )
                }
            }
        },
        /**
         * 创建进度并显示 100%后自动隐藏
         * @param length 总长度
         * @param cbFn 100%后的回调函数
         * */
        showProgressbar(length,cbFn){
            let _this = this
            let status = '撤销'
            let stepLength = length * 2 // 全部步骤
            let step = 0 // 当前步骤
            _this.progressbar.setProgress(0)
            _this.progressbarBox.style.display = 'block'
            // _this.progressbarMsg.innerHTML = '正在撤销第1条，还剩'+(stepLength - step)+'条。'
            return function (type){
                if(type === 'stop'){
                    _this.progressbarBox.style.display = 'none'
                    cbFn && cbFn('stop')
                }
                if(type === 'hide'){
                    _this.progressbarBox.style.display = 'none'
                    cbFn && cbFn('hide')
                    return
                }
                step ++
                status = step%2 ? '撤销' : '删除'
                let _step = Number((step/2).toFixed(0))
                _this.progressbar.setProgress(step/stepLength*100 - 1)
                _this.progressbarMsg.innerHTML = '正在'+status+'第'+_step+'条，还剩'+(length - _step)+'条。'
            }
        },
        // 根据单据类型 调用相关的撤销方法
        revokeOrder(item){
            let _requestRevert
            switch (item.record_type){
                case 1 :
                case 2 :
                case 3 :
                case 4 :
                case 5 :
                case 6 : _requestRevert = $API.order.revertOrder; break;
                case 7 :
                case 8 : _requestRevert = $API.order.revertStockCheck; break;
                case 9 : _requestRevert = $API.order.revertStockAllot; break
            }
            return _requestRevert({id: item.id || item.order_id, revertFA: true})
        },
        // 撤销后删除
        deleteOrder(item){
            let _requestRevert = item.record_type === 8 ? $API.order.delStockCheck : $API.order.delOrder
            return _requestRevert({id: item.id || item.order_id})
        },
        // 批量删除遇到失败
        taskDiscontinue(e){
            this.progressbarBox.style.display = 'none'
            mui.alert(e.type === 'success' ? e.data.msg : '网络错误','错误',['确定'],function (){
            },'div')
        },
        // 批量删除遇到完成
        taskSuccess(e){
            if(e === 'stop'){
                return
            }
            mui.alert('全部删除完成！','成功',['确定'],function (){
                // 返回上层页面
                viewHandle.back('close')
            },'div')
        },
        // 触发自定义事件
        dispatchEvent(type, detail){
            let event = document.createEvent("HTMLEvents");
            event.initEvent(type)
            event.detail = detail
            window.dispatchEvent(event)
        }

    },
    created: function(){

    },
    mounted:function () {
        var _this = this;
        mui.plusReady(function () {
            var arg = plus.webview.currentWebview().arg;
            if(arg){
                arg = JSON.parse(arg);
                _this.listInfo = arg.list
                console.log(_this.listInfo)
            }
            //_this.getPurview()
        })
        window.addEventListener('product_update',function(e){
            mui.each(_this.listInfo,function(i,v){
                 if(v.order_id == e.detail.id){
                      if(v.record_type == 1){
                          v.record_type = 3
                      }else if(v.record_type == 4){
                          v.record_type = 6
                      }
                      return false
                 }
            })
        })
        window.addEventListener('product_del',function(e){
            _this.delete_splice(e.detail.id,(e.detail.type || ''))
        })
        this.progressbar = mui("#mui-progressbar").progressbar()
        this.progressbarBox = document.querySelector('.mui-progressbar-box')
        this.progressbarMsg = this.progressbarBox.querySelector('.mui-progressbar-msg')
        this.progressbarBox.querySelector('.stop-delete').addEventListener('tap', function (e){
            _this.stopDelete = true
        })
    }
});

mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
});
