mui.plusReady(function(){
	var arg = plus.webview.currentWebview().arg;
	if(arg){
		arg = JSON.parse(arg);
		classificationPageVM.fromType = arg.fromType || '';
		classificationPageVM.batchProduct = arg.batchProduct || [];
		sessionStorage.setItem("category_id",arg.category_id || '');
		sessionStorage.setItem("category_name",arg.category_name || '');
		sessionStorage.setItem("category_parent_name",arg.category_parent_name || '');
		classificationPageVM.getCategoryList();
	}
});
window.addEventListener("classificationUpdate",function(e) {
	classificationPageVM.fromType = e.detail.fromType || '';
	classificationPageVM.batchProduct = e.detail.batchProduct || [];
	sessionStorage.setItem("category_id",e.detail.category_id || '');
	sessionStorage.setItem("category_name",e.detail.category_name || '');
	sessionStorage.setItem("category_parent_name",e.detail.category_parent_name || '');
	classificationPageVM.getCategoryList();
});
var classificationPageVM = new Vue({
	el: '#classificationPageVM',
	data: {
		fromType:'',
		batchProduct:[], //批量操作商品信息
		saveOldName:'',

		delClassify:{},
		showProductToast:false,
		
		searchText:'',
		categoryList:[],
		categoryLikeVal:'',
		isSortChange:false,//二级分类立即保存 一级分类点击确定再保存
	},
	watch:{
		categoryList:{
			deep:true,
			handler(){
				this.initChoose()
			}
		}
	},
	methods: {
		closeOneCategoryTransparent:function (event,index){
			$("#oneC"+index).css('display','none')
		},
		closeTwoCategoryTransparent:function (event,p_index,c_index){
			$("#twoC"+p_index+c_index).css('display','none')
		},
		getCategoryList:function() {
			let _this = this
			mui.ajax(severUrl + "scm/productcategory/categoryList.json",{
				data:{},
				type:'POST',
				timeout: 10000,//超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				success:function(res){
					if (res && 200 == res.status) {
						var category_parent_name=sessionStorage.getItem("category_parent_name");
						var category_name=sessionStorage.getItem("category_name");
						let categoryList = res.data
						categoryList.forEach(categoryItem=>categoryItem.is_add_color = false)
						let categoryListOne = categoryList.filter(categoryItem =>!categoryItem.parent_id)
						categoryList = categoryListOne.map(categoryItem=>{
							let childList = categoryList.filter(childItem=>categoryItem.id ==childItem.parent_id)
							categoryItem.child = childList
							categoryItem.showChild = false
							
							childList.forEach(childItem=>{
								if(category_parent_name && category_parent_name!='undefined'){
									if(category_name && category_name!='undefined'){
										if(category_name == childItem.name){
											childItem.is_add_color = true
										}else{
											childItem.is_add_color =false
										}
									}
								}else{
									childItem.is_add_color =false
								}
							})
							
							return categoryItem
						})
						categoryListOne.forEach(categoryItem=>{
							if(category_parent_name && category_parent_name!='undefined'){
								if(category_parent_name == categoryItem.name){
									categoryItem.is_add_color = true;
								}else{
									categoryItem.is_add_color = false;
								}
							}else{
								if(category_name == categoryItem.name){
									categoryItem.is_add_color = true;
								}else{
									categoryItem.is_add_color = false;
								}
							}
						})
						
					    _this.categoryList = categoryList;
					    _this.$forceUpdate();
					}
				}
			})
		},
		//添加分类
		createCategory:function(name,id){
			let _this = this
			mui.ajax(severUrl + "scm/productcategory/createCategory.json",{
				data:{
					name:name,
					parent_id:id // 不传创建的是一级分类
				},
				type:'POST',
				timeout: 10000,//超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				success:function(res){
					if(res.success){
						if(id !='' && id!=null){
							_this.domTwoAdd(res.data.id,res.data.name,id)
						}else{
							_this.domAdd(res.data.id,res.data.name)
						}
					}
					mui.toast(res.msg)
				}
			})
		},
		domAdd:function (id, name){
			classificationPageVM.categoryList.unshift({
				id:id,
				name:name,
				child: [],
				is_add_color: false,
				showChild:false,
				level: 1,
				parent_id: ""
			})
		},
		domTwoAdd:function(id, name,parent_id){
			let categoryOneItem = classificationPageVM.categoryList.find(categoryItem=>categoryItem.id == parent_id)
			categoryOneItem.child.unshift({
				id:id,
				name:name,
				is_add_color: false,
				level: 2,
				parent_id:parent_id
			})
			categoryOneItem.showChild = true
		},
		//删除分类
		editCategory:function(event,id,type,p_index,c_index){
			let _this = this
			mui.confirm("确认删除分类?", "提示", ["取消","确定"], function (e) {
				if(e.index==1){
					mui.ajax(severUrl + "scm/productcategory/deleteCategory.json",{
						data:{
							id:id,
							level:type
						},
						type:'POST',
						timeout: 10000,//超时时间设置为10秒；
						headers: {
							'Content-Type': 'application/x-www-form-urlencoded'
						},
						xhrFields: {
							withCredentials: true
						},
						success:function(res){
							if(res.success){
								if(type == 1){
									_this.categoryList.splice(p_index,1)
								}else{
									_this.categoryList[p_index].child.splice(c_index,1)
								}
								mui.toast(res.msg)
							}else{
								var delClassify= {
									id:id,
									level:type,
									p_index,
									c_index,
									title:"分类删除",
									msg:res.msg,
									productList: res.data
								};
								_this.delClassify=delClassify
								_this.showProductToast=true
							}
						}
					})
				}
			},'div')
		},
		popConfirm:function(){
			var _this=this
			var id    = this.delClassify.id;
			var level = this.delClassify.level
			let {p_index,c_index} = this.delClassify
			mui.ajax(severUrl + "scm/productcategory/deleteCategory.json",{
				data:{
					id:id,
					level:level,
					confirmDelete:true
				},
				type:'POST',
				timeout: 10000,//超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				success:function(res){
					if(res.success){
						if(level == 1){
							_this.categoryList.splice(p_index,1)
						}else{
							_this.categoryList[p_index].child.splice(c_index,1)
						}
					}
					_this.showProductToast=false
					mui.toast(res.msg)
				}
			})
		},
		//保存旧名字
		saveOldNameHandle:function(event){
			this.saveOldName = event.currentTarget.value;
			if(event.currentTarget.value == "请输入一级分类名称" || event.currentTarget.value == "请输入二级分类名称"){
				event.currentTarget.value ="";
			}
		},
		//修改分类
		addCategory:function(event,id,type,p_index,c_index){
			var _this=this
			var name = event.currentTarget.value;
			let categoryInfo = null
			if(type == 1){
				categoryInfo = _this.categoryList.find(categoryItem=>categoryItem.id == id)
				//恢复遮罩
				$("#oneC"+p_index).css('display','block')
			}else{
				//恢复遮罩
				$("#twoC"+p_index+c_index).css('display','block')
				_this.categoryList.forEach(categoryItem=>{
					let childInfo = categoryItem.child.find(childItem=>childItem.id == id)
					if(childInfo){
						categoryInfo = childInfo
					}
				})
			}
			if(name == '' || name ==null){
				categoryInfo.name = _this.saveOldName;
				return;
			}
			mui.ajax(severUrl + "scm/productcategory/modifyCategory.json",{
				data:{
					id:id,
					name:name
				},
				type:'POST',
				timeout: 10000,//超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				success:function(res){
					if(res.success){
						categoryInfo.name = name
					}
					mui.toast(res.msg)
				}
			});
		},
		
		batchSave:function(){
			let _this = this
			var category_id = sessionStorage.getItem("category_id");
			if(!category_id){
				return mui.toast("请选择分类")
			}
			viewHandle.waiting("请等待");
			mui.ajax(severUrl + "scm/product/setCategoryByIds.json",{
				data:{
					list:_this.batchProduct,
					listlength:_this.batchProduct.length,
					category:category_id
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType:'json',//服务器返回json格式数据
				type:'post',//HTTP请求类型
				timeout:120000,
				success:function(res){
					viewHandle.close()
					mui.toast(res.msg);
					if(res.success){
						setTimeout(function(){
							//一级分类更改
							if(classificationPageVM.isSortChange){
								saveCategorySort()
							}
							viewHandle.viewFire('cun.html','closeOperation')
							viewHandle.back('close')
						},500)
					}
				},
				error:function(err){
					viewHandle.close()
				}
			});
		},
		popBack:function(){
			this.showProductToast=false
		},
		
		chooseItem(event,type,p_index,c_index){
			var _this=this
			if(type == 1){
				_this.categoryList.forEach((categoryItem,categoryIndex)=>{
					if(categoryIndex != p_index){
						categoryItem.is_add_color = false
					}
					categoryItem.child.forEach(childItem=>{
						childItem.is_add_color = false
					})
				})
				_this.categoryList[p_index].is_add_color = !_this.categoryList[p_index].is_add_color
			}else{
				_this.categoryList.forEach((categoryItem,categoryIndex)=>{
					categoryItem.is_add_color = false
					categoryItem.child.forEach((childItem,childIndex)=>{
						if(!(categoryIndex==p_index && childIndex == c_index)){
							childItem.is_add_color = false
						}
					})
				})
				_this.categoryList[p_index].is_add_color = true;
				_this.categoryList[p_index].child[c_index].is_add_color = !_this.categoryList[p_index].child[c_index].is_add_color;
			}
		},
		initChoose(){
			let _this = this
			let categoryList = _this.categoryList
			sessionStorage.removeItem("category_id");
			sessionStorage.removeItem("category_name");
			sessionStorage.removeItem("category_parent_name");
			categoryList.forEach(categoryItem=>{
				if(categoryItem.is_add_color){
					let chooseChildItem = categoryItem.child.find(childItem=>childItem.is_add_color)
					if(chooseChildItem){
						sessionStorage.setItem("category_id",chooseChildItem.id);
						sessionStorage.setItem("category_name",chooseChildItem.name);
						sessionStorage.setItem("category_parent_name",categoryItem.name);
					}else{
						sessionStorage.setItem("category_id",categoryItem.id);
						sessionStorage.setItem("category_name",categoryItem.name);
						sessionStorage.setItem("category_parent_name","");
					}
				}
			})
		}
	},
	created:function(){
		
	},
	computed:{
		showCategory:function () {
			let _this=this
			let categoryLikeVal=this.categoryLikeVal
			let categoryList = JSON.parse(JSON.stringify(this.categoryList))
			categoryList = categoryList.map(function (item) {
				// 包含一级分类
				if(item.name.toString().toUpperCase().indexOf(categoryLikeVal.toString().toUpperCase()) >=0){
					return item
				}else{
					// 包含二级分类
					let isIncludeTwo = false
					let childList = item.child.map(function (childItem) {
						if(childItem.name.toString().toUpperCase().indexOf(categoryLikeVal.toString().toUpperCase()) >=0){
							isIncludeTwo = true
							return childItem
						}else{
							return {
								hide:true
							}
						}
					})
					if(isIncludeTwo){
						item.child = childList
						return item
					}else{
						return {
							hide:true
						}
					}
				}
			});
			return categoryList
		}
	},
	mounted:function (){
		var _this = this;
		var winHeight = $(window).height();  //获取当前页面高度
		$(window).resize(function () {
			var u = navigator.userAgent, app = navigator.appVersion;
			var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //android终端或者uc浏览器
			var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
			if(isAndroid){
				var thisHeight = $(this).height();
				if ( winHeight - thisHeight > 140 ) {
				} else {
					var inputs = document.getElementsByTagName("input")
					for(var i =0; i<inputs.length; i++){
						if(inputs[i] == document.activeElement){
                            inputs[i].blur()
                        }
					}
				}
			}else if(isiOS){

			}
		});
	}
});
//新建一级
mui("body").on('tap','.addIcon',function(){
    var oneLevels = document.getElementsByClassName("oneLevel");
    for(var i =0; i<oneLevels.length; i++){
        if(oneLevels[i].value == "请输入一级分类名称"){
            mui.toast("已有未命名分类,请勿重复创建");
            return false;
        }
    }
	classificationPageVM.createCategory("请输入一级分类名称",'');
});
//新建二级
mui("body").on('tap','.addTwoIcon',function(){
    var twoLevels = document.getElementsByClassName("twoLevel");
    for(var i =0; i<twoLevels.length; i++){
        if(twoLevels[i].value == "请输入二级分类名称"){
            mui.toast("已有未命名分类,请勿重复创建")
            return false;
        }
    }
    var id = this.dataset.onecategory;
    classificationPageVM.createCategory("请输入二级分类名称",id);
});
mui('.mui-content').on('tap','.mui-icon',function(){
	var onecategory = this.dataset.onecategory;
	var index = this.dataset.index;
	let categoryOneItem = classificationPageVM.categoryList.find(categoryItem=>categoryItem.id == onecategory)
	if(!categoryOneItem.showChild){
		if(categoryOneItem.child.length){
			$(this).removeClass("mui-icon-arrowdown");
			$(this).addClass("mui-icon-arrowup");
			categoryOneItem.showChild = true
			openSortableForTwoCategory(index)
		}else{
			mui.toast("未创建子分类")
		}
	}else{
		$(this).addClass("mui-icon-arrowdown");
		$(this).removeClass("mui-icon-arrowup");
		categoryOneItem.showChild = false
	}
});

mui('body').on('tap','.muiBack',function(){
	if(classificationPageVM.fromType == 'cun'){
		//一级分类更改
		if(classificationPageVM.isSortChange){
			saveCategorySort()
		}
		return viewHandle.back('close')
	}
	//一级分类更改
	if(classificationPageVM.isSortChange){
		saveCategorySort()
	}
	var listSend = {
		category_id : sessionStorage.getItem("category_id") || '',
		category_name : sessionStorage.getItem("category_name") || '',
		category_parent_name : sessionStorage.getItem("category_parent_name") || ''
	};
	if(classificationPageVM.fromType == 'change'){
		viewHandle.viewFire('changeItem.html','categoryUpdate',listSend);
	}else{
		viewHandle.viewFire('itemAdd.html','categoryUpdate',listSend);
	}
	localStorage.setItem("productListPage","refresh");
	localStorage.setItem("pinProductListPage","refresh");
	localStorage.setItem("draftProductListPage","refresh");
	localStorage.setItem("pinDraftProductListPage","refresh");
	localStorage.setItem("cunInventoryListPage","refresh");
	localStorage.setItem("cunAlloctionListPage","refresh");
	viewHandle.back('close')
});
function openSortableForTwoCategory(index){
	Sortable.create(document.getElementById('categoryTwo'+index), {
		animation: 150,
		delay:500,//拖拽0.5s后开始响应
		onEnd: function(evt) {
			console.log(evt)
			console.log('onEnd.foo:', [evt.item, evt.from]);
			if(classificationPageVM.showCategory.filter(function(item){return item.hide!=true}).length!=classificationPageVM.categoryList.length){
				mui.toast('搜索期间不能进行拖拽排序！')
				return false;
			}
			// 这里是一级分类
			if(evt.oldIndex!=evt.newIndex){
				//	1  保存临时数据
				let tempData=classificationPageVM.categoryList[index].child[evt.oldIndex]
				// 2 删除移动处的数据
				classificationPageVM.categoryList[index].child.splice(evt.oldIndex,1)
				// 3 在停止的地方添加数据
				classificationPageVM.categoryList[index].child.splice(evt.newIndex,0,tempData)
				// 4 保存二级分类排序
				saveCategorySortTwo(index)
			}
		}
	});
}
//保存 二级分类 顺序
function saveCategorySortTwo(parentIndex){
	let ids
	classificationPageVM.categoryList[parentIndex].child.forEach(function (item){
		if(ids){
			ids+=';'+item.id
		}else{
			ids=item.id
		}
	})
	mui.ajax({
		url: severUrl+ "scm/productcategory/dragSort.json",
		type: "post",
		async: false,
		data: {
			"ids": ids,
			'parent_id':classificationPageVM.categoryList[parentIndex].child[0].parent_id
		},
		success: function (res) {
			if(res.success){
				mui.toast("二级分类顺序保存成功")
			}
		}
	})
}

//保存 一级分类 顺序
function saveCategorySort(){
	let ids
	classificationPageVM.categoryList.forEach(function (item){
		if(ids){
			ids+=';'+item.id
		}else{
			ids=item.id
		}
	})
	mui.ajax({
		url: severUrl + "scm/productcategory/dragSort.json",
		type: "post",
		async: false,
		data: {
			"ids": ids
		},
		success: function (res) {
			if(res.success){
				mui.toast("一级分类顺序保存成功")
			}
		}
	})
}