function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if (r != null) return decodeURIComponent(r[2]);
	return null;
}
window.addEventListener("showInfo", function(e) {
	localStorage.setItem("productId", e.detail.productId);
	loadProductDtsInfo();
	e.detail.selectDepot ? sessionStorage.setItem("selectedDepot", e.detail.selectDepot) : ''
	e.detail.type ? getGoodsMenu(e.detail.type) : getGoodsMenu();
	kufang();
	goodsMenuVM.fromHtml = e.detail.fromHtml || ''
});
mui.plusReady(function() {
	var arg = plus.webview.currentWebview().arg;
	if (arg) {
		arg = JSON.parse(arg);
		localStorage.setItem("productId", arg.productId);
		loadProductDtsInfo();
		arg.selectDepot ? sessionStorage.setItem("selectedDepot", arg.selectDepot) : ''
		arg.type ? getGoodsMenu(arg.type) : getGoodsMenu();
		kufang();
		goodsMenuVM.fromHtml = arg.fromHtml || ''
	}
});
window.addEventListener("editRefresh", function() { //修改更新
	loadProductDtsInfo();
	kufang();
});
var goodsMenuVM = new Vue({
	el: '#goodsMenuVM',
	data: {
		systemSetting:JSON.parse(localStorage.systemSetting),
		vipLevel:localStorage.getItem("vipLevel"),
		colorList: [],
		sizeList: [],
		selTabId: '',
		product: {
			model: '',
			purchase_price: ''
		},
		purchase_price: 0,
		totalPrice: "",
		totalAmount: "",
		selectedDepot: "",
		titleSwitch: true,
		inventoryTotal: 0,
		beforeInventoryTotal: 0,
		profitCount: 0,
		profitPrice: 0,
		stock: '',
		isOpen: false,
		fromHtml: '', //商品修改盘点跳转参数
		//全行业参数
		size_show: localStorage.getItem("size_show") || 1,
		color_show: localStorage.getItem("color_show") || 1,
		unit_show: localStorage.getItem("unit_show") || 0,
		origin_specification: localStorage.getItem("origin_specification") || 0,
		//权限相关
		positionName: false,
		stockManager: false,
		purchaseManager: false,
		companySetIndustry: true,
		labelPprinter: false,
		faAccount: true,
		is_advanced: 0,
		company_name: '',
		company_id: '',
		user_id: '',
		jifenshow: false,
		bindDepot: -1,
		//--------------------
		unitData: {
			productId: null,
			mainUintName: null
		}
	},
	watch: {
		purchase_price: {
			handler: function(newVal) {
				if (parseFloat(newVal) < 0) {
					mui.alert("价格不能小于0");
					this.purchase_price = this.product.purchase_price;
				}
				this.calculation();
			},
			deep: true
		}
	},
	methods: {
		getPurview: function() { //获取权限
			var _this = this;
			mui.ajax(severUrl + "sso/user/qryOp.json", {
				data: {
					id: ''
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 30000,
				async: false,
				success: function(res) {
					if (res.success) {
						// var position_name = res.data.position_name;
						_this.company_name = res.data.company_name;
						_this.company_id = res.data.company_id;
						_this.bindDepot = res.data.manage_depot_id;
						_this.user_id = res.data.id;
						var code = res.data.position,
							permission = code.permission;
						if (permission.indexOf('A11_1_O') >= 0 || permission.indexOf('A11_1_E') >= 0) {
							_this.positionName = true
						} else {
							_this.positionName = false
						}
						permission.indexOf('A4_1_E') >= 0 ? _this.stockManager = true : _this.stockManager = false;
						permission.indexOf('FA_ACC') >= 0 ? _this.faAccount = true : _this.faAccount = false;
						permission.indexOf('LOOK_PURCHASE') >= 0 ? _this.purchaseManager = true : _this.purchaseManager = false;
						permission.indexOf('ONLY_PRINT') >= 0 ? _this.labelPprinter = true : _this.labelPprinter = false;
						'RFRk,eYVo,y0oa,mVbc,pqrB,pDAY,CCP2,Oo4T,LfTY'.indexOf(_this.company_id) >= 0 ? _this.jifenshow = true :
							_this.jifenshow = false
						_this.companySetIndustry = res.data.company_set_industry;
					}

				}
			});
		},
		calculation: function() {
			var inventoryTotal = 0;
			var beforeInventoryTotal = 0;
			var profitCount = 0;
			var profitPrice = 0;
			mui.each(this.product.list, function(index, value) {
				if (value.inventoryTotal!=='') {
					beforeInventoryTotal += Number(value.amount);
					inventoryTotal += Number(value.inventoryTotal);
				}
			});
			this.inventoryTotal = inventoryTotal;
			this.beforeInventoryTotal = beforeInventoryTotal;
			this.profitCount = numToCur(Number(inventoryTotal) - Number(beforeInventoryTotal),goodsMenuVM.systemSetting.amount_decimals_setting);
			this.profitPrice = numToCur((inventoryTotal - beforeInventoryTotal) * this.purchase_price,goodsMenuVM.systemSetting.price_decimals_setting,'price');
		},
		changeTab: function(color) {
			this.selTabId = color.color_id;
		},
		batchAddCount: function(list, color_id) {
			for (var i = 0, len = list.length; i < len; i++) {
				if (list[i].color_id == color_id) {
					list[i].inventoryTotal = numToCur(Number(list[i].inventoryTotal) + 1,goodsMenuVM.systemSetting.amount_decimals_setting);
				}
			}
			this.product.list = list;
			this.calculation();
		},
		batchReduceCount: function(list, color_id) {
			for (var i = 0, len = list.length; i < len; i++) {
				if (list[i].color_id == color_id) {
					list[i].inventoryTotal = numToCur(Number(list[i].inventoryTotal) - 1,goodsMenuVM.systemSetting.amount_decimals_setting);
				}
			}
			this.product.list = list;
			this.calculation();
		},
		addCount: function(item) {
			item.inventoryTotal = numToCur(Number(item.inventoryTotal) + 1,goodsMenuVM.systemSetting.amount_decimals_setting);
			this.calculation();
		},
		reduceCount: function(item) {
			// if (item.inventoryTotal > 0) {
			// }
			item.inventoryTotal = numToCur(Number(item.inventoryTotal) - 1,goodsMenuVM.systemSetting.amount_decimals_setting);
			this.calculation();
		},
		saveList: function() {
			this.product.amt = this.purchase_price;
			var selProductList = [];
			if (sessionStorage.getItem("panDraft") == 'panDraft') {
				selProductList = JSON.parse(localStorage.getItem("selDraftProductList"));
			} else {
				selProductList = JSON.parse(localStorage.getItem("inventoryProductList"));
			}
			this.product.list.forEach(function(p) {
				if(goodsMenuVM.unitData.productId === p.product_id){
					p.main_uint_name = goodsMenuVM.unitData.mainUintName
				} else {
					console.error('未匹配到单位')
				}
			})
			if (!selProductList || selProductList.length == 0) {
				selProductList = [];
				goodsMenuVM.product.depot_id = goodsMenuVM.selectedDepot;
				selProductList.push(goodsMenuVM.product);
			} else {
				console.log(selProductList);
				mui.each(selProductList, function(index, value) {
					if (value.product_id == goodsMenuVM.product.product_id && value.depot_id == goodsMenuVM.selectedDepot) {
						
						$.each(value.list,function(a,b){
						    $.each(goodsMenuVM.product.list,function(c,d){
						        if(b.color_id == d.color_id && b.size_id == d.size_id){
									d.product_sn_list=b.product_sn_list||[]
									d.product_sn_list_old=b.product_sn_list_old||[]
						        	return;
								}
						    });
						});
						
						value.list = goodsMenuVM.product.list;
						value.amt = goodsMenuVM.product.amt;
						return false;
					} else if (index == selProductList.length - 1) {
						goodsMenuVM.product.depot_id = goodsMenuVM.selectedDepot;
						selProductList.push(goodsMenuVM.product);
						console.log(selProductList);
						return false;
					}
				});
				console.log(selProductList)
			}
			if (sessionStorage.getItem("panDraft") == 'panDraft') {
				localStorage.removeItem('type');
				localStorage.setItem("selDraftProductList", JSON.stringify(selProductList));
			} else {
				localStorage.setItem("inventoryProductList", JSON.stringify(selProductList));
			}
			console.log(this.inventoryTotal, this.beforeInventoryTotal, this.profitCount, this.profitPrice);
			this.calculation();
			sessionStorage.removeItem("type");
			if (goodsMenuVM.fromHtml == "changeItem") {
				var change = plus.webview.getWebviewById("changeItem.html");
				change.close();
				var cun = plus.webview.getWebviewById("cun.html");
				var listSend = {};
				if (cun) {
					listSend.fromType = 'changeItem';
					viewHandle.viewFire('cun.html', 'panAndAllotAdd', listSend);
					viewHandle.openWindow('cun.html', 'cun.html')
				} else {
					listSend.fromType = 'changeItem';
					viewHandle.openWindow('cun.html', 'cun.html', JSON.stringify(listSend))
				}
				sessionStorage.clear()
			} else if (goodsMenuVM.fromHtml == "inventTory") {
				viewHandle.viewFire('cun.html', 'inventTory');
				viewHandle.openWindow('cun.html', 'cun.html')
			} else {
				if (localStorage.getItem("type") == 6) {
					mui('#goodsInventory')[0].style.display = "none";
					mui('#cunInventoryListVM')[0].style.display = "block";
					viewHandle.viewFire('cun.html', 'panAndAllotAdd');
					viewHandle.back()
				} else {
					if (sessionStorage.getItem("panDraft") == 'panDraft') {
						if (mui('#cunInventoryListVM')[0]) {
							mui('#goodsInventory')[0].style.display = "none";
							mui('#cunInventoryListVM')[0].style.display = "block";
						}
						viewHandle.viewFire('panDraft.html', 'panAndAllotAdd');
						viewHandle.back()
					} else {
						viewHandle.viewFire('cun.html', 'panAndAllotAdd');
						viewHandle.back()
					}
				}
			}
		}
	},
	mounted: function() {
		var _this = this;
		FastClick.attach(document.body);
		mui.plusReady(function() {
			_this.getPurview()
		})
	}
});

function companyQry() {
	mui.ajax(severUrl + "scm/productpicture/qry.json", {
		data: {
			"productId": getQueryString('productId') || sessionStorage.getItem("productId") || localStorage.getItem(
				"productId")
		},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		dataType: 'json',
		type: 'post',
		timeout: 10000,
		success: function(res) {
			var src = '';
			if (null != res.data && res.data != "") {
				src = img_url + res.data.name;
				$(".phUpload").attr("src", src);
			} else {
				src = "img/tx.jpg";
				$(".phUpload").attr("src", src);
			}
		}
	});
}

/**
 * load product dts info
 */
function loadProductDtsInfo() {
	companyQry();
	let id = getQueryString('productId') || sessionStorage.getItem("productId") || localStorage.getItem("productId")
	mui.ajax(severUrl + "scm/product/qryOp.json", {
		data: {
			"id": id
		},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		dataType: 'json',
		type: 'get',
		timeout: 10000,
		success: function(res) {
			if (res.success) {
				//goodsMenuVM.product.model = res.data.model;
				goodsMenuVM.product.purchase_price = res.data.purchase_price;
				goodsMenuVM.purchase_price = res.data.purchase_price;

				var x = [];
				x.push({
					"billsn": res.data.billsn,
					"category": res.data.category,
					"id": res.data.id,
					"model": res.data.model,
					"material": res.data.material,
					"name": res.data.name,
					"purchase_price": res.data.purchase_price,
					"sale_price": res.data.sale_price,
					"sale_price_b": res.data.sale_price_b,
					"status": res.data.status,
					"stock_warn": res.data.stock_warn,
					"unit": res.data.unit,
					"colorlist": res.data.colorlist,
					"colornamelist": res.data.colornamelist,
					"sizelist": res.data.sizelist,
					"sizenamelist": res.data.sizenamelist,
					"company_id": res.data.company_id,
					"remark": res.data.remark,
					"barcodes": res.data.barcodes,
					"main_uint_name": res.data.main_uint_name
				});
				goodsMenuVM.unitData.productId = id || null
				goodsMenuVM.unitData.mainUintName = res.data.main_uint_name || null

				var category = res.data.category;
				sessionStorage.setItem('category_id', category);
				sessionStorage.setItem('category_name', '');
				sessionStorage.setItem('category_parent_name', '');
				var parent_id = '';
				if (category != '1' && category != '') {
					var categorylist = res.data.categorylist;
					mui.each(categorylist, function(i, v) {
						if (v.id == category) {
							sessionStorage.setItem('category_name', v.name);
							parent_id = v.parent_id;
							return;
						}
					})
				}
				if (parent_id != '') {
					mui.each(categorylist, function(i, v) {
						if (v.id == parent_id) {
							sessionStorage.setItem('category_parent_name', v.name);
							return;
						}
					})
				}
				sessionStorage.setItem("list", JSON.stringify(x));
				sessionStorage.setItem("name", res.data.name);
				sessionStorage.setItem("model", res.data.model);
				sessionStorage.setItem("material", res.data.material);
				sessionStorage.setItem("purchase_price", res.data.purchase_price);
				sessionStorage.setItem("sale_price", res.data.sale_price);
				sessionStorage.setItem("sale_price_b", res.data.sale_price_b);
				sessionStorage.setItem("selColorList", JSON.stringify(res.data.colornamelist));
				sessionStorage.setItem("selSizeList", JSON.stringify(res.data.sizenamelist));
				sessionStorage.setItem("barcodes", JSON.stringify(res.data.barcodes));
				sessionStorage.setItem("id", res.data.id);
				sessionStorage.setItem("mainUnitId", res.data.main_unit);
				sessionStorage.setItem("mainUnitName", res.data.main_uint_name);
				if (goodsMenuVM.unit_show == 1) {
					var unitChooseList = [],
						unitList = [],
						unitChoose = {};
					if (res.data.main_unit != "" && res.data.main_uint_name != "") {
						unitChoose = {
							id: res.data.main_unit,
							name: res.data.main_uint_name,
							ratio: 1
						};
						unitChooseList.push(unitChoose);
					}
					if (res.data.unitrulelist.length > 0) {
						var list = res.data.unitrulelist;
						for (var i = 0; i < list.length; i++) {
							var info = {
								id: list[i].assist_unit,
								name: list[i].assist_unit_name,
								ratio: list[i].ratio,
								editId: list[i].id,
								product_id: list[i].product_id
							};
							unitChoose = {
								id: list[i].assist_unit,
								name: list[i].assist_unit_name,
								ratio: list[i].ratio
							};
							unitChooseList.push(unitChoose);
							unitList.push(info)
						}
					}
					goodsMenuVM.unitChooseList = unitChooseList;
					goodsMenuVM.unitMinName = '';
					if (goodsMenuVM.unitChooseList.length > 0) {
						goodsMenuVM.unitMinName = goodsMenuVM.unitChooseList[0].name
					}
					sessionStorage.setItem("unitList", JSON.stringify(unitList))
				}
			}
		}
	});
}
/*库房*/
function kufang() {
	var depotList = JSON.parse(localStorage.getItem("depotList"));
	var id = localStorage.selectedDepot || sessionStorage.selectedDepot;
	if (id) {
		mui.each(depotList, function(index, value) {
			if (value.id == id) {
				goodsMenuVM.stock = value.name;
				sessionStorage.setItem("name", value.name);
			}
		});
	} else {
		goodsMenuVM.stock = depotList[0].name;
		sessionStorage.setItem("name", depotList[0].name);
	}
}

function getGoodsMenu(type) {
	sessionStorage.removeItem("panDraft");
	if (type) {
		sessionStorage.setItem("panDraft", type)
	}
	var product = JSON.parse(sessionStorage.getItem("product")) || JSON.parse(localStorage.getItem("product"));
	if (!product) {
		return;
	}
	var depotList = JSON.parse(localStorage.getItem("depotList"));
	goodsMenuVM.selectedDepot = sessionStorage.getItem("selectedDepot") || localStorage.getItem("selectedDepot") ||
		depotList[0].id;
	if (!goodsMenuVM.selectedDepot || goodsMenuVM.selectedDepot == 'undefined') {
		mui.toast("仓库异常！请确认仓库是否正确！")
		return
	}
	goodsMenuVM.product.model = product.model;
	goodsMenuVM.sizeList = [];
	goodsMenuVM.colorList = [];
	mui.ajax(severUrl + "scm/stock/qryOp.json", {
		data: {
			product_id: product.product_id,
			depot_id: goodsMenuVM.selectedDepot,
			needSN:(goodsMenuVM.vipLevel == 1 && goodsMenuVM.systemSetting.sn_setting == 1)?true:false
		},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		beforeSend: function() {
			mui('.loadColorAndSize').button('loading');
		},
		complete: function() {
			mui('.loadColorAndSize').button('reset');
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(res) {
			var colorList = [];
			var sizeList = [];
			mui.each(res.data, function(index, value) {
				value.inventoryTotal = '';
				value.ordertype = 0;
				value.inventoryType = 0; // 盘点类型 0:手动选择，1:扫码
				if (index != 0) {
					var i, j;
					for (i = 0; i < colorList.length; i++) {
						if (value.color_id == colorList[i].color_id) {
							break;
						}
					}
					for (j = 0; j < sizeList.length; j++) {
						if (value.size_id == sizeList[j].size_id) {
							break;
						}
					}
					if (i == colorList.length) {
						colorList.push({
							color_name: value.color_name,
							color_id: value.color_id
						});
					}
					if (j == sizeList.length) {
						sizeList.push({
							size_name: value.size_name,
							size_id: value.size_id
						});
					}
				} else {
					colorList.push({
						color_name: value.color_name,
						color_id: value.color_id
					});
					sizeList.push({
						size_name: value.size_name,
						size_id: value.size_id
					});
				}
			});
			var list_data = res.data;
			mui.each(list_data,function(i,v){
				v.product_sn_list = _.compact(_.split(v.product_sn_list,','));
				v.product_sn_list_old = v.product_sn_list
			})
			product.list = list_data;
			var selProductList = JSON.parse(localStorage.getItem("inventoryProductList")) || JSON.parse(localStorage.getItem(
				"selDraftProductList"));
			if (selProductList && selProductList.length != 0) {
				mui.each(selProductList, function(index, value) {
					if (value.product_id == product.product_id && value.depot_id == goodsMenuVM.selectedDepot) {
						mui.each(product.list, function(index1, value1) {
							mui.each(value.list, function(index2, value2) {
								if (value2.color_id == value1.color_id && value2.size_id == value1.size_id) {
									value1.inventoryTotal = value2.inventoryTotal;
									value1.inventoryType = value2.inventoryType;
									return false;
								}
							});
						});
						// goodsMenuVM.purchase_price=value.amt;
						return false;
					}
				});
			}
			goodsMenuVM.sizeList = sizeList;
			goodsMenuVM.colorList = colorList;
			if (colorList.length != 0) {
				goodsMenuVM.selTabId = colorList[0].color_id;
			}
			mui.each(product.list, function(i, v) {
				if(v.inventoryTotal!==''){
					v.inventoryTotal = numToCur(v.inventoryTotal,goodsMenuVM.systemSetting.amount_decimals_setting);
				}
				v.amount = numToCur(v.amount,goodsMenuVM.systemSetting.amount_decimals_setting);
			});

			goodsMenuVM.product = product;
			goodsMenuVM.calculation();
		}
	});
}

mui('.mui-media').on('tap', '.link-product-attr', function() {
	var productId = getQueryString('productId') || sessionStorage.getItem("productId");
	if (getQueryString('productId')) {
		location = 'changeItem.html?productId=' + productId + '&page=' + 'goodsInventory' + '&type=' + 2;
	} else {
		var listSend = {};
		listSend.list = JSON.parse(sessionStorage.getItem("list"));
		listSend.mainUnitId = sessionStorage.getItem("mainUnitId");
		listSend.mainUnitName = sessionStorage.getItem("mainUnitName");
		listSend.unitList = JSON.parse(sessionStorage.getItem("unitList"));
		listSend.category_id = sessionStorage.getItem("category_id");
		listSend.category_name = sessionStorage.getItem("category_name");
		listSend.category_parent_name = sessionStorage.getItem("category_parent_name");
		viewHandle.viewFire('changeItem.html', 'changeItem', listSend);
		viewHandle.openWindow('changeItem.html', 'changeItem.html', JSON.stringify(listSend));
		//location = 'changeItem.html?productId=' + productId + '&page=' + 'goodsInventory' + '&type='+ 0;
	}
});
mui('.mui-media').on('tap', '.show-img-info', function () {
	var id = sessionStorage.getItem("productId") || localStorage.getItem("productId");
	var name = goodsMenuVM.product.name;
	mui.ajax(severUrl + "scm/product/qryProductPicturesById", {
		data: {
			id: id
		},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(res) {
			if (res.data.length > 0) {
				var list = res.data;
				for (var i = 0; i < list.length; i++) {
					list[i].name = img_url + list[i].name;
					list[i].product_name = name
				}
				var html = '';
				list.forEach(function(v, i) {
					if (v.is_default == 1) {
						html += '<a href="' + v.name + '" class="swipebox" title="主图">' +
							'<img src="' + v.name + '" alt="image">' +
							'</a>'
					} else {
						html += '<a href="' + v.name + '" class="swipebox" title="' + v.product_name + '">' +
							'<img src="' + v.name + '" alt="image">' +
							'</a>'
					}
				});
				$("#photo").html('');
				$("#photo").append(html);
				if (mui.os.ios == true) {
					$(".swipebox")[0].click()
				}
				$(".swipebox")[0].click()
			} else {
				mui.toast("您未上传图片")
			}
		}
	});
});
mui('.mui-bar').on('tap', '.back-cg', function() {
	if (getQueryString("type") == 0) {
		location = 'cunInventoryList.html';
		sessionStorage.removeItem("type");
	} else if (localStorage.getItem("type") == 6) {
		mui('#goodsInventory')[0].style.display = "none";
		mui('#cunInventoryListVM')[0].style.display = "block";
		localStorage.removeItem("type");
	} else if (getQueryString("type") == 2) {
		location = 'cun.html';
	} else {
		viewHandle.back()
	}
	sessionStorage.removeItem("type")
});

mui('.mui-content').on('tap', '.look-price', function() {
	if (!goodsMenuVM.isOpen && goodsMenuVM.purchaseManager) {
		goodsMenuVM.isOpen = true;
	} else if (goodsMenuVM.isOpen && goodsMenuVM.purchaseManager) {
		goodsMenuVM.isOpen = false;
	} else {
		mui.toast('没有查看权限！');
	}
});

function clearZero(obj) {
	obj.value = "";
	return false;
}

function hideBottom(type) {
	if (type == 1) {
		mui('.goodsI-pd')[0].style.display = 'none';
	} else {
		mui('.goodsI-pd')[0].style.display = 'block';
	}
	goodsMenuVM.calculation()
}

EVENTLISTENER.addKeyboardEventListener(function(type){
	type === 'hide' && hideBottom(2)
})
