window.addEventListener("productUpdate",function(e){ //商品创建/修改更新 (列表重置)
   VM.productUpdate(e)
})

window.addEventListener("repeatOpen",function(e){ //再次进入本页面事件 ( 更新商品列表，更新客户，更新仓库，)
    let data = e.detail
    if(!data.depotId){ // 选择的仓库
        throw new Error('缺少选择的仓库Id')
    }
    VM.depotChange(e.depotId)
    if(e.customer){ // 选择的客户 （没有客户既是盘点调拨等 开单选择需要客户处理价格
        VM.customerChange(e.customer)
    }
    if(e.productList){
        VM.productListChange(e.productList)
    }else{
        VM.productListChange([])
    }

})

window.addEventListener("productSelect",function(e){ //商品选择更新 （更新选择的数据）
    VM.productSelect(e)
})

mui.plusReady(function(){
    // 页面显示事件（再次进入时触发）
    plus.webview.currentWebview().addEventListener('show',function(e){

    })

    mui.toast('arg:'+ plus.webview.currentWebview().arg) // debug
    const args = JSON.parse(plus.webview.currentWebview().arg||'{}');
    if(!args.depotId){ // 选择的仓库
        throw new Error('缺少选择的仓库Id')
    }
    if(args.customer){ // 选择的客户 （没有客户既是盘点调拨等 开单选择需要客户处理价格

    }
    if(args.productList){ // 选择的商品列表

    }else{
        args.productList = []
    }

    if(args.selectedType !== undefined){
        // 0 || 1 (开单，销售采购| 销售退货| 采购退货) undefined ? 盘点调拨等 商品列表不存在重复商品
    }
    if(!args.customer && args.pageId === 'xiao-goodsList'){ // 不需要供应商id
        throw new Error('缺少客户')
    }
    if(!args.pageId){ // 当前的页面id
        throw new Error('缺少当前的页面id')
    }
    if(!args.parentPageId){ // 父级页面的id
        throw new Error('缺少父级页面的id')
    }


    const VM = new Vue({
        el: '#VM',
        data: function(){
            return {
                systemSetting:JSON.parse(localStorage.systemSetting),
                // 页面传递参数
                args: args,
                // 商品列表
                list: [],
                lazyLoadImg: null,
                searchMsg: '',
                searchMsgQueryTimer: null,
                category: {
                    levelOneList: [],
                    levelOne: -1,
                    levelOneOld: -1,
                    levelTwoList: [],
                    levelTwo: '-1-1',
                    levelTwoOld: '-1-1',
                    // 显示的父级分类商品总数
                    showParentProductCount: '',
                },
                show: {
                    categoryFilter: false,
                },
                // 权限 start
                company_name:'',
                company_id:'',
                bindDepot:'',
                user_id:'',
                positionName:'',
                stockManager:'',
                faAccount:'',
                purchaseManager:'',
                labelPprinter:'',
                jifenshow:'',
                companySetIndustry:'',
                // 权限 end
            }
        },
        watch: {
            'show.categoryFilter': function(val){
                let category = this.category
                if(val){
                    category.levelOneOld = category.levelOne
                    category.levelTwoOld = category.levelTwo
                }else{
                    if(category.levelOneOld !== category.levelOne || category.levelTwoOld !== category.levelTwo ){
                        //更新
                        this.pullUpLoading.load(1,true)
                    }
                    category.levelOneOld = category.levelOne
                    category.levelTwoOld = category.levelTwo
                }
            },
            'searchMsg': function(){
                if(this.searchMsgQueryTimer){
                    clearTimeout(this.searchMsgQueryTimer)
                }
                let _this = this
                this.searchMsgQueryTimer = setTimeout(function(){
                   _this.pullUpLoading.load(1,true)
                },1000)
            }
        },
        methods: {
            // 一级分类查询
            getLevelOneCategory(){
                let _this = this
                $API.product.qryAllLevelOneCategory({}).then(function(e){
                    _this.category.levelOneList = e.data
                })
            },
            // 二级分类查询
            getLevelTwoCategory(id){
                let _this = this
                $API.product.qryAllLevelTwoCategory({parent_id:id}).then(function(e){
                    _this.category.levelTwoList = e.data
                })
            },
            // 选择一级分类
            tapCategoryLevelOne(item){
                if(item === 'all'){
                    this.category.showParentProductCount = ''
                    this.category.levelOne = -1
                    this.category.levelTwo = '-1-1'
                    this.category.levelTwoList = []
                }else{
                    if(this.levelOne !== item.id){
                        this.getLevelTwoCategory(item.id)
                    }
                    this.category.showParentProductCount = item.product_count
                    this.category.levelOne = item.id
                    this.category.levelTwo = this.levelOne + '-1'
                }
            },
            // 选择二级分类
            tapCategoryLevelTwo(item){
                if(item === 'all'){
                    this.category.levelTwo = this.category.levelOne + '-1'
                }else{
                    this.category.levelTwo = item.id
                }
            },
            tapMask(){
              this.show.categoryFilter = false
            },
            // 权限获取
            getPurview :function(){//获取权限
                var _this = this;
                $API.user.getCurrUser({id: ''}).then(function(res){
                    // var position_name = res.data.position_name;
                    _this.company_name = res.data.company_name;
                    _this.company_id = res.data.company_id;
                    _this.bindDepot = res.data.manage_depot_id;
                    _this.user_id = res.data.id;
                    var code = res.data.position,permission = code.permission;
                    _this.positionName = permission.indexOf('A11_1_O') >= 0 || permission.indexOf('A11_1_E') >= 0;
                    permission.indexOf('A4_1_E') >=0?_this.stockManager = true:_this.stockManager = false;
                    permission.indexOf('FA_ACC') >=0?_this.faAccount = true:_this.faAccount = false;
                    permission.indexOf('LOOK_PURCHASE') >=0?_this.purchaseManager = true:_this.purchaseManager = false;
                    permission.indexOf('ONLY_PRINT') >=0?_this.labelPprinter = true:_this.labelPprinter = false;
                    'RFRk,eYVo,y0oa,mVbc,pqrB,pDAY,CCP2,Oo4T,LfTY'.indexOf(_this.company_id) >=0?_this.jifenshow = true:_this.jifenshow=false
                    _this.companySetIndustry = res.data.company_set_industry;
                })
            },
            // 商品更新
            productUpdate(){
                this.pullUpLoading.load(1, true)
            },
            // 商品选择列表 更新/添加
            productSelect(e){

            },
            // 仓库更新
            depotChange(e){
                this.pullUpLoading.load(1, true)
            },
            // 客户更新
            customerChange(e){
                if(e && e !== this.args.customer){
                    this.args.customer = e
                    this.pullUpLoading.load(1, true) // 加载商品列表
                    // TODO 客户发送变化 修改已选择商品价格？
                }
            },
            // 传入商品选择列表更新
            productListChange(e){
                this.args.productList = e
            },
            // 查看商品图片
            showImg(item){
                let id = item.id;
                let name = item.name;
                $API.product.qryProductPicturesById({ id: id }).then(function(res){
                    if(res.data.length>0){
                        // var list=res.data;
                        // for(var i=0; i<list.length; i++){
                        //     list[i].name=img_url+list[i].name;
                        //     list[i].product_name=name
                        // }
                        // productListVM.photoList=list;
                        // var html='';
                        // productListVM.photoList.forEach(function(v,i){
                        //     if(v.is_default == 1){
                        //         html +='<a href="'+v.name+'" class="swipebox" title="主图">' +
                        //             '<img src="'+v.name+'" alt="image">' +
                        //             '</a>'
                        //     }else{
                        //         html +='<a href="'+v.name+'" class="swipebox" title="'+v.product_name+'">' +
                        //             '<img src="'+v.name+'" alt="image">' +
                        //             '</a>'
                        //     }
                        // });
                        // $("#photo").html('');
                        // $("#photo").append(html);
                        // if(mui.os.ios == true){
                        //     $(".swipebox")[0].click()
                        // }
                        // $(".swipebox")[0].click()
                    }else{
                        mui.toast("您未上传图片!")
                    }
                })

            },
            // 获取一个商品的已选择数量 newAmount 设置新的值 如果列表中不存在则返回0 (设置新值只对单规格单尺码商品品有用)
            getProductSelectAmount(productId, newAmount){
                let amount = 0
                let _this = this
                let product = this.args.productList.find(function(i){
                    return i.type === _this.args.selectedType && i.id === productId
                })
                if(newAmount || newAmount === 0){
                    if(product.list[0].count !== newAmount){
                        product.list[0].count = newAmount
                    }
                }
                if(product){
                    product.list.forEach(function(i){
                        amount += i.count
                    })
                }
                return amount
            },
            productAmountReduce(item){
                let productId = item.id
                let amount = this.getProductSelectAmount(productId) - 1
                if(amount <= 0){
                    this.getProductSelectAmount(productId, 0)
                }else{
                    this.getProductSelectAmount(productId, amount)
                }
            },
            productAmountAdd(item,e){

                let _this = this
                if(item.isMultipleSpecifications){
                    // 跳转颜色尺码选择
                    return
                }
                let productId = item.id
                let input = e.path[1].querySelector('.number>input')
                this.getSelectProductItem(productId, 'add').then(function(e){
                    let product = e.product
                    _this.$set(product.list[0], 'count' , product.list[0].count + 1)
                    // 只在第一次出现输入框时输入框选择全部
                    if(e.type === 'get'){
                        _this.$nextTick(function(){
                            input.select()
                        })
                    }
                })

                // e.preventDefault()
                // e.stopPropagation()
                return setTimeout(function (){},300)
            },
            // 获取一个选择列表中的商品 type = add 没有则增加
            getSelectProductItem(productId, type){
                let _this = this
                if(this.args.selectedType === undefined){

                }else{
                    let product = this.args.productList.find(function(i){
                        return i.type === _this.args.selectedType && productId === i.id
                    })
                    if(product){
                        return Promise.resolve({product:product, type: 'find'})
                    }else if(type === 'add'){
                       // 添加当前商品
                        return this.setProduct(productId).then(function(product){
                            return Promise.resolve({product:product, type: 'get'})
                        })
                    }
                    // if(this.args.selectedType === 0){
                    //
                    // }
                    // else if(this.args.selectedType === 1){
                    //
                    // }
                }
            },
            // 添加指定商品到商品选择列表
            setProduct(productId){
                let _this = this
                let data = {
                    "product_ids": "'"+productId+"'",
                    "is_default": 0,
                    "depot_id": this.args.depotId
                }
                // 判断销售 查价格
                if(this.args.pageId === 'xiao-goodsList'){
                    data.customer_id = this.args.customer
                    // 客户分类价
                    if(this.systemSetting.customer_category_price === 1){
                        data.ordertype = 1
                        data.type = 0
                    }
                }else{

                }

                return $API.product.qryOpByIdProduct(data).then(function(e){
                    console.log(e)
                    let data = e.data[0]
                    let price // 商品价格 amt

                    // 销售
                    if(_this.args.pageId === 'xiao-goodsList'){
                        price = data.last_amt ? data.last_amt : data.sale_price
                        if(_this.systemSetting.customer_category_price === 1) { // 客户分类价格
                            price = data.customer_category_price || data.sale_price
                        }
                        let product = {
                            amt: price,
                            depot_id: _this.args.depotId,
                            id: productId,
                            list: [],
                            model: data.model,
                            name: data.name,
                            product_id: productId,
                            product_name: data.name,
                            purchase_price: data.purchase_price,
                            sale_price: data.sale_price,
                            status: data.status,
                            type: _this.args.selectedType,
                            unitChooseId: "",//??
                        }
                        let id = productListIdUtil.getNext()
                        let listItem = {
                            // all_sales: 1, //近3月销量？？？？
                            amount: Number(data.amountlist),
                            barcode: data.barcodelist,
                            // color_click_rank: 0, ???
                            color_id: data.colorlist,
                            color_name: data.colornamelist,
                            count: 0,
                            depot_id: product.depot_id,
                            op_id_: id,
                            ordertype: product.type,
                            product_id: product.id,
                            // size_click_rank: 0,
                            size_id: data.sizelist,
                            size_name: data.sizenamelist,
                            type: product.type,
                            // used_amount: 0,
                            __id__: id,
                            __pid__: 0,
                        }
                        product.list.push(listItem)
                        _this.args.productList.push(product)
                        return Promise.resolve(product)
                    }
                })
            },
            // 过滤选择列表 触发事件 返回数据
            enter(){
                // TODO 过滤选择列表 触发事件 返回数据
            },
            // 加载列表 (通过 this.pullUpLoading.load(1, true)调用第一页）
            getList(pageNum){
                let _this = this
                let data = {
                    "rows": 20,
                    "page": pageNum,
                    "condition":_this.searchMsg,
                    "depot_id":_this.args.depotId,
                }
                if(_this.category.levelTwo === '-1-1' && _this.category.levelOne !== -1){ // 一级分类
                    data.category_level = 1
                    data.category = _this.category.levelOne
                }
                else if (_this.category.levelTwo !== '-1-1' && _this.category.levelOne !== -1){ // 二级分类
                    data.category_level = 2
                    data.category = _this.category.levelTwo
                }

                return $API.product.qryOpByModelOrName(data).then(function(res){
                    if(_this.pullUpLoading.data.num === 1){
                        _this.pullUpLoading.reset()
                        _this.list = []
                    }
                    _this.list.push.apply(_this.list,res.data.list)

                    if(_this.pullUpLoading.data.num === 1){
                        _this.$nextTick(function(){
                            mui(_this.pullUpLoading.wrapperClass).scroll().refresh(); //先刷新一次布局再scrollTo
                            mui(_this.pullUpLoading.wrapperClass).scroll().scrollTo(0, 0, 100); //100毫秒滚动到顶
                        })
                    }
                    _this.$nextTick(function(){
                        _this.lazyLoadImg.addElements();
                    })
                    let isEntire = res.data.pageNumber >= res.data.totalPage
                    return Promise.resolve({isEntire: isEntire})
                }).catch(function(e){
                    return Promise.reject(e)
                })
            }
        },
        computed: {
            showList(){
                let _this = this
                return this.list.map(function(i){
                    // 处理单品是否有多规格多尺码
                    i.isMultipleSpecifications = i.colorlist.split(';').length > 1 || i.sizelist.split(';').length > 1;
                    // 匹配价格显示
                    if(_this.args.pageId === 'xiao-goodsList'){
                        i.price = i.sale_price
                    }
                    return i
                })
            },
            total: function(){
                let total = {
                    product: 0,
                    singleProduct: 0
                }
                let _this = this
                this.args.productList.forEach(function(i){
                    if(_this.args.selectedType || _this.args.selectedType === 0){
                        if(i.type === _this.args.selectedType){
                            total.product ++
                            i.list.forEach(function(j){
                                total.singleProduct += j.count
                            })
                        }
                    }else{
                        total.product ++
                        i.list.forEach(function(j){
                            total.singleProduct += j.count
                        })
                    }
                })
                return total
            },
        },
        created(){
            // 事件调用
            window.VM = this
            this.getPurview()
            this.getLevelOneCategory()
        },
        mounted(){
            // 商品列表下拉加载
            let _this = this
            this.pullUpLoading = new $comm.PullUpLoading('.J-scroll', '.J-scroll-wrapper',function(num){
                return _this.getList(num)
            },'.J-pull-caption')
            this.pullUpLoading.load(1)
            this.lazyLoadImg = mui(".J-lazy-load").imageLazyload({
                placeholder: 'img/tx.jpg',
                selector: 'img', //查询哪些元素需要lazyload
                autoDestroy: false, //元素加载完后是否自动销毁当前插件对象
                duration: 1500, //滑动停止多久后开始加载
                diff: 0 //距离视窗底部多少像素出发lazyload
            });

        }
    })



})
mui.init()