let VM, setProduct;
window.addEventListener('productionBatchSetting', function (e) {
	if (setProduct) {
		VM.editNewBNBack(e.detail)
	} else {
		VM.addNewBN(e.detail)
	}
})
mui.plusReady(function(){

	const page = plus.webview.currentWebview()
	const CACHE = {expire_date_ms: {}}
	VM = new Vue({
		el: '#vm',
		data (){
			let systemSetting = JSON.parse(localStorage.systemSetting)
			return {
				// 默认 inventory 盘点， transfer 调拨
				type: page.type || 'inventory',
				productSum: page.selectAmount,
				sort: false,
				preTotal: page.sumAmount,
				allChecked: false,
				notBatchItem: {
					amount: page.sumAmount,
					selectAmount: page.selectAmount
				},
				product: {
					model: page.productModel,
					name: page.productName,
					sizeName:  page.productSizeName,
					colorName: page.productColorName,
					unit: page.productUnit,
					purchasePriceString: '￥' + ( typeof page.purchasePrice === "number" ? page.purchasePrice  : '***')
				},
				show: {
					size: !!Number(localStorage.getItem("size_show") || 1),
					color: !!Number(localStorage.getItem("color_show") || 1),
					unit: page.productUnit !== null && page.productUnit !== undefined && !!Number(localStorage.getItem("unit_show") || 0),
					originSpecification: Number(localStorage.getItem("origin_specification") || 0),
				},
				BNList: [],
				// 新键 的 BN list
				newBNList: [],
				systemSetting: systemSetting
			}
		},
		components: {

		},
		watch: {

		},
		computed: {
			checkedProductSum() {
				if(this.type === 'transfer'){
					let sum = 0
					this.BNList.forEach(function (v) {
						sum += v.selectAmount
					})
					return Number((sum).toFixed(4))
				}
			},
			inventoryTotal() {
				if(this.type !== 'inventory'){
					return null
				}
				let sum = this.notBatchItem.selectAmount
				this.BNList.forEach(function (e) {
					sum += e.selectAmount
				})
				this.newBNList.forEach(function (e) {
					sum += e.selectAmount
				})
				return sum
			},
			profitCount() {
				if(this.type !== 'inventory'){
					return null
				}
				return this.preTotal - this.inventoryTotal
			},
			profitPrice() {
				if(this.type !== 'inventory'){
					return null
				}
				if(typeof page.purchasePrice === "number"){
					return -(this.profitCount * page.purchasePrice)
				}else{
					return '***'
				}
			},
			showBNList(){
				if(this.type !== 'inventory'){
					return this.BNList
				}
				if(this.sort){
					return this.sortBNList()
				}else{
					return this.BNList
				}
			}
		},
		methods: {
			init() {
				let _this = this
				if(page.productColorId && page.productSizeId && page.depotId && page.productColorSizeId && page.productId){
				}else{
					console.error('参数异常', page.productColorId, page.productSizeId, page.depotId, page.productColorSizeId, page.productId)
				}
				$API.product.qryProductionBatchList({
					"depot_id": page.depotId,
					'color_id': page.productColorId,
					'size_id': page.productSizeId,
					'product_color_size_id':page.productColorSizeId || '',
					'product_id':page.productId,
					'page': 1,
					'rows': 1000,
					// "production_batch_number": '',//批次号
					"sort": 'create_date_timestamp',//以什么排序
					"sort_rule": 'asc',//升序降序
				}).then(function(e) {
					_this.fillBNList(e.data.list || [], page.isDraft && page.isOrgAmount)
				})
			},
			fillBNList(list, orderFirstCalculation) {
				let selectAmount = this.notBatchItem.selectAmount
				let amount = this.notBatchItem.amount
				let BNList = []
				let newBNList = []
				let amount_decimals_setting = this.systemSetting.amount_decimals_setting
				list.forEach(function(v){
					v.amount = Number(v.amount.toFixed(amount_decimals_setting))
				})
				if(orderFirstCalculation){
					let map = {}
					page.BNList.forEach(function (v) {
						map[v.production_batch_id] = v
					})
					// 遍历list
					list.forEach(function (v) {
						if(map[v.id] && map[v.id].hasOwnProperty('amount')){
							v.selectAmount = v.amount + map[v.id].amount
						}else{
							v.selectAmount = v.amount
						}
						amount -= v.amount
						selectAmount -= v.selectAmount
						BNList.push(v)
					})
				} else {
					let _this = this
					list.forEach(function(v) {
						amount -= v.amount
						if(v.selectAmount === 0){

						}else{
							if(_this.type === 'transfer') {
								v.selectAmount = v.selectAmount || 0
								v.checked = v.checked || false
							} else {
								v.selectAmount = v.selectAmount || v.amount
							}
						}
						selectAmount -= v.selectAmount
						if(v.isNew){
							newBNList.push(v)
						}else{
							BNList.push(v)
						}
					})
				}
				this.BNList = BNList
				this.newBNList = newBNList
				this.diffBNList()
				this.notBatchItem.selectAmount = Number(selectAmount.toFixed(4))
				this.notBatchItem.amount = Number(amount.toFixed(4))
			},
			changeSelectAmount(item, value) {
				if (this.type === 'transfer') {
					return this.transferChangeSelectAmount(item, value)
				}
				value = Number(value)
				if (item === this.notBatchItem) { //操作无批次
					value = Number(value.toFixed(4))
					item.selectAmount = null
					item.selectAmount = value
				} else {
					if (value < 0) {
						value = 0
					}
					value = Number(value.toFixed(4))
					item.selectAmount = null
					item.selectAmount = value
				}

			},
			transferChangeSelectAmount(item, value) {
				value = Number(Number(value).toFixed(4))
				if (value <= 0) {
					value = 0
				}
				let oldSelectAmount = item.selectAmount
				item.selectAmount = null
				if(value > item.amount && item.amount >= 0){
					value = item.amount
				}
				if(oldSelectAmount !== value && this.allChecked === true){
					this.allChecked = false
				}
				item.selectAmount = value
				item.checked = item.selectAmount > 0;
			},
			tapCheckbox(item) {
				item.checked = !item.checked
				if(item.checked) {
					if (item.amount > 0 && item.amount < 1) {
						item.selectAmount = item.amount
					}else if(item.amount >= 1){
						item.selectAmount = 1
					} else {
						item.checked = !item.checked
					}
				}else{
					item.selectAmount = 0
				}
			},
			tapAllCheckbox() {
				this.allChecked = !this.allChecked
				if(this.allChecked) {
					this.BNList.forEach(function (v) {
						if(v.amount > 0){
							v.selectAmount = v.amount
							v.checked = true
						}
					})
				}else{
					this.BNList.forEach(function (v) {
						if(v.selectAmount > 0){
							v.selectAmount = 0
							v.checked = false
						}
					})
				}
			},
			jumpAddBN(expireDateMs, options) {
				let extras = {
					setPageId: page.id,
					colorName: page.productColorName,
					productModel: page.productModel,
					sizeName: page.productSizeName,
					expireDateMs: expireDateMs
				}
				// 已设置 去编辑
				if (options) {
					extras.productionBatchId = ''
					extras.productionBatchNumber = options.productionBatchNumber || ''
					extras.productionDateTimestamp = options.productionDateTimestamp
				}
				mui.openWindow('../production_batch_set.html', 'production_batch_set.html', {
					extras: extras
				})
			},
			addNewBN(data) {
				this.newBNList.unshift({
				    isNew: true,
					id: productListIdUtil.getNext(),
					amount: 0,
					selectAmount: 0,
					production_date_str: data.production_date_str,
					production_date_timestamp: data.production_date_timestamp,
					expire_date_ms: data.expire_date_ms || '',
					product_color_size_id: page.productColorSizeId,
					production_batch_number: data.production_batch_number,
				})
				this.diffBNList()
			},
			delNewBN(id) {
				let index = this.newBNList.findIndex(function (v) {return v.id === id})
				if(index !== -1){
					let items = this.newBNList.splice(index, 1)
					if(items[0].selectAmount !== 0) {
						this.notBatchItem.selectAmount = Number((this.notBatchItem.selectAmount + items[0].selectAmount).toFixed(4))
					}
					this.diffBNList()
				}
			},
			editNewBN(item) {
				setProduct = item
				let options = {
					productionBatchId: '',
					productionBatchNumber: item.production_batch_number || '',
					productionDateTimestamp: item.production_date_timestamp,
				}
				this.jumpAddBN(item.expire_date_ms|| '', options)
			},
			editNewBNBack(data) {
				setProduct.production_batch_number = data.production_batch_number
				setProduct.production_date_str = data.production_date_str
				setProduct.production_date_timestamp = data.production_date_timestamp
				this.diffBNList()
			},
			diffBNList() {
				for (let i = 0; i < this.BNList.length; i++) {
					let item = this.BNList[i]
					if(!item.isNew) continue
					let f = this.newBNList.find(function(v) {return v === item})
					if(!f){
						this.BNList.splice(i, 1)
						i--
					}
				}
				for (let i = 0; i < this.newBNList.length; i++) {
					let item = this.newBNList[i]
					let f = this.BNList.find(function(v) {return v === item})
					if(!f){
						this.BNList.unshift(item)
					}
				}
			},
			saveBN() {
				function emit (options) {
					let data = {
						type: this.type,
						BNList: this.BNList.length ? this.BNList : null
					}
					let checked = false
					if (this.type === 'transfer') {
						checked = this.BNList.filter(function (v) {
							return v.checked
						}).length !== 0
						if (options === 'change'){
							data.changeProductSum = true
						}
						data.productSum = this.checkedProductSum
					}else{
						data.productSum = this.inventoryTotal
					}
					data.checked = checked

					mui.fire(plus.webview.getWebviewById(page.setPageId), 'panSetBNBack', data)
					setTimeout(function (){
						mui.back()
					},50)
				}
				if(this.type === 'transfer'){
					if(this.checkedProductSum < page.selectAmount){
						let _this = this
						mui.confirm('批次数量少于调拨数量，请选择：', '提示', ['使用原有数量调拨','修改为批次数量调拨', '返回修改'], function (e) {
							if(e.index === 0) {
								setTimeout(emit.bind(_this),10)
							}
							else if(e.index === 1) {
								setTimeout(emit.bind(_this, 'change'),10)
							}
						}, 'div')
						document.querySelector('.mui-popup-button:first-child').style.borderRadius = 0
						let buttons = document.querySelector('.mui-popup-buttons')
						buttons.style.display = 'block'
						buttons.style.height = 'auto'
					}else{
						setTimeout(emit.bind(this),10)
					}
				}else{
					setTimeout(emit.bind(this),10)
				}
			},
			sortBNList() {
				let temp = Array.from(this.BNList)
				return temp.sort(function(a, b){
					return b.amount - a.amount
				})
			}
		},
		beforeCreate(){
			console.log('beforeCreate')
		},
		created(){
			console.log('created')
		},
		beforeMount(){
			console.log('beforeMount')
		},
		mounted(){
			let _this = this
			let loading = false
			let titleDom = document.querySelector('.contentPage-title')
			let addBNBottom = document.querySelector('.add-BN')
			let sortBottom = document.querySelector('.sort-inventory')
			if (this.type === 'transfer') {
				addBNBottom.remove()
				titleDom.append(document.createTextNode('批次选择'))
				let span = document.createElement('span')
				span.style.fontSize = '14px'
				span.append(document.createTextNode(' 调出仓库：' + page.depotName))
				titleDom.append(span)
			}else{
				sortBottom.style.display = 'inline-block'
				sortBottom.addEventListener('tap', function() {
					if(_this.sort === true){
						sortBottom.style.color = '#fff'
						_this.sort = false
					}else{
						sortBottom.style.color = '#ffb03a'
						_this.sort = true
					}
				})
				titleDom.append(document.createTextNode('批次盘点'))
				addBNBottom.addEventListener('tap', function(){
					if (loading) return
					if (CACHE.expire_date_ms.hasOwnProperty(page.productId)) {
						setProduct = null
						_this.jumpAddBN(CACHE.expire_date_ms[page.productId])
					} else {
						loading = true
						$API.product.qryProduct({id: page.productId}).then(function (e) {
							loading = false
							CACHE.expire_date_ms[page.productId] = e.data.expire_date_ms
							setProduct = null
							_this.jumpAddBN(CACHE.expire_date_ms[page.productId])
						}).catch(function() {
							loading = false
						})
					}
				})
			}
			// 盘点订单
			if(page.isDraft){
				// 盘点订单 未初始化的 BNList 首次进入
				if(page.BNList && page.isOrgAmount === true){
					this.init()
				}
				// 没有 BNList
				else if(!page.BNList){
					this.init()
				}
				else if(page.BNList){ // 再次进入
					this.fillBNList(page.BNList)
				}
			}
			// 不是订单
			else {
				if(!page.BNList){ // 盘点首次进入
					this.init()
				}else{ // 再次进入
					this.fillBNList(page.BNList)
				}
			}
			console.log('mounted')
		},
		beforeUpdate(){
			console.log('beforeUpdate')
		},
		updated(){
			console.log('updated')
		},
		beforeDestroy(){
			console.log('beforeDestroy')
		},
		destroyed(){
			console.log('destroyed')
		}
	})

})
