let VM
mui.plusReady(function() {

	const page = plus.webview.currentWebview()

	VM = new Vue({
		el: '#vm',
		data (){
			let systemSetting = JSON.parse(localStorage.systemSetting)
			return {
				type: page.type || 'inventory',
				preTotal: page.preAmount,
				currentTotal: page.nowAmount,
				purchaseManager: page.purchaseManager,
				product: {
					model: page.productModel,
					name: page.productName,
					sizeName:  page.productSizeName,
					colorName: page.productColorName,
					unit: page.productUnit,
					purchasePriceString: '￥' + ( typeof page.purchasePrice === "number" ? page.purchasePrice  : '***')
				},
				show: {
					size: !!Number(localStorage.getItem("size_show") || 1),
					color: !!Number(localStorage.getItem("color_show") || 1),
					unit: page.productUnit !== null && page.productUnit !== undefined && !!Number(localStorage.getItem("unit_show") || 0),
					originSpecification: Number(localStorage.getItem("origin_specification") || 0),
				},
				BNList: [],
				systemSetting: systemSetting
			}
		},
		components: {

		},
		watch: {

		},
		computed: {
			checkedProductSum(){
				if(this.type === 'transfer'){
					let sum = 0
					this.BNList.forEach(function (v) {
						sum += v.amount
					})
					return Number((sum).toFixed(4))
				}
			},
			profitCount() {
				if(this.type !== 'inventory'){
					return null
				}
				return this.preTotal - this.currentTotal
			},
			profitPrice() {
				if(this.type !== 'inventory'){
					return null
				}
				if(typeof page.purchasePrice === "number"){
					return -(this.profitCount * page.purchasePrice)
				}else{
					return '***'
				}
			},
		},
		methods: {
			fillBNList(list){
				let BNList = []
				if (this.type === 'inventory'){
					let notBatchItem = {
						notBatchItem: true,
						amount: 0
					}
					let allChangeAmount = page.nowAmount - page.preAmount
					list.forEach(function(v) {
						BNList.push(v)
						allChangeAmount = Number((allChangeAmount - v.amount).toFixed(4))
					})
					notBatchItem.amount = allChangeAmount
					BNList.unshift(notBatchItem)
				} else if (this.type === 'transfer') {
					BNList = list
				}
				this.BNList = BNList
			},
		},
		beforeCreate(){
			console.log('beforeCreate')
		},
		created(){
			let titleDom = document.querySelector('.contentPage-title')
			if (this.type === 'transfer') {
				titleDom.append(document.createTextNode('批次调拨'))
				let span = document.createElement('span')
				span.style.fontSize = '14px'
				span.append(document.createTextNode(' 调出仓库：' + page.depotName))
				titleDom.append(span)
			}else{
				titleDom.append(document.createTextNode('批次盘点'))
			}
			this.fillBNList(page.BNList)
			console.log('created')
		},
		beforeMount(){
			console.log('beforeMount')
		},
		mounted(){
			console.log('mounted')
		},
		beforeUpdate(){
			console.log('beforeUpdate')
		},
		updated(){
			console.log('updated')
		},
		beforeDestroy(){
			console.log('beforeDestroy')
		},
		destroyed(){
			console.log('destroyed')
		}
	})
})
