if (typeof(String.prototype.trim) === "undefined") {
	String.prototype.trim = function() {
		return String(this).replace(/^\s+|\s+$/g, '');
	};
}

function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = window.location.search.substr(1).match(reg);
	if (r != null) return decodeURIComponent(r[2]);
	return null;
}
var upFile = {
		fileA: '',
		fileB: '',
		fileC: '',
		fileD: ''
	},
	checkModel = '';
mui.plusReady(function() {
	var arg = plus.webview.currentWebview().arg;
	if (arg) {
		arg = JSON.parse(plus.webview.currentWebview().arg);
		goodsAddVM.model = arg.model || '';
		goodsAddVM.name = arg.model || '';
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("name", goodsAddVM.name)
	}
	goodsAddVM.getAllDepot()
});
window.addEventListener("modelAndName", function(e) {
	goodsAddVM.model = e.detail.model || '';
	goodsAddVM.name = e.detail.model || '';
	sessionStorage.setItem("model", goodsAddVM.model);
	sessionStorage.setItem("name", goodsAddVM.name)
})
window.addEventListener("colorAndSizeUpdate", function(e) {
	if (e.detail.colorNewest && e.detail.colorNewest != undefined) {
		sessionStorage.setItem('selColorList', e.detail.colorNewest);
		$("#sp_color").html('');
	} else {
		if (goodsAddVM.colorList.length < 1) {
			getDefaultColor();
		}
	}
	if (e.detail.sizeNewest && e.detail.sizeNewest != undefined) {
		sessionStorage.setItem('selSizeList', e.detail.sizeNewest);
		$("#sp_size").html('');
	} else {
		if (goodsAddVM.sizeList.length < 1) {
			getDefaultSize();
		}
	}
	console.log(JSON.parse(sessionStorage.getItem("big_list")))
	getGoodsMenu("updateByCS")
});
window.addEventListener("categoryUpdate", function(e) {
	goodsAddVM.category = e.detail.category_id
	sessionStorage.setItem('category_id', e.detail.category_id)
	goodsAddVM.category_name = e.detail.category_name
	sessionStorage.setItem('category_name', e.detail.category_name)
	goodsAddVM.category_parent_name = e.detail.category_parent_name
	sessionStorage.setItem('category_parent_name', e.detail.category_parent_name)
})
window.addEventListener("unitUpdate", function(e) {
	goodsAddVM.mainUnitId = e.detail.mainUnitId
	sessionStorage.setItem('mainUnitId', e.detail.mainUnitId)
	goodsAddVM.mainUnitName = e.detail.mainUnitName
	sessionStorage.setItem('mainUnitName', e.detail.mainUnitName)
	goodsAddVM.unitList = e.detail.unitList
	sessionStorage.setItem('unitList', JSON.stringify(e.detail.unitList))
})
// 初始库存设置更新
window.addEventListener("cunUpdate", function(e) {
	if (e.detail.big_list) {
		// let amountTotal = 0
		mui.each(e.detail.big_list, function(index, item) {
			item.depot_id = item.depot_id || item.id
		});
		sessionStorage.setItem('big_list', JSON.stringify(e.detail.big_list));
		getGoodsMenu()
	}
})
window.addEventListener("otherUpdate", function(e) {
	goodsAddVM.material = e.detail.material;
	goodsAddVM.otherAttrList = e.detail.otherAttrList;
	sessionStorage.setItem('otherAttrList', JSON.stringify(e.detail.otherAttrList));
})
window.addEventListener("codeUpdate", function(e) {
	sessionStorage.setItem('barcodeList', JSON.stringify(e.detail.barcodeList));
	sessionStorage.setItem('selList', JSON.stringify(e.detail.selList));
	goodsAddVM.barcodeNumber = e.detail.barcodeNumber > 0 ? '已设置' : '未设置';
	goodsAddVM.selList = e.detail.selList;
	getGoodsMenu()
})
window.addEventListener("changeCategoryPprice", function(e) {
	var info = e.detail;
	var priceList = info.customerCategory.reduce(function(prev, cur) {
		if (!isNaN(parseInt(cur.price))) {
			prev.push(cur.price)
		}
		return prev
	}, [])
	sessionStorage.setItem('customerCategory', JSON.stringify(info.customerCategory));
	goodsAddVM.customerCategory = info.customerCategory
	$("#classifSet").val(String(priceList.join("/")))
})
window.addEventListener('printBack', function() {
	viewHandle.back()
})
window.addEventListener('stockLimitSave', function(e) {
	goodsAddVM.stockLimit.stockLimitSave = e.detail.stockLimitSave
	goodsAddVM.stockLimit.allStockSetSave = e.detail.allStockSetSave
	goodsAddVM.stockLimit.oldShowStockType = e.detail.oldShowStockType
	goodsAddVM.updateAddStockLimitText()
})
mui('body').on('tap', '#remark', function() {
	document.getElementById("remark").scrollIntoView()
})
function autoGrow (oField) {
	$(oField).autoHeight()
}
var toggleFlag = false;
var goodsAddVM = new Vue({
	el: '#goodsAddVM',
	data: {
		name: '',
		model: '',
		// 备注
		remark: '',
		// 库存预警
		stockLimit: {
			// '未设置','已设置','部分设置'
			statusText: '未设置',
			// 单仓库列表 设置了预警的 提交使用这个合并数据
			stockLimitSave: undefined,
			// 所有仓库 设置预警
			allStockSetSave: undefined,
			// 上次界面 可配置首次打开
			oldShowStockType: 'all',
		},
		allDepot: [], // 所有仓库
		barcodeNumber: Number(sessionStorage.getItem('barcodeNumber')) > 0 ? '已设置' : '未设置',
		systemSetting: JSON.parse(localStorage.systemSetting),
		purchase_price: '',
		sale_price: '',
		sale_price_b: '',
		colorList: [],
		sizeList: [],
		material: '',
		list: [],
		big_list: [],
		changeList: [],
		amountTotal: 0,
		goodsList: [],
		goodsId: sessionStorage.getItem("selListId") || '',
		depot_id: '',
		stockSwt: false,
		selbarCodeList: [],
		default_color: '',
		default_size: '',
		otherAttrList: '',
		category: sessionStorage.getItem('category_id') || 1,
		category_name: sessionStorage.getItem('category_name') || '',
		category_parent_name: sessionStorage.getItem('category_parent_name') || '',
		id: '', //用作图片id,
		mainUnitId: sessionStorage.getItem("mainUnitId") || '',
		mainUnitName: sessionStorage.getItem("mainUnitName") || '',
		unitList: JSON.parse(sessionStorage.getItem("unitList")) || [],
		//全行业参数
		size_show: localStorage.getItem("size_show") || 1,
		color_show: localStorage.getItem("color_show") || 1,
		unit_show: localStorage.getItem("unit_show") || 0,
		origin_specification: localStorage.getItem("origin_specification") || 0,
		//是否扫码录入
		isSweepCodeEntry: false,
		upFileType: 'fileA',
		//权限相关
		positionName: false,
		stockManager: false,
		purchaseManager: false,
		companySetIndustry: true,
		labelPprinter: false,
		faAccount: true,
		is_advanced: 0,
		company_name: '',
		company_id: '',
		user_id: '',
		jifenshow: false,
		bindDepot: -1,
		// 用户开启库存预警功能？
		isStockLimit: false,
		//--------------------
		//客户分类价
		customerCategory: [],
		//--------------------
		// 保质期
		expire_date:'',
		expire_date_toggleFlag:false,
		expire_date_unit:0,
		expire_date_power:false
	},
	mixins:[globalSystemMixin],
	directives:{
		intInput:{
			//v-int-input 指令不能大写 input type要是text number 会有问题 会把"-"、"+"识别为空 难以处理
			bind: function(el, binding, vnode) {
				let input = vnode.elm;
				if (!input) return;
				input.addEventListener('input', function (e) {
					let oldValue = input.value;
					let newValue = input.value;
					newValue = newValue.replace(/[^0-9]/g, '');
					// 判断是否需要更新，避免进入死循环
					if (newValue !== oldValue) {
						input.value = newValue;
						input.dispatchEvent(new Event('input')); // 通知v-model更新
					}
				})
			}
		},
	},
	watch: {
		sale_price: function() {
			if (this.sale_price != '' || this.sale_price > 0) {
				this.sale_price_b = this.sale_price;
			} else {
				this.sale_price_b = 0
			}
		},
		expire_date(){
			this.clearProduction()
		},
		expire_date_unit(){
			this.clearProduction()
		}
	},
	computed:{
		clearProduction(){
			const big_list = JSON.parse(sessionStorage.big_list)
			let del = false
			const delList = ['production_batch_id', 'production_batch_number', 'production_date_str', 'production_date_timestamp']
			debugger
			mui.each(big_list, function(index, item) {
				delList.forEach(function (v) {
					if(item.hasOwnProperty(v)){
						delete item[v]
						del = true
					}
				})
			});
			if (del) {
				mui.toast('保质期变化，初始批次已清除！')
				sessionStorage.setItem('big_list', JSON.stringify(big_list));
				getGoodsMenu()
			}
		},
		expire_date_unit_show:function (){
			if(this.expire_date_unit==0){
				return '天'
			}else if(this.expire_date_unit==1){
				return '周'
			}else if(this.expire_date_unit==2){
				return '月'
			}else{
				return '年'
			}
		}
	},
	methods: {
		changeExpireDateToggleFlag:function (){
			this.expire_date_toggleFlag=!this.expire_date_toggleFlag
		},
		changeExpireDateUnit(type){
			this.expire_date_unit=type
			setTimeout(function (){
				goodsAddVM.expire_date_toggleFlag=false
			},200)
		},
		getPurview: function() { //获取权限
			var _this = this;
			mui.ajax(severUrl + "sso/user/qryOp.json", {
				data: {
					id: ''
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 30000,
				async: false,
				success: function(res) {
					if (res.success) {
						// var position_name = res.data.position_name;
						_this.company_name = res.data.company_name;
						_this.company_id = res.data.company_id;
						_this.bindDepot = res.data.manage_depot_id;
						_this.user_id = res.data.id;
						var code = res.data.position,
							permission = code.permission;
						if (permission.indexOf('A11_1_O') >= 0 || permission.indexOf(
								'A11_1_E') >= 0) {
							_this.positionName = true
						} else {
							_this.positionName = false
						}
						permission.indexOf('A4_1_E') >= 0 ? _this.stockManager = true : _this
							.stockManager = false;
						permission.indexOf('FA_ACC') >= 0 ? _this.faAccount = true : _this
							.faAccount = false;
						permission.indexOf('LOOK_PURCHASE') >= 0 ? _this.purchaseManager =
							true : _this.purchaseManager = false;
						permission.indexOf('ONLY_PRINT') >= 0 ? _this.labelPprinter = true :
							_this.labelPprinter = false;
						'RFRk,eYVo,y0oa,mVbc,pqrB,pDAY,CCP2,Oo4T,LfTY'.indexOf(_this
								.company_id) >= 0 ? _this.jifenshow = true : _this.jifenshow =
							false
						_this.companySetIndustry = res.data.company_set_industry;
					}

				}
			});
		},
		createGoods: function() {
			if (mui.os.ios == true) {
				if (this.model != $('#sphh').val()) {
					this.model = $('#sphh').val();
				}
				if (this.name != $('#spmc').val()) {
					this.name = $('#spmc').val();
				}
			}
			if (this.model.trim() == '') {
				mui.toast('请输入商品货号');
				return;
			}
			if (this.name.trim() == '') {
				mui.toast('请输入商品名称');
				return;
			}
			if(this.remark.trim().length > 100){
				mui.toast('商品备注字数超过最大字数100'); return
			}
			if(this.model.trim().length > 30){
				mui.toast('商品货号字数超过最大字数30'); return
			}
			if(this.name.trim().length > 50){
				mui.toast('商品名称字数超过最大字数50'); return
			}
			if (this.purchase_price == '') {
				this.purchase_price = '0';
			}
			if (this.sale_price == '') {
				this.sale_price = '0';
			}
			if (goodsAddVM.unitList) {
				for (var i = 0; i < goodsAddVM.unitList.length; i++) {
					if (goodsAddVM.unitList[i].ratio == undefined || goodsAddVM.unitList[i].ratio == '') {
						mui.toast('请返回设置单位换算数据');
						return false;
					}
				}

			}
			setDefaultValues();

			var selbarCodeList = JSON.parse(sessionStorage.getItem('selList'));

			var big_list = JSON.parse(sessionStorage.getItem('big_list'));
			if (big_list == null) {
				big_list = get_ku_cun();
			} else {
				big_list = get_all_ku_cun(big_list);
			}
			//保存合并条码
			mui.each(selbarCodeList, function(i, v) {
				mui.each(big_list, function(k, n) {
					if (v.color_id == n.color_id && v.size_id == n.size_id) {
						n.barcode = v.barcode;
					}
				})
			});
			list = big_list;
			// 合并库存预警数据
			if (goodsAddVM.isStockLimit === true && goodsAddVM.stockLimit.stockLimitSave) {
				goodsAddVM.stockLimit.stockLimitSave.map(depot => {
					const depot_id = depot.id
					depot.color.map(color => {
						const color_id = color.color_id
						color.size.map(size =>{
							const size_id = size.size_id
							const singleProduct = list.find(singleProduct => singleProduct.size_id === size_id && singleProduct.color_id === color_id && singleProduct.depot_id === depot_id)
							if(singleProduct){
								singleProduct.stock_warn_max = size.stock_warn_max || ''
								singleProduct.stock_warn_min = size.stock_warn_min || ''
							}
						})
					})
				})
			}
			console.log(list) // debug
			mui.each(list, function(index, item) {
				delete item.color_name;
				delete item.size_name;
			});
			var otherAttrList = JSON.parse(sessionStorage.getItem("otherAttrList"));
			var otherAttrListlength;
			if (otherAttrList) {
				otherAttrListlength = otherAttrList.length;
			} else {
				otherAttrListlength = 0;
				otherAttrList = [];
			}
			var unitRuleListLength;
			var unitList = [];
			if (goodsAddVM.unitList) {
				unitRuleListLength = goodsAddVM.unitList.length;
				for (var i = 0; i < goodsAddVM.unitList.length; i++) {
					if (goodsAddVM.unitList[i].ratio != undefined && goodsAddVM.unitList[i].ratio != '') {
						var unit = {
							assist_unit: goodsAddVM.unitList[i].id,
							ratio: goodsAddVM.unitList[i].ratio
						};
						unitList.push(unit)
					}
				}

			} else {
				unitRuleListLength = 0;
				unitList = [];
			}
			console.log(unitList);
			console.log(unitRuleListLength);
			var customerCategoryPrices = goodsAddVM.customerCategory.map(function(customer) {
				return {
					customer_category_id: customer.id,
					price: customer.price
				}
			});
			//处理保质期的换算 时间戳 毫秒
			let expire_date_ms=getTimeUnitDateTOStamp(goodsAddVM.expire_date,goodsAddVM.expire_date_unit_show)
			mui.ajax(severUrl + "scm/product/save.json", {
				data: {
					id: goodsAddVM.goodsId,
					category: goodsAddVM.category,
					name: goodsAddVM.name.trim(),
					billsn: 1,
					stock_warn: 0,
					model: goodsAddVM.model.trim(),
					material: goodsAddVM.material,
					status: 1,
					unit: 1,
					main_unit: goodsAddVM.mainUnitId,
					unitRuleList: unitList,
					unitRuleListLength: unitRuleListLength,
					sale_price: goodsAddVM.sale_price,
					sale_price_b: goodsAddVM.sale_price_b,
					purchase_price: goodsAddVM.purchase_price,
					depot_id: goodsAddVM.depot_id,
					listlength: list.length,
					amount: goodsAddVM.amountTotal || 0, //该数量为list中数量总和
					list: list,
					otherAttrList: otherAttrList,
					otherAttrListlength: otherAttrListlength,
					customerCategoryPrices:JSON.stringify(customerCategoryPrices),
					remark: goodsAddVM.remark.trim(),
					expire_date_ms:expire_date_ms||"",//保质期
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json', //服务器返回json格式数据
				type: 'post', //HTTP请求类型
				timeout: 60000, //超时时间设置为10秒；
				beforeSend: function() {
					// mask.show();//显示遮罩层
					mui('#dh')[0].style.display = "block";
				},
				complete: function() {
					//mask.close();//关闭遮罩层
					mui('#dh')[0].style.display = "none";
				},
				success: function(res) {
					if (res.success) {
						if (null != res && res != "") {
							goodsAddVM.id = res.data.productId;
							if (upFile.fileA != '') {
								viewHandle.fileUpload(upFile.fileA, goodsAddVM.id, '1',
									new Date().getTime() + 6000, 'add')
							}
							if (upFile.fileB != '') {
								viewHandle.fileUpload(upFile.fileB, goodsAddVM.id, '0',
									new Date().getTime() + 4000, 'add')
							}
							if (upFile.fileC != '') {
								viewHandle.fileUpload(upFile.fileC, goodsAddVM.id, '0',
									new Date().getTime() + 2000, 'add')
							}
							if (upFile.fileD != '') {
								viewHandle.fileUpload(upFile.fileD, goodsAddVM.id, '0',
									new Date().getTime() + 0, 'add')
							}
						}
						if (res.success) {
							if (JSON.parse(sessionStorage.getItem("barcodeList") != null)) {
								var btnArray = ['仅保存', '保存并打印'];
								mui.confirm('', ' 是否打印条码?', btnArray, function(e) {
									if (e.index == 1) {
										var listSend = {};
										listSend.id = goodsAddVM.id;
										listSend.name = goodsAddVM.name;
										listSend.model = goodsAddVM.model;
										listSend.enterCode = 2;
										listSend.sale_price = goodsAddVM.sale_price;
										listSend.sale_price_b = goodsAddVM.sale_price_b;
										listSend.otherAttrList = goodsAddVM
											.otherAttrList
										listSend.selList = goodsAddVM.selList;
										listSend.material = goodsAddVM.material;
										sessionStorage.clear();
										viewHandle.openWindow('changeCode.html',
											'changeCode.html', JSON.stringify(
												listSend))
										// sessionStorage.setItem("enterCode",'2');
										// location = 'changeCode.html'
									} else {
										sessionStorage.removeItem("selColorList");
										sessionStorage.removeItem("selSizeList");
										sessionStorage.removeItem("selList");
										sessionStorage.removeItem("list");
										sessionStorage.removeItem("barcodeList");
										sessionStorage.removeItem("name");
										sessionStorage.removeItem("model");
										sessionStorage.removeItem("material");
										sessionStorage.removeItem("category_id");
										sessionStorage.removeItem("category_name");
										sessionStorage.removeItem(
											"category_parent_name");
										sessionStorage.removeItem("purchase_price");
										sessionStorage.removeItem("sale_price");
										sessionStorage.removeItem("mainUnitId");
										sessionStorage.removeItem("mainUnitName");
										sessionStorage.removeItem("unitList");
										sessionStorage.removeItem("selListId");
										sessionStorage.removeItem("selbarCodeList");
										sessionStorage.removeItem("big_list");
										sessionStorage.removeItem("selDepotId");
										sessionStorage.removeItem("otherAttrList");
										sessionStorage.removeItem("barcodeNumber");
										setTimeout(function() {
											mui.toast(res.msg);
										}, 250);
										setTimeout(function() {
											getDefaultColor();
											getDefaultSize();
											creatBackRefresh()
											viewHandle.close();
											viewHandle.back('close')
										}, 1950)
									}
								}, 'div');
							} else {
								sessionStorage.removeItem("selColorList");
								sessionStorage.removeItem("selSizeList");
								sessionStorage.removeItem("selList");
								sessionStorage.removeItem("list");
								sessionStorage.removeItem("barcodeList");
								sessionStorage.removeItem("name");
								sessionStorage.removeItem("model");
								sessionStorage.removeItem("material");
								sessionStorage.removeItem("category_id");
								sessionStorage.removeItem("category_name");
								sessionStorage.removeItem("category_parent_name");
								sessionStorage.removeItem("purchase_price");
								sessionStorage.removeItem("sale_price");
								sessionStorage.removeItem("mainUnitId");
								sessionStorage.removeItem("mainUnitName");
								sessionStorage.removeItem("unitList");
								sessionStorage.removeItem("selListId");
								sessionStorage.removeItem("selbarCodeList");
								sessionStorage.removeItem("big_list");
								sessionStorage.removeItem("selDepotId");
								sessionStorage.removeItem("otherAttrList");
								sessionStorage.removeItem("barcodeNumber");
								setTimeout(function() {
									mui.toast(res.msg);
								}, 300);
								setTimeout(function() {
									getDefaultColor();
									getDefaultSize();
									creatBackRefresh()
									viewHandle.close();
									viewHandle.back('close')
								}, 1900)
							}
						}
					} else {
						$comm.showLimitConfirm(res, {
							payOrderNameStrategy: 'product',
							rootPath: './'
						})
					}
				},
				error: function() {
					mui.toast('保存失败！');
				},
			});

		},
		sweepCode: function() {
			var sendUrl = 'zhijianjxcapp://barcodescan/param?color_id=-1&size_id=-1';
			var cookie = 'ecp_cookie=' + localStorage.getItem("HF");
			if (mui.os.ios == true) {
				sweepCode_i(cookie, sendUrl, 777)
			} else if (mui.os.android == true) {
				sweepCode(cookie, sendUrl, 777)
			}
		},
		purchaseInfo: function() {
			mui.alert("采购价根据每次进货输入的价格自动调整", '', '', '', 'div')
		},
		modelRule(){
			var _this = this;
			if (_this.model == '') {
				return false
			}
			clearTimeout(checkModel);
			checkModel = setTimeout(function() {
				mui.ajax(severUrl + "scm/product/modelIfRepeat.json", { //货号唯一性查询
					data: {
						"model": _this.model
					},
					xhrFields: {
						withCredentials: true
					},
					dataType: 'json', //服务器返回json格式数据
					type: 'post', //HTTP请求类型
					timeout: 10000, //超时时间设置为10秒；
					success: function(res) {
						if (res.success) {
							if (res.data.repeat) {
								mui.confirm(res.msg, '提示', ["确定"], function(e) {
								}, 'div');
							}
						}
					}
				});
			}, 180)
		},
		// 点击库存预警
		clickAddStockLimit() {
			const _this = this
			if(_this.allDepot.length > 0){
				go()
			}else{
				_this.getAllDepot(go, '获取仓库失败，无法进入库存预警，请重试')
			}
			function go(){
				const colorList = JSON.parse(JSON.stringify(_this.colorList.length < 1 ? [_this.default_color] : _this.colorList))
				const sizeList = JSON.parse(JSON.stringify(_this.sizeList.length < 1 ? [_this.default_size] : _this.sizeList))
				const specification = formDataStockLimitData(colorList, sizeList)
				const source = {allDepot: _this.allDepot, specification, model: _this.model, originId: 'itemAdd.html'}
				JumpPage.jump('./stockLimitSet.html','stockLimitSet', function () {
					viewHandle.viewFire('stockLimitSet', 'stockLimitInit', Object.assign(_this.stockLimit, source))
				})
			}
		},
		// 获取所有仓库
		getAllDepot(cbFn, errText){
			const _this = this
			mui.ajax(severUrl + "scm/depot/list.json", {
				data: {},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 10000,
				success: function(res) {
					if (res) {
						if (res.success && Array.isArray(res.data)) {
							_this.allDepot = res.data; /*depotList仓库列表*/
							cbFn&&cbFn()
						} else if (res.status == 10101 || res.status == 10102) { // 登录失效
							logOut(res.msg)
						} else {
							mui.toast('获取仓库异常' + res.msg)
						}
					}
				},
				error(){
					console.log('请求异常')
					errText && mui.toast(errText)
				}
			});
		},
		// 更新库存预警 状态
		updateAddStockLimitText(){
			if(this.isStockLimit === false || !this.stockLimit.stockLimitSave) return;
			let colorList = JSON.parse(JSON.stringify(this.colorList.length < 1 ? [this.default_color] : this.colorList))
			let sizeList = JSON.parse(JSON.stringify(this.sizeList.length < 1 ? [this.default_size] : this.sizeList))
			const specification = formDataStockLimitData(colorList, sizeList)
			colorList = specification.colorList
			sizeList = specification.sizeList
			const allDepot = this.allDepot
			const productList = []
			const queryList = []

			const _this = this
			if(allDepot.length > 0){
				update()
			}else{
				_this.getAllDepot(update, '更新库存预警状态失败')
			}
			function update(){
				// 生成单品列表
				allDepot.map(item => {
					const depot_id = item.id
					colorList.map(item => {
						const color_id = item.color_id
						sizeList.map(item => {
							const size_id = item.size_id
							productList.push({depot_id, color_id, size_id})
						})
					})
				})
				let text = ''
				// 在设置的中查询 查到就将结果添加到queryList
				_this.stockLimit.stockLimitSave.map(depot => {
					const depot_id = depot.id
					depot.color.map(color => {
						const color_id = color.color_id
						color.size.map(size =>{
							const size_id = size.size_id
							const singleProduct = productList.find(singleProduct => singleProduct.size_id === size_id && singleProduct.color_id === color_id && singleProduct.depot_id === depot_id && (size.stock_warn_min || size.stock_warn_max))
							if(singleProduct){
								queryList.push(singleProduct)
							}
						})
					})
				})
				if(queryList.length === 0){
					text = '未设置'
				} else if(productList.length > queryList.length){
					text = '部分设置'
				} else {
					text = '已设置'
				}
				_this.stockLimit.statusText = text
			}
		}

	},
	mounted: function() {
		// 初始化 isStockLimit 库存预警设置
		if(this.systemSetting){
			// 1 启用 0 停用
			this.isStockLimit = this.systemSetting.stock_warn_setting === 1
		}
		var _this = this;
		setTimeout(function() {
			var winHeight = $(window).height(); //获取当前页面高度
			$(window).resize(function() {
				var u = navigator.userAgent,
					app = navigator.appVersion;
				var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -
					1; //android终端或者uc浏览器
				var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
				if (isAndroid) {
					var thisHeight = $(this).height();
					if (winHeight - thisHeight > 140) {} else {
						$("input").blur();
					}
				} else if (isiOS) {

				}
			});
			//用混入 利于后期的扩展
			goodsAddVM.expire_date_power=globalSystemMixin.computed.productionBatchPower(goodsAddVM.systemSetting.production_batch_setting)
		}, 350);
		mui.plusReady(function() {
			_this.getPurview()
			getDefaultColor();
			getDefaultSize();
		})
	},
	created: function() {
		// this.getAllDepot()
	}
});
setListener();
mui('.mui-scroll-wrapper').scroll({
	deceleration: 0.0005 //flick 减速系数，系数越大，滚动速度越慢，滚动距离越小，默认值0.0006
});

function getGoodsMenu(val) {
	var selColorList = JSON.parse(sessionStorage.getItem("selColorList"));
	var selSizeList = JSON.parse(sessionStorage.getItem("selSizeList"));
	var depotList = JSON.parse(localStorage.getItem("depotList"));
	goodsAddVM.otherAttrList = JSON.parse(sessionStorage.getItem("otherAttrList")) || [];
	goodsAddVM.selbarCodeList = (JSON.parse(sessionStorage.getItem("selList"))) || (JSON.parse(sessionStorage.getItem(
		"selbarCodeList"))); /*selbarCodeList*/
	goodsAddVM.name = sessionStorage.getItem("name") || '';
	goodsAddVM.model = sessionStorage.getItem("model") || '';
	goodsAddVM.material = sessionStorage.getItem("material") || '';
	goodsAddVM.category = sessionStorage.getItem('category_id') || 1;
	goodsAddVM.category_name = sessionStorage.getItem('category_name') || '';
	goodsAddVM.category_parent_name = sessionStorage.getItem('category_parent_name') || '';
	goodsAddVM.purchase_price = sessionStorage.getItem("purchase_price") || '';
	goodsAddVM.sale_price = sessionStorage.getItem("sale_price") || '';
	goodsAddVM.sale_price_b = sessionStorage.getItem("sale_price_b") || '';
	goodsAddVM.mainUnitId = sessionStorage.getItem("mainUnitId") || '';
	goodsAddVM.mainUnitName = sessionStorage.getItem("mainUnitName") || '';
	goodsAddVM.unitList = JSON.parse(sessionStorage.getItem("unitList")) || [];
	goodsAddVM.depot_id = sessionStorage.getItem("selDepotId") || depotList[0].id;
	if (selColorList && selSizeList) {
		goodsAddVM.colorList = selColorList;
		goodsAddVM.sizeList = selSizeList;
		var list = [];
		mui.each(selColorList, function(index1, color) {
			color.visible = false;
			mui.each(selSizeList, function(index2, size) {
				if (!color.disabled || !size.disabled) {
					color.visible = true;
					for (var i = 0; i < goodsAddVM.selbarCodeList.length; i++) {
						if (goodsAddVM.selbarCodeList[i].color_id == color.color_id && goodsAddVM
							.selbarCodeList[i].size_id == size.size_id) {
							var barcode = goodsAddVM.selbarCodeList[i].barcode;
						}
					}
					list.push({
						color_name: color.color_name,
						size_name: size.size_name,
						color_id: color.color_id,
						size_id: size.size_id,
						name: goodsAddVM.name,
						amount: 0,
						barcode: barcode || '',
					});
					goodsAddVM.stockSwt = true;
				}
			})
		});
		sessionStorage.setItem("selColorList", JSON.stringify(selColorList));
		var selList = JSON.parse(sessionStorage.getItem("selList"));
		var big_list = JSON.parse(sessionStorage.getItem("big_list"));
		if (val == "updateByCS" && big_list) {
			var newBig_list = get_ku_cun();
			mui.each(newBig_list, function(i, v) {
				mui.each(big_list, function(k, n) {
					if (n.color_id == v.color_id && n.size_id == v.size_id && n.depot_id == v
						.depot_id) {
						v.amount = n.amount;
						v.product_sn_list = n.product_sn_list;
						return false
					}
				})
			})
			big_list = newBig_list;
			sessionStorage.setItem("big_list", JSON.stringify(big_list))
		}
		if (big_list) {
			var amountTotal = 0;
			mui.each(big_list, function(index, item) {
				amountTotal += item.amount;
				mui.each(list, function(i, v) {
					if (item.size_id == v.size_id && item.color_id == v.color_id) {
						v.amount += Number(item.amount);
						return;
					}
				})
			});
			goodsAddVM.amountTotal = numToCur(amountTotal,goodsAddVM.systemSetting.amount_decimals_setting);

		}
		goodsAddVM.list = list;
		mui.each(goodsAddVM.list, function(i, v) {
			if (v.barcode == '') {
				return goodsAddVM.barcodeNumber = '未设置';
			}
		})
		sessionStorage.setItem("selList", JSON.stringify(list));
	} else if (selColorList) {
		goodsAddVM.colorList = selColorList;
	} else if (selSizeList) {
		goodsAddVM.sizeList = selSizeList;
	}
}

function setListener() {
	setTimeout(function() {
		getGoodsMenu();
	}, 500);
	mui(".mui-content").on('tap', '.commodityColor', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var listSend = {
			selColorList: JSON.stringify(goodsAddVM.colorList)
		};
		viewHandle.viewFire('commodityColor.html', 'editColor', listSend);
		viewHandle.openWindow('commodityColor.html', 'commodityColor.html');
	});
	mui(".mui-content").on('tap', '.commoditySize', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var obj = {
			selSizeList: JSON.stringify(goodsAddVM.sizeList)
		};
		viewHandle.viewFire('commoditySize.html', 'editSize', obj);
		viewHandle.openWindow('commoditySize.html', 'commoditySize.html');
	});
	mui(".mui-content").on('tap', '.classificationPage', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var listSend = {
			category_id: goodsAddVM.category || '',
			category_name: goodsAddVM.category_name || '',
			category_parent_name: goodsAddVM.category_parent_name || ''
		};
		viewHandle.viewFire('classificationPage.html', 'classificationUpdate', listSend);
		viewHandle.openWindow('view/classificationPage.html', 'classificationPage.html', JSON.stringify(
			listSend))
	});
	//客户分类价
	mui(".mui-content").on('tap', '.categoryPage', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var listSend = {};
		listSend.customerCategory = goodsAddVM.customerCategory
		viewHandle.viewFire('categoryPriceList.html', 'categoryPriceList', listSend);
		viewHandle.openWindow('view/categoryPriceList.html', 'categoryPriceList.html', JSON.stringify(
			listSend))
	});
	mui(".mui-content").on('tap', '.companyPage', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var listSend = {};
		listSend.mainUnitId = goodsAddVM.mainUnitId;
		listSend.mainUnitName = goodsAddVM.mainUnitName;
		listSend.unitList = goodsAddVM.unitList;
		listSend.id = '';
		viewHandle.viewFire('companyPage.html', 'unitUpdate', listSend);
		viewHandle.openWindow('view/companyPage.html', 'companyPage.html', JSON.stringify(listSend))
	});
	mui(".mui-content").on('tap', '.commodityOther', function() {
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		var listSend = {};
		listSend.material = goodsAddVM.material;
		listSend.otherAttrList = goodsAddVM.otherAttrList;
		viewHandle.viewFire('commodityOther.html', 'otherUpdate', listSend);
		viewHandle.openWindow('commodityOther.html', 'commodityOther.html', JSON.stringify(listSend))
	})
	// 初始库存
	mui(".mui-content").on('tap', '.initialInventory', function() {
		goodsAddVM.allDepot || goodsAddVM.getAllDepot(true) // 确保获取到仓库
		setDefaultValues();
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selDepotId", goodsAddVM.depot_id);
		var listSend = {};
		listSend.expireDateMs = getTimeUnitDateTOStamp(goodsAddVM.expire_date,goodsAddVM.expire_date_unit_show)
		listSend.model = goodsAddVM.model;
		listSend.name = goodsAddVM.name;
		listSend.allDepot = goodsAddVM.allDepot;
		listSend.selColorList = JSON.parse(sessionStorage.getItem("selColorList"));
		listSend.selSizeList = JSON.parse(sessionStorage.getItem("selSizeList"));
		listSend.selList = JSON.parse(sessionStorage.getItem("selList"));
		listSend.big_list = JSON.parse(sessionStorage.getItem("big_list"))
		// viewHandle.viewFire('initialInventory.html', 'kucun', listSend) // 没页面 事件不会触发
		viewHandle.openWindow('initialInventory.html', 'initialInventory.html', JSON.stringify(listSend));
	});


	mui(".mui-content").on('tap', '.barcodeSet', function() {

		if (goodsAddVM.model == '') {
			mui.toast('请输入商品货号');
			return;
		}
		if (goodsAddVM.name == '') {
			mui.toast('请输入商品名称');
			return;
		}
		if (goodsAddVM.purchase_price == '') {
			goodsAddVM.purchase_price = '0';
		}
		if (goodsAddVM.sale_price == '') {
			goodsAddVM.sale_price = '0';
		}
		setDefaultValues();
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		sessionStorage.setItem("selList", JSON.stringify(goodsAddVM.list));
		sessionStorage.setItem("name", goodsAddVM.name);
		sessionStorage.setItem("model", goodsAddVM.model);
		sessionStorage.setItem("material", goodsAddVM.material);
		sessionStorage.setItem("purchase_price", goodsAddVM.purchase_price);
		sessionStorage.setItem("sale_price", goodsAddVM.sale_price);
		sessionStorage.setItem("sale_price_b", goodsAddVM.sale_price_b);
		sessionStorage.setItem("selDepotId", goodsAddVM.depot_id);
		//增加进入码区别入口
		sessionStorage.setItem("enterCode", '1');
		var listSend = {}
		listSend.model = goodsAddVM.model;
		listSend.name = goodsAddVM.name;
		listSend.enterCode = '1';
		listSend.selList = JSON.parse(sessionStorage.getItem("selList"));
		viewHandle.openWindow('changeCode.html', 'changeCode.html', JSON.stringify(listSend))
	})
}
mui("body").on('tap', '#muiBack', function() {
	var parent = plus.webview.currentWebview().parent();
	console.log(plus.webview.currentWebview())
	getDefaultColor();
	getDefaultSize();
	viewHandle.back('close')
})

function getDefaultColor() {
	mui.ajax(severUrl + "scm/productcolor/dataGrid.json", {
		data: {},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(res) {
			var list = res.data.list;
			goodsAddVM.default_color = list[0];
			var selColorList = JSON.parse(sessionStorage.getItem("selColorList"));
			if (selColorList == null || selColorList == "") {
				$("#sp_color").html(goodsAddVM.default_color.color_name);
			}
		}
	});
}

function getDefaultSize() {
	mui.ajax(severUrl + "scm/productsize/dataGrid.json", {
		data: {},
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded'
		},
		xhrFields: {
			withCredentials: true
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(res) {
			var list = res.data.list;
			var is_default = false;
			mui.each(list, function(i, v) {
				if (v.is_default == 1) {
					goodsAddVM.default_size = v;
					var selSizeList = JSON.parse(sessionStorage.getItem("selSizeList"));
					if (selSizeList == null || selSizeList == "") {
						$("#sp_size").html(goodsAddVM.default_size.size_name);
					}
					is_default = true;
				}
			});
			if (!is_default) {
				goodsAddVM.default_size = list[list.length - 1];
				var selSizeList = JSON.parse(sessionStorage.getItem("selSizeList"));
				if (selSizeList == null || selSizeList == "") {
					$("#sp_size").html(goodsAddVM.default_size.size_name);
				}
			}
		}
	});
}

function setDefaultValues() {
	//设置默认颜色
	// 前面留的坑 注意这里的color 和size 的 id属性 有时候是 color_id /size_id
	if (goodsAddVM.colorList.length == 0) {
		goodsAddVM.colorList.push({
			color_name: goodsAddVM.default_color.color_name,
			color_id: goodsAddVM.default_color.id,
			visible: true,
			disabled: false
		});
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		if (goodsAddVM.sizeList.length == 0) {
			goodsAddVM.sizeList.push({
				size_name: goodsAddVM.default_size.size_name,
				size_id: goodsAddVM.default_size.id,
				visible: false,
				disabled: false
			});
			sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
			for (var i = 0; i < goodsAddVM.colorList.length; i++) {
				for (var j = 0; j < goodsAddVM.sizeList.length; j++) {
					goodsAddVM.list.push({
						color_name: goodsAddVM.colorList[i].color_name,
						size_name: goodsAddVM.sizeList[j].size_name,
						color_id: goodsAddVM.colorList[i].color_id,
						size_id: goodsAddVM.sizeList[j].size_id,
						amount: 0,
						barcode: ""
					});
				}
			}
			sessionStorage.setItem("selList", JSON.stringify(goodsAddVM.list));
		} else {
			for (var i = 0; i < goodsAddVM.colorList.length; i++) {
				for (var j = 0; j < goodsAddVM.sizeList.length; j++) {
					goodsAddVM.list.push({
						color_name: goodsAddVM.colorList[i].color_name,
						size_name: goodsAddVM.sizeList[j].size_name,
						color_id: goodsAddVM.colorList[i].color_id,
						size_id: goodsAddVM.sizeList[j].size_id,
						amount: 0,
						barcode: ""
					});
				}
			}
			sessionStorage.setItem("selList", JSON.stringify(goodsAddVM.list));
		}
	}
	//设置默认尺寸
	if (goodsAddVM.sizeList.length == 0) {
		for (var i = 0; i < goodsAddVM.colorList.length; i++) {
			goodsAddVM.colorList[i].visible = true;
		}
		sessionStorage.setItem("selColorList", JSON.stringify(goodsAddVM.colorList));
		goodsAddVM.sizeList.push({
			size_name: goodsAddVM.default_size.size_name,
			size_id: goodsAddVM.default_size.id,
			visible: false,
			disabled: false
		});
		sessionStorage.setItem("selSizeList", JSON.stringify(goodsAddVM.sizeList));
		for (var i = 0; i < goodsAddVM.colorList.length; i++) {
			for (var j = 0; j < goodsAddVM.sizeList.length; j++) {
				goodsAddVM.list.push({
					color_name: goodsAddVM.colorList[i].color_name,
					size_name: goodsAddVM.sizeList[j].size_name,
					color_id: goodsAddVM.colorList[i].color_id,
					size_id: goodsAddVM.sizeList[j].size_id,
					amount: 0,
					barcode: ""
				});
			}
		}
		sessionStorage.setItem("selList", JSON.stringify(goodsAddVM.list));
	}
	$("#sp_color").html("");
	$("#sp_size").html("");
	console.log(goodsAddVM.list)
}

function get_ku_cun() {
	var depotList = JSON.parse(localStorage.getItem("depotList"));
	var big_list = [];
	if (goodsAddVM.big_list.length == 0) {
		for (var k = 0; k < depotList.length; k++) {
			for (var i = 0; i < goodsAddVM.colorList.length; i++) { // 封装颜色和尺码
				for (var j = 0; j < goodsAddVM.sizeList.length; j++) {
					// if (goodsAddVM.colorList[i].checked && goodsAddVM.sizeList[j].checked) {
					big_list.push({
						color_name: goodsAddVM.colorList[i].color_name,
						size_name: goodsAddVM.sizeList[j].size_name,
						color_id: goodsAddVM.colorList[i].color_id,
						size_id: goodsAddVM.sizeList[j].size_id,
						name: '',
						amount: 0,
						barcode: "",
						depot_id: depotList[k].id
					});
					// }
				}
			}
		}
	}
	return big_list;
}


function get_all_ku_cun(list) {
	let expire_date_ms = getTimeUnitDateTOStamp(goodsAddVM.expire_date,goodsAddVM.expire_date_unit_show)
	var depotList = JSON.parse(localStorage.getItem("depotList"));
	var big_list = [];
	if (goodsAddVM.big_list.length == 0) {
		for (var k = 0; k < depotList.length; k++) {
			for (var i = 0; i < goodsAddVM.colorList.length; i++) { // 封装颜色和尺码
				for (var j = 0; j < goodsAddVM.sizeList.length; j++) {
					// if (goodsAddVM.colorList[i].checked && goodsAddVM.sizeList[j].checked) {
					big_list.push({
						color_name: goodsAddVM.colorList[i].color_name,
						size_name: goodsAddVM.sizeList[j].size_name,
						color_id: goodsAddVM.colorList[i].color_id,
						size_id: goodsAddVM.sizeList[j].size_id,
						product_sn_list: [],
						name: '',
						amount: 0,
						barcode: "",
						depot_id: depotList[k].id
					});
					// }
				}
			}
		}
	}
	for (var m = 0; m < big_list.length; m++) {
		for (var n = 0; n < list.length; n++) {
			if (big_list[m].color_id == list[n].color_id && big_list[m].size_id == list[n].size_id && big_list[m]
				.depot_id == list[n].depot_id) {
				let amount = Number(list[n].amount)
				big_list[m].amount = amount;
				big_list[m].product_sn_list = list[n].product_sn_list;
				// 设置批次
				if(amount && (list[n].production_date_timestamp || list[n].production_batch_number || list[n].production_date_str)){
					big_list[m].production_batch_id =  ''
					big_list[m].production_batch_number =  list[n].production_batch_number
					big_list[m].production_date_str =  list[n].production_date_str
					big_list[m].expire_date_ms =  expire_date_ms
					big_list[m].production_amount =  amount
				}
				break;
			}
		}
	}
	return big_list;
}
mui("#goodsAddVM").on('tap', '#details', function() {
	if (toggleFlag) {
		mui('.mui-icon-arrowup')[0].style.display = "block";
		mui('.details')[0].style.display = "block";
		mui('.mui-icon-arrowdown')[0].style.display = "none";

		toggleFlag = false;
	} else {
		mui('.mui-icon-arrowup')[0].style.display = "none";
		mui('.details')[0].style.display = "none";
		mui('.mui-icon-arrowdown')[0].style.display = "block";

		toggleFlag = true;
	}
});
// 生成名称
function copyModel() {
	if (goodsAddVM.model != '' && goodsAddVM.model != undefined) {
		goodsAddVM.name = goodsAddVM.model;
		console.log(goodsAddVM.model)
	} else {
		mui.toast("请先输入货号")
	}
}
// 生成货号
function creatModel() {
	if (goodsAddVM.name != "") {
		mui.plusReady(function() {
			mui.ajax({
				type: "POST",
				url: severUrl + "scm/product/createModelByName.json",
				contentType: 'application/x-www-form-urlencoded;charset=utf-8',
				data: {
					name: goodsAddVM.name
				},
				success: function(res) {
					goodsAddVM.model = res.data;
				},
				error: function(e) {
					mui.alert("", "生成货号失败")
				}
			});
		})
	} else {
		mui.toast("请先输入名称")
	}
}

mui('#goodsAddVM').on('tap', '.heads', function() {
	mui('#picture').popover('toggle');
	goodsAddVM.upFileType = 'fileA'
});
mui('#goodsAddVM').on('tap', '.heads2', function() {
	mui('#picture').popover('toggle');
	goodsAddVM.upFileType = 'fileB'
});
mui('#goodsAddVM').on('tap', '.heads3', function() {
	mui('#picture').popover('toggle');
	goodsAddVM.upFileType = 'fileC'
});
mui('#goodsAddVM').on('tap', '.heads4', function() {
	mui('#picture').popover('toggle');
	goodsAddVM.upFileType = 'fileD'
});

function clickType(type) {
	if(mui.os.android === true && (type === 'photoAlbum' || type === 'photograph')){
		plus.android.requestPermissions(['android.permission.READ_EXTERNAL_STORAGE'], function(e){
			if(e.granted.length>0){	//权限被允许
				//调用依赖获取定位权限的代码
				open()
			}
		}, function(e){
		});
	}else{
		open()
	}
	function open(){
		switch (type) {
			case "photoAlbum":
				clickGallery(goodsAddVM.upFileType);
				break;
			case "photograph":
				clickCamera(goodsAddVM.upFileType);
				break;
		}
	}
	mui('#picture').popover('toggle')
}

function getDirection(localUrl, name, type, fileName) {
	var img = document.createElement("img");
	if (mui.os.ios) {
		img.src = localUrl;
		img.onload = function() {
			prepareUpload(localUrl, name, type, fileName, '', img.width, img.height)
		}
	} else {
		img.src = localUrl;
		img.onload = function(){
			prepareUpload(localUrl,name,type,fileName,'',img.width,img.height)
		}
		// img.onload = function() {
		// 	EXIF.getData(img, function() {
		// 		direction = EXIF.getTag(this, 'Orientation');
		// 		switch (direction) {
		// 			case 1: //0
		// 				break;
		// 			case 6: //->90
		// 				direction = 90;
		// 				break;
		// 			case 8: //<-90
		// 				direction = 270;
		// 				break;
		// 			case 3: //180
		// 				direction = 180;
		// 				break;
		// 		}
		// 		prepareUpload(localUrl, name, type, fileName, direction, img.width, img.height)
		// 	})
		// }
	}
}
//相册
function clickGallery(type) {
	plus.gallery.pick(function(path) {
		var name = (new Date()).valueOf()
		var fileName = 'gallery';
		getDirection(path, name, type, fileName)
	}, function(err) {});
}
// 拍照
function clickCamera(type) {
	var cmr = plus.camera.getCamera();
	cmr.captureImage(function(path) {
		plus.io.resolveLocalFileSystemURL(path, function(entry) {
			var localUrl = entry.toLocalURL();
			var name = (new Date()).valueOf();
			var fileName = 'camera';
			getDirection(localUrl, name, type, fileName)
		});
	}, function(err) {
		console.error("拍照失败：" + err.message);
	}, {
		filename: '/storage/emulated/0/Pictures/',
		index: 1, //摄像头类型（1:主摄，2:副摄）Android - 2.2+ (不支持)iOS - 4.3+ (支持)
		optimize: false //自动调整图片的方向（图片显示会有延迟）iOS不支持
	});
}

function prepareUpload(localUrl, name, type, fileName, direction, width, height) {
	var data = {};
	var maxWidth = 720
	if ((width || width == 0) && Number(width) < maxWidth) {
		data = {
			src: localUrl,
			dst: "_doc/" + fileName + "/" + name + ".jpg",
			quality: 60,
			rotate: direction || 0,
			overwrite: true
		}
	} else {
		height = maxWidth * height / width;
		data = {
			src: localUrl,
			dst: "_doc/" + fileName + "/" + name + ".jpg",
			quality: 40,
			width: maxWidth + 'px',
			height: height + 'px',
			rotate: direction || 0,
			overwrite: true
		}
	}
	plus.zip.compressImage(data, function(e) {
		switch (type) {
			case "fileA":
				upFile.fileA = e.target;
				$("#head").attr('src', e.target);
				$('.mainImg').hide();
				$("#head").show();
				mui('#delA')[0].style.height = '21px';
				mui(".bli").on('tap', '#delA', function() {
					upFile.fileA = ''
					$("#head").attr("src", '');
					mui('#delA')[0].style.height = 0;
					$('.mainImg').show();
				})
				break;
			case "fileB":
				upFile.fileB = e.target;
				$("#head2").attr("src", e.target);
				mui('#delB')[0].style.height = '21px';
				mui(".bli").on('tap', '#delB', function() {
					upFile.fileB = ''
					$("#head2").attr("src", '');
					mui('#delB')[0].style.height = 0;
				})
				break;
			case "fileC":
				upFile.fileC = e.target;
				$("#head3").attr("src", e.target);
				mui('#delC')[0].style.height = '21px';
				mui(".bli").on('tap', '#delC', function() {
					upFile.fileC = ''
					$("#head3").attr("src", '');
					mui('#delC')[0].style.height = 0;
				})
				break;
			case "fileD":
				upFile.fileD = e.target;
				$("#head4").attr("src", e.target);
				mui('#delD')[0].style.height = '21px';
				mui(".bli").on('tap', '#delD', function() {
					upFile.fileD = ''
					$("#head4").attr("src", '');
					mui('#delD')[0].style.height = 0;
				})
				break;
		}
	}, function(err) {
		console.log("压缩失败：  " + err.message);
	});
}

function creatBackRefresh() {
	var opener = plus.webview.currentWebview().opener().id;
	localStorage.setItem("productListPage", "refresh");
	localStorage.setItem("pinProductListPage", "refresh");
	localStorage.setItem("draftProductListPage", "refresh");
	localStorage.setItem("pinDraftProductListPage", "refresh");
	localStorage.setItem("cunInventoryListPage", "refresh");
	localStorage.setItem("cunAlloctionListPage", "refresh");
	switch (opener) {
		// case "productList.html":
		// 	viewHandle.viewFire('productList.html', 'productRefresh');
		// 	break;
		// case "pinProductList.html":
		// 	viewHandle.viewFire('pinProductList.html', 'productRefresh');
		// 	break;
		// case "draftProductList.html":
		// 	viewHandle.viewFire('draftProductList.html', 'productRefresh');
		// 	break;
		// case "pinDraftProductList.html":
		// 	viewHandle.viewFire('pinDraftProductList.html', 'productRefresh');
		// 	break;
		// case "cunInventoryList.html":
		// 	viewHandle.viewFire('cunInventoryList.html', 'productRefresh');
		// 	break;
		// case "cunAlloctionList.html":
		// 	viewHandle.viewFire('cunAlloctionList.html', 'productRefresh');
		// 	break;
		case "cun.html":
			plus.webview.currentWebview().opener().evalJS('infoUpdate()');
			break;
	}
	updateAllProductList()
}

/**
 * 更新所有的商品列表
 */
function updateAllProductList(){
	viewHandle.viewFire('productList.html', 'productRefresh');
	viewHandle.viewFire('pinProductList.html', 'productRefresh');
	viewHandle.viewFire('draftProductList.html', 'productRefresh');
	viewHandle.viewFire('pinDraftProductList.html', 'productRefresh');
	viewHandle.viewFire('cunInventoryList.html', 'productRefresh');
	viewHandle.viewFire('cunAlloctionList.html', 'productRefresh');
}

/**
 * 库存限制数据 统一 此处改变引用
 * @param {colorList} colorList
 * @param {sizeList} sizeList
 * @return {specification} {colorLis, sizeList}
 */
function formDataStockLimitData(colorList, sizeList){
	if(colorList && colorList[0].id){
		colorList.map(item =>{
			item.color_id = item.id
			delete item.id
		})
	}
	if(sizeList && sizeList[0].id){
		sizeList.map(item =>{
			item.size_id = item.id
			delete item.id
		})
	}
	return {colorList, sizeList}
}
