const upLoadImgUrl = 'cosfile/uploadBusinessLicense'
const IMG_URL_HEAD = 'https://wx-xcx-1253752464.cos.ap-chengdu.myqcloud.com/app/pay_config/'

const VM = new Vue({
    el: '#VM',
    data: {
        errType: Location.getQueryVariable('errType'),
        // 失败提示信息
        errInfo: null,
        form: {
            // 上传哪一项图片
            uploadType: null,
            licenseType: 'company',
            // 营业执照照片网络 url
            license: null,
            accountBank: {
                name: null,
                id: null
            },
            alipId: null,
            // 法人身份证照片 网络 url
            legalPersonFront: null,
            // 法人身份证照片 网络 url
            legalPersonBack: null,
            legalPersonWeChatId: null,
            adminType: 'legalPerson',
            // 管理员身份证照片 网络 url
            adminFront: null,
            // 管理员身份证照片 网络 url
            adminBack: null,
            adminPhoneNumber: null,
            email: null,
            consumerHotline: null,
            storeName: null,
            storeAddress: null,
            // 店铺外照片 网络 url
            storeOuter: null,
            // 店铺内照片 网络 url
            storeInner: null,
        },
        show:{
            mask: false,
            weChatIdExample: false
        },
        disable: {
            submit: false
        }
    },
    watch: {
        'show.weChatIdExample': function (val){
            this.show.mask = val
        }
    },
    methods: {
        /**
         * 点击上传图片
         * @param {'license'|'legalPersonFront'|'legalPersonBack'|'adminFront'|'adminBack'|'storeOuter'|'storeInner'} type 那个类型
         */
        clickUpload(type) {
            this.uploadType = type
            this.show.mask = true
            this.IMGUPLOADPOPOVER.popover('show')
        },
        clickIMGUPLOADPOPOVER(type) {
            switch (type){
                case 'camera': clickCamera(this.uploadType); break;
                case 'photoAlbum': clickGallery(this.uploadType); break;
                default:
                    this.uploadType = null;
            }
            this.show.mask = false
            this.IMGUPLOADPOPOVER.popover('hide')
        },
        /**
         * 图片上传结束 存图url
         * @param type 那个上传结束
         * @param status 状态
         * @param res 响应
         */
        uploadImgEnd(type, status, res) {
            console.log({this: this, type, status, res})
            if(!status){
                this[type] = null
                return
            }
            $('.' + type).remove()
            this.addShowImg(type, res.data)
        },
        /**
         *  点击提交
         */
        clickSubmitForm() {
            const err = this.ruleVerify()
            if(err) {
                return mui.confirm(err, '提示', ["确定"], function(e) {}, 'div')
            }
            this.submit()
        },
        /**
         * 验证表单完整性
         */
        ruleVerify() {
            let err
            this.form.storeInner || (err = '等待上传店铺内景照')
            this.form.storeOuter || (err = '等待上传店铺门头照')
            this.form.storeAddress || (err = '店铺地址')
            this.form.storeName || (err = '店铺名称(简称)')
            this.form.consumerHotline || (err = '请填写客服电话')
            this.form.email || (err = '请填写电子邮箱')
            this.form.adminPhoneNumber || (err = '请填写' + (this.form.adminType === 'naturalPerson' ? '超管员' : '法人') + '手机号')
            if(this.form.adminType === 'naturalPerson'){
                this.form.adminBack || (err = '等待上传超级管理员照片背面')
                this.form.adminFront || (err = '等待上传超级管理员照片正面')
            }
            this.form.adminType || (err = '请选择超级管理员类型')
            this.form.legalPersonWeChatId || (err = '请填写法人实名微信号')
            this.form.legalPersonBack || (err = '等待上传法人身份证照片背面')
            this.form.legalPersonFront || (err = '等待上传法人身份证照片正面')
            this.form.alipId || (err = '请填写支付宝账号')
            this.form.accountBank.id || (err = '请填写开户行账号')
            this.form.accountBank.name || (err = '请填写开户行名称')
            this.form.license || (err = '等待上传营业执照照片')
            this.form.licenseType || (err = '请选择营业执照类型')
            return err
        },
        /**
         * 提交表单 错误尝试10次
         */
        submit() {
            if(this.disable.submit) return
            this.disable.submit = true
            const form = this.form
            const data = {
                bl_type: form.licenseType === 'company' ? '公司' : '个体',
                bl_url: deleteImgUrlHead(form.license),
                open_bank_name: form.accountBank.name,
                open_bank_account: form.accountBank.id,
                ali_pay_account: form.alipId,
                fr_id_card_url_1: deleteImgUrlHead(form.legalPersonFront),
                fr_id_card_url_2: deleteImgUrlHead(form.legalPersonBack),
                fr_vx_id: form.legalPersonWeChatId,
                sa_type: '0',
                phone: form.adminPhoneNumber,
                email: form.email,
                kf_phone: form.consumerHotline,
                shop_name: form.storeName,
                shop_address: form.storeAddress,
                shop_out_pic: deleteImgUrlHead(form.storeOuter),
                shop_inner_pic: deleteImgUrlHead(form.storeInner),
            }
            if(form.adminType === 'naturalPerson'){
                data.sa_type = '1'
                data.sa_id_card_url_1 = deleteImgUrlHead(form.adminFront)
                data.sa_id_card_url_2 = deleteImgUrlHead(form.adminBack)
            }
            this.show.mask = true
            let count = 0
            let url = 'sso/payCompany/add'
            if(this.errType) {
                url = 'sso/payCompany/update'
                switch (this.errType){
                    case '2': data.type = ''; break;
                    case '3': data.type = 'WX'; break;
                    case '4': data.type = 'ALI'; break;
                }
            }
            post()
            function post() {
                mui.ajax({
                    url: severUrl + url,
                    data: data,
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    xhrFields: {
                        withCredentials: true
                    },
                    dataType: 'json',
                    type: 'post',
                    timeout: 10000,
                    success(res) {
                        if(res.status === 200){
                            VM.show.mask = false
                            VM.jumpSuccess()
                        }else{
                            mui.confirm(res.msg, '错误', ["确定"], function(e) {}, 'div')
                            VM.show.mask = false
                            VM.disable.submit = false
                        }
                    },
                    error() {
                        count ++
                        if(count < 10){
                            post()
                        }else{
                            mui.confirm('提交失败，请稍后再试。', '错误', ["确定"], function(e) {}, 'div')
                            VM.show.mask = false
                            VM.disable.submit = false
                        }
                    }
                })
            }

        },
        jumpSuccess() {
            JumpPage.jump('openScanCodePaySuccess.html','openScanCodePaySuccess',function (){
                plus.webview.hide('openScanCodePayUpload')
                plus.webview.close('openScanCodePayUpload', 'none')
            },'slide-in-right')
        },
        /**
         * 获取之前的提交信息
         */
        getScanCodePayInfo(errType) {
            let data = {}
            switch (errType){
                case '2': data.type = ''; break;
                case '3': data.type = 'WX'; break;
                case '4': data.type = 'ALI'; break;
            }
            mui.ajax({
                url: severUrl + 'sso/payCompany/showDescription',
                data: data,
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                xhrFields: {
                    withCredentials: true
                },
                dataType: 'json',
                type: 'post',
                timeout: 10000,
                success(res) {
                    if (res.status === 200){
                        console.log(res) // debug
                        VM.errInfo = res.data.description
                        VM.form.licenseType = res.data.bl_type === '公司' ? 'company' : 'selfEmployed'
                        VM.addShowImg('license', IMG_URL_HEAD + res.data.bl_url)
                        VM.form.accountBank.name = res.data.open_bank_name
                        VM.form.accountBank.id = res.data.open_bank_account
                        VM.form.alipId = res.data.ali_pay_account
                        res.data.fr_id_card_url_1 && VM.addShowImg('legalPersonFront', IMG_URL_HEAD + res.data.fr_id_card_url_1)
                        res.data.fr_id_card_url_1 && VM.addShowImg('legalPersonBack', IMG_URL_HEAD + res.data.fr_id_card_url_2)
                        VM.form.legalPersonWeChatId = res.data.fr_vx_id
                        VM.form.adminPhoneNumber = res.data.phone
                        VM.form.email = res.data.email
                        VM.form.consumerHotline = res.data.kf_phone
                        VM.form.storeName = res.data.shop_name
                        VM.form.storeAddress = res.data.shop_address
                        VM.addShowImg('storeOuter', IMG_URL_HEAD + res.data.shop_out_pic)
                        VM.addShowImg('storeInner', IMG_URL_HEAD + res.data.shop_inner_pic)
                        VM.form.adminType = 'legalPerson'
                        if(res.data.sa_type === '1'){
                            VM.form.adminType = 'naturalPerson'
                            VM.addShowImg('adminFront', IMG_URL_HEAD + res.data.sa_id_card_url_1)
                            VM.addShowImg('adminBack', IMG_URL_HEAD + res.data.sa_id_card_url_2)
                        }
                    }else{
                        mui.toast('获取数据失败，请返回重试！')
                    }
                },
                error() {
                    mui.toast('获取数据失败，请返回重试！')
                }
            })
        },
        /**
         * 添加图片显示
         * @param type
         * @param url
         */
        addShowImg(type, url){
            const img = document.createElement('a')
            img.className = 'img-Placeholder circleChart ' + type
            // img.style.backgroundImage = 'url(' + IMG_URL_HEAD + url + ')'
            img.style.backgroundImage = 'url(' + url + '?time=' + new Date().valueOf() + ')'
            img.onclick = function (){
                VM.clickUpload(type)
            }
            this['J_'+ type].before(img)
            this.form[type] = url
        },
        showToastImg(url){
            this.$refs.toastImgDom.style.backgroundImage = 'url('+ url +')'
            this.show.weChatIdExample = true
        }
    },
    mounted(){
        const _this = this
        mui.plusReady(function (){
            _this.errType && _this.getScanCodePayInfo(this.errType)
        })
        this.IMGUPLOADPOPOVER =  mui('#IMGUPLOADPOPOVER')
        this.J_license = $('#J_license')
        this.J_legalPersonFront = $('#J_legalPersonFront')
        this.J_legalPersonBack = $('#J_legalPersonBack')
        this.J_adminFront = $('#J_adminFront')
        this.J_adminBack = $('#J_adminBack')
        this.J_storeOuter = $('#J_storeOuter')
        this.J_storeInner = $('#J_storeInner')
    },
})
/**
 * 去除图片url的固定路径
 * @param url {string} 上传返回的图片地址
 */
function deleteImgUrlHead(url){
    return url.replace(IMG_URL_HEAD,'')
}

// 相册
function clickGallery(type) {
    plus.gallery.pick(function(path) {
        getDirection(path,type)
    }, function(err) {
        this.uploadType = null;
        console.error("相册失败：" + err.message)
    });
}
// 拍照
function clickCamera(type) {
    let cmr = plus.camera.getCamera();
    cmr.captureImage(function(path) {
        plus.io.resolveLocalFileSystemURL(path, function(entry) {
            let localUrl = entry.toLocalURL();
            getDirection(localUrl,type)
        });
    }, function(err) {
        this.uploadType = null;
        console.error("拍照失败：" + err.message);
    }, {
        filename:'/storage/emulated/0/Pictures/',
        index: 1, //摄像头类型（1:主摄，2:副摄）Android - 2.2+ (不支持)iOS - 4.3+ (支持)
        optimize:false //自动调整图片的方向（图片显示会有延迟）iOS不支持
    });
}
// 获取本地地址
function getDirection(localUrl,type){
    let getHW = new Promise(function (resolve, reject) {
        plus.io.getImageInfo({
            src: localUrl,
            success: resolve,
            fail: reject
        })
    })
    let getSize = new Promise(function (resolve, reject) {
        plus.io.getFileInfo({
            filePath: localUrl,
            success: resolve,
            fail: reject
        })
    })
    Promise.all([getHW, getSize]).then(function(e){
        let width = e[0].width, height = e[0].height, size = e[1].size
        prepareUpload(localUrl,type,width,height,size)
    }).catch(function(e){
        mui.toast('获取文件信息失败')
    })
}

/**
 * 图片压缩 准备上传
 * @param localUrl 本地地址
 * @param type clickUpload的type类型
 * @param width 宽度
 * @param height 高度
 * @param size
 */
function prepareUpload(localUrl,type,width,height,size) {
    let data = {
        src: localUrl,
        dst: "_doc/"+type+".jpg",
        quality: 100,
        overwrite: true,
        width: "auto",
        height: "auto"
    };
    let maxWidth=2000

    if(Number(width) > Number(height) && Number(width) > maxWidth){
        data.width = maxWidth +'px'
    }else if(Number(height) > Number(width) && Number(height) > maxWidth) {
        data.height = maxWidth +'px'
    }
    if(size < 5 * 1024 * 1024){
        submitImg({
            target: localUrl
        })
        return
    }

    plus.zip.compressImage(data, submitImg , function(err) {
        console.error("压缩失败：" + err.message);
    });
    function submitImg(file){
        console.log(file)
        VM['J_'+ type].before('<a href="javascript:;" class="img-Placeholder circleChart" id="'+type+'"></a>')
        const circleChart =  $('#'+type+'').circleChart({
            text:0,
            textSize: '1rem',
            value:0,
            onDraw: function(el, circle) {
                circle.text(Math.round(circle.value) + "%");
            }
        })
        const fileUploadData = {}
        switch (type) {
            case 'license' : fileUploadData.url = 'bl_url'; break;
            case 'legalPersonFront' : fileUploadData.url = 'fr_id_card_url_1'; break;
            case 'legalPersonBack' : fileUploadData.url = 'fr_id_card_url_2'; break;
            case 'adminFront' : fileUploadData.url = 'sa_id_card_url_1'; break;
            case 'adminBack' : fileUploadData.url = 'sa_id_card_url_2'; break;
            case 'storeOuter' : fileUploadData.url = 'shop_out_pic'; break;
            case 'storeInner' : fileUploadData.url = 'shop_inner_pic'; break;
        }
        // switch (VM.errType) {
        //     case '2' : fileUploadData.style = 'ALL'; break;
        //     case '4' : fileUploadData.style = 'ALI'; break;
        //     case '3' : fileUploadData.style = 'WX'; break;
        // }
        fileUpload(upLoadImgUrl, file.target, fileUploadData, function(status, res){
            if(status) {

            }else{
                mui.toast('上传失败！')
            }
            setTimeout(function (){
                circleChart.remove();
                VM.uploadImgEnd(type, status, res)
            },200)
        }, function (schedule, state, res) {
            schedule = parseInt(schedule * 100)
            const data = {
                value:  schedule === 100 ? schedule - 1 : schedule,
                speed: 30,
                fontSize: '0.8rem',
            }
            if( state === 4 && schedule === 100) {
                data.color = '#229a01'
                data.onDraw = function(el, circle) {
                    circle.text("成功");
                }
                setTimeout(function (){
                    circleChart.remove();
                    // VM.uploadImgEnd(type, true, res)
                },800)
            }else if(state === 4 && (schedule !== 100 || isNaN(schedule) )){
                data.color = '#f00'
                data.onDraw = function(el, circle) {
                    circle.text("错误");
                }
                setTimeout(function (){
                    circleChart.remove();
                    // mui.toast('上传失败！')
                    // VM.uploadImgEnd(type, false, res)
                },800)
            }else{
                data.onDraw = function(el, circle) {
                    circle.text(Math.round(circle.value) + "%");
                }
            }
            // console.log(schedule, state)
            circleChart.circleChart(data)
        })
    }
}

/**
 * 文件上传
 * @param url 上传服务器地址
 * @param src 本地文件路径
 * @param data 额外参数
 * @param cbFn 回调 实参1 响应码 实参2  响应体
 * @param timerFn 上传中 50ms 回调  实参 进度 小数
 */
function fileUpload(url ,src, data, cbFn, timerFn) {
    let timer = null
    let res
    const server = severUrl + url;
    //打开等待旋转提示按钮
    // const wt = plus.nativeUI.showWaiting();
    const task = plus.uploader.createUpload(server, {
        method: "post"
    }, function(t, status) {
        // wt.close(); //关闭等待提示按钮
        // console.log(status,t)
        let f = false
        if(status === 200 && JSON.parse(t.responseText||'{}').status === 200){
            f = true
        }
        res = JSON.parse(t.responseText[0] === '{' ? t.responseText : '{}')
        cbFn && cbFn(f, res)
    });
    task.addFile(src, {});
    if(data){
        for (const dataKey in data) {
            task.addData(dataKey, data[dataKey].toString());
        }
    }
    task.start();
    if(timerFn){
        timer = setInterval(function () {
            let schedule = task.uploadedSize/task.totalSize
            // ios uploadedSize 是 0
            ;(task.state === 3 || task.state === 4) && timerFn(schedule,task.state, res)
            if(task.state === 4){
                clearInterval(timer)
            }
        }, 50)
    }
}
