/** 获取页面URL参数 */
function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if (r != null) return unescape(r[2]); return null;
};

var barcodeDepotId = getQueryString('option_id');
var goodBarcodeListVM = new Vue({
	el: '#goodBarcodeListVM',
	data: {
		goodBarcodeList:[],
		salePrice:0,
		optionName:sessionStorage.getItem('optionName'),
		product:{model:'',purchase_price :''},
	},
	methods: {
		saveList:function(){
			this.product.amt=this.salePrice;
			var selProductList=JSON.parse(sessionStorage.getItem("selProductList"));
			
			if(!selProductList||selProductList.length==0){
				selProductList=[];
				goodBarcodeListVM.product.depot_id=barcodeDepotId;
				selProductList.push(goodBarcodeListVM.product);
			}else{
				mui.each(selProductList,function(index,value){
					if(value.product_id==goodBarcodeListVM.product.product_id&&value.depot_id==barcodeDepotId){
						value.list=goodBarcodeListVM.product.list;
						return false;	
					}else if(index==selProductList.length-1){
						goodBarcodeListVM.product.depot_id=barcodeDepotId;
						selProductList.push(goodBarcodeListVM.product);
						return false;
					}
				});
			}
			sessionStorage.setItem("selProductList",JSON.stringify(selProductList));
			mui.back();
		},
		changeUnitPrice:function(){
			goodBarcodeListVM.$nextTick(function(){
                document.getElementById("priceIpt").focus();
            })
		},
	},
	created:function(){
		scan = null; //扫描对象
		 mui.plusReady(function() {
		   	mui.init();
		   	startRecognize();
		
		 });
		 getDataList();
	}
});

setListener();
   function startRecognize() {
   	try {
   		var filter;
   		//自定义的扫描控件样式  
   		var styles = { frameColor: "#29E52C", scanbarColor: "#29E52C", background: "" }
   		//扫描控件构造  
   		scan = new plus.barcode.Barcode('bcid', filter, styles);
   		scan.onmarked = onmarked;
   		scan.onerror = onerror;
   		scan.start();
   		//打开关闭闪光灯处理  
   		var flag = false;
   		document.getElementById("turnTheLight").addEventListener('tap', function() {
   			if(flag == false) {
   				scan.setFlash(true);
   				flag = true;
   			} else {
   				scan.setFlash(false);
   				flag = false;
   			}
   		});
   	} catch(e) {
   		console.log("出现错误啦:\n" + e);
   	}
   };

   function onerror(e) {
// 	alert("暂无记录请换其他仓库");
// 	mui.back();
		console.log("暂无记录请换其他仓库")
   };

   function onmarked(type, result) {
   	var text = '';
   	switch(type) {
   		case plus.barcode.QR:
   			text = 'QR: ';
   			break;
   		case plus.barcode.EAN13:
   			text = 'EAN13: ';
   			break;
   		case plus.barcode.EAN8:
   			text = 'EAN8: ';
   			break;
   	}
   	console.log(text + " : " + result);
   	//                  barcode=result;
   	getDataList(result);
   	//				mui.openWindow({
   	//				    id:'addCamera',
   	//				    url:'../barCode.html',
   	//				    extras: {  
   	//				       barcode:result//自定义扩展参数，可以用来处理页面间传值  
   	//				    } 
   	//				});

   };

   // 从相册中选择二维码图片   
   function scanPicture() {
   	plus.gallery.pick(function(path) {
   		plus.barcode.scan(path, onmarked, function(error) {
   			plus.nativeUI.alert("无法识别此图片");
   		});
   	}, function(err) {
   		plus.nativeUI.alert("Failed: " + err.message);
   	});
   }

   function getDataList(result) {
   	console.log(barcodeDepotId)
   	mui.ajax(severUrl + "scm/product/qryOpByBarcode.json", {
   		data: {
   			depot_id: barcodeDepotId,
   			barcode: result,
   		},
   		headers: {
   			'Content-Type': 'application/x-www-form-urlencoded'
   		},
   		xhrFields: {
   			withCredentials: true
   		},
   		dataType: 'json',
   		type: 'post',
   		timeout: 10000,
   		success: function(res) {
   			if(res.status==200) {
   				goodBarcodeListVM.goodBarcodeList=res.data;
   				goodBarcodeListVM.salePrice=res.data.sale_price;
   				console.log(goodBarcodeListVM.salePrice)
   				//赋值
   				goodBarcodeListVM.product.unit=res.data.unit;
   				goodBarcodeListVM.product.billsn=res.data.billsn;
   				goodBarcodeListVM.product.name=res.data.name;
   				goodBarcodeListVM.product.purchase_price=res.data.purchase_price;
   				goodBarcodeListVM.product.model=res.data.model;
   				goodBarcodeListVM.product.id=res.data.id;
   				goodBarcodeListVM.product.stock_warn=res.data.stock_warn;
   				goodBarcodeListVM.product.category=res.data.category;
   				goodBarcodeListVM.product.product_name=res.data.name;
   				goodBarcodeListVM.product.sale_price=res.data.sale_price;
   				goodBarcodeListVM.product.status=res.data.status;
   				goodBarcodeListVM.product.list=[];
				goodBarcodeListVM.product.list.push({
					product_id:res.data.id, 
					sale_price:res.data.sale_price,
					amt:goodBarcodeListVM.salePrice,		
					color_id:res.data.color_id, 	
					color_name:res.data.color_name,
					size_id:res.data.size_id, 
					size_name:res.data.size_name,
					amount:res.data.amount,
					barcode:result,
					count:res.data.amount,
					ordertype:0,
					depot_id:barcodeDepotId
					
				});
   			}else{
   				/*alert("暂无记录请换其他仓库");
   				mui.back();*/
   				console.log("暂无记录请换其他仓库")
   			}
   		}
   	});
 }
function setListener(){
  	mui(".mui-content").on('tap','.btn-xiugai',function(){
	  
	}) 
}