mui.plusReady(init)
let VM
function init (){
	let page = plus.webview.currentWebview()
	const trackingType = ['开单', '盘点', '调出', '调入', '初始入库', '草稿']
	const orderType = ['采购', '销售']
	const submitStatus = ['', '订单']
	const jumpInfoUrl = ['customerDebets', 'historyXQ', 'allocationXQ', 'allocationXQ']
	let listPullUploading
	let listDOM
	VM = new Vue({
		el: '#vm',
		data (){
			return {
				batchNumber: page.batchNumber,
				trackingType: trackingType,
				orderType,
				submitStatus,
				list: [],
				systemSetting: JSON.parse(localStorage.systemSetting),
				size_show: localStorage.getItem("size_show") || 1,
				color_show: localStorage.getItem("color_show") || 1,
				unit_show: localStorage.getItem("unit_show") || 0,
				origin_specification: localStorage.getItem("origin_specification") || 0,
				// permission
				positionName: false,
				stockManager: false,
				purchaseManager: false,
				faAccount: false,
				labelPrinter: false,
				companySetIndustry: false,
			}
		},
		components: {

		},
		watch: {

		},
		computed: {

		},
		methods: {
			getPurview: function() { //获取权限
				let _this = this;
				$API.user.getCurrUser().then(function (res) {
					if (res.success) {
						let code = res.data.position,
							permission = code.permission;
						_this.positionName = permission.indexOf('A11_1_O') >= 0 || permission.indexOf('A11_1_E') >= 0;
						_this.stockManager = permission.indexOf('A4_1_E') >= 0
						_this.faAccount = permission.indexOf('FA_ACC') >= 0
						_this.purchaseManager = permission.indexOf('LOOK_PURCHASE') >= 0
						_this.labelPrinter = permission.indexOf('ONLY_PRINT') >= 0
						_this.companySetIndustry = res.data.company_set_industry;
					} else if (res.status === 10101 || res.status === 10102) {
						logOut(res.msg)
					}
				})
			},
			getList(pageNum) {
				if(pageNum){
					listPullUploading.data.num = pageNum
				}
				let _this = this
				return $API.product.qryProductionBatchDataGridBNTracking({id: page.batchId, rows: 20, page: pageNum}).then(function (e){
					if (listPullUploading.data.num === 1) {
						listPullUploading.reset()
						_this.list = e.data.list
						listDOM.scroll().refresh(); //先刷新一次布局再scrollTo
						listDOM.scroll().scrollTo(0, 0, 100); //100毫秒滚动到顶
					} else {
						Array.prototype.push.apply(_this.list, e.data.list)
						_this.$forceUpdate()
					}

					let isEntire = e.data.pageNumber >= e.data.totalPage
					return Promise.resolve({isEntire: isEntire})
				}).catch(function (e) {
					return Promise.reject(e)
				})
			},
			jumpInfo(item){
				if(!jumpInfoUrl[item.tracking_type]){
					return mui.toast('暂不支持')
				}
				let listSend = {

					htmlType: 'bn_info',
					openType: 'show',
				}
				if (item.tracking_type === 0){
					listSend.type = 'auto'
				} else {
					listSend.openType = 'show'
				}
				if (item.tracking_type === 1){
					listSend.histDetail_id = item.refer_id
				}else if(item.tracking_type === 2 || item.tracking_type === 3){
					listSend.alltDetail_id = item.refer_id
				} else {
					listSend.id = item.refer_id
				}

				viewHandle.viewFire(jumpInfoUrl[item.tracking_type] + '.html', jumpInfoUrl[item.tracking_type], listSend);
				viewHandle.openWindow('../' + jumpInfoUrl[item.tracking_type] + '.html', jumpInfoUrl[item.tracking_type] + '.html', JSON.stringify(listSend))
			}
		},
		beforeCreate(){
			console.log('beforeCreate')
		},
		created(){
			this.getPurview()
			console.log('created')
		},
		beforeMount(){
			console.log('beforeMount')
		},
		mounted(){
			let _this = this
			listDOM = mui('.J-scroll-wrapper')
			listDOM.scroll({
				deceleration: 0.0006,
				indicators: false
			})
			listPullUploading = new $comm.PullUpLoading('.J-pull-up-loading', '.J-scroll-wrapper', function (num) {
				return _this.getList(num)
			}, '.J-text')
			listPullUploading.load(1, true)
			console.log('mounted')
		},
		beforeUpdate(){
			console.log('beforeUpdate')
		},
		updated(){
			console.log('updated')
		},
		beforeDestroy(){
			console.log('beforeDestroy')
		},
		destroyed(){
			console.log('destroyed')
		}
	})
}
