var isSelectedProductionBatchNumber=false
mui('body').on('tap', '.muiBack', function() {
    viewHandle.back('close');
});
var production_batch_set_vm = new Vue({
    el:"#production_batch_set_vm",
    data:{
        readOnly: false,
        expire_date_ms:'',
        production_date:'',//生产日期
        finish_date:'',//到期日期
        item_info:'',
        product_info:'',
        // args:'',
        expire_date:'',//保质期
        expire_date_power:false,//保质期权限
        systemSetting:JSON.parse(localStorage.systemSetting),
        product_color_size_id:'',
        production_batch_number:'',
        type:'',
        list:[],//采购退货的批次号列表
        depot_id:'',
        indexCopy:'',
        setPageId: null, // 订单来设置 会提供触发事件的页面id

        //全行业参数
        size_show: Number(localStorage.getItem("size_show") || 1),
        color_show: Number(localStorage.getItem("color_show") || 1),
        unit_show: Number(localStorage.getItem("unit_show") || 0),
        origin_specification: localStorage.getItem("origin_specification") || 0,
    },
    mixins:[globalSystemMixin],
    mounted:function (){
        var _this=this;
        setTimeout(function (){
            //用混入 利于后期的扩展
            production_batch_set_vm.expire_date_power=globalSystemMixin.computed.productionBatchPower(_this.systemSetting.production_batch_setting)
        },100)
        mui.plusReady(function (){
            let page = plus.webview.currentWebview()
            var arg=page.arg;
            if(arg){
               arg=JSON.parse(arg);
               _this.item_info=arg.item;
               _this.product_info=arg.product;
               _this.depot_id=arg.depot_id;
               // _this.args=arg.args;
               _this.type=arg.type;
               if(arg.index===0){
                   _this.indexCopy=arg.index
               }else{
                   if(arg.index){
                       _this.indexCopy=arg.index
                   }else{
                       _this.indexCopy=null
                   }
               }
               if(production_batch_set_vm.expire_date_power) getExpireDate(arg.product.id, arg.depot_id, arg.item.color_id, arg.item.size_id);//查询获取保质期
            } else if ( page.setPageId ){
                if(page.readOnly){
                    _this.readOnly = true
                }
                // 订单入库BN设置修改
                _this.item_info = {
                    color_name: page.colorName,
                    size_name: page.sizeName
                }
                _this.setPageId = page.setPageId
                _this.product_info = {model: page.productModel}
                // if(production_batch_set_vm.expire_date_power) getExpireDate(page.product.product_id);//查询获取保质期

                if(page.expireDateMs){
                    _this.expire_date_ms=page.expireDateMs
                    _this.expire_date=getTimeUnitStampTODate( page.expireDateMs,'天')
                }
                if(page.productionBatchId ||  page.productionBatchNumber || page.productionDateTimestamp)
                    _this.item_info.product_production_batch_list = [{
                        production_batch_id: page.productionBatchId,
                        production_batch_number: page.productionBatchNumber,
                        production_date_str: page.productionDateTimestamp ? $comm.DATE_UTIL.formatDate(new Date(page.productionDateTimestamp),false) : '',
                        expire_date_ms:_this.expire_date_ms
                    }]
                _this.initBatch()
                // 订单处理END
            }
        })

    },
    methods:{
        sweepCode(){
            if(this.readOnly) return
            const sendUrl = 'zhijianjxcapp://barcodescan/param?color_id=-1&size_id=-1';
            const cookie = 'ecp_cookie=' + localStorage.getItem("HF");
            if (mui.os.ios === true) {
                sweepCode_i(cookie, sendUrl, 777)
            } else if (mui.os.android === true) {
                sweepCode(cookie, sendUrl, 777)
            }
        },
        productBatch(){
            if(this.readOnly) return mui.back()
            //先做验证
            if(this.production_date!='' && this.production_batch_number==''){
                mui.toast('设置了生产日期必须设置批次号')
                return false
            }
            if(this.production_batch_number && this.production_batch_number.length > 50){
                return  mui.toast('批次号长度不能大于50字符')
            }
            if(this.setPageId){
                mui.fire(plus.webview.getWebviewById(this.setPageId), 'productionBatchSetting', {
                    production_batch_id:'',
                    production_batch_number: this.production_batch_number,
                    production_date_str:this.production_date,
                    production_date_timestamp: Math.round(new Date(this.production_date)/1),
                    expire_date_ms:this.expire_date_ms,
                })
                mui.back()
                return
            }
            var listSend={
                production_batch_id:'',
                production_batch_number: this.production_batch_number,
                production_date_str:this.production_date,
                product_color_size_id:this.product_color_size_id,
                expire_date_ms:this.expire_date_ms,
                item:this.item_info,
                product:this.product_info,
                type:this.type,
                indexCopy:this.indexCopy
            }
            // 写返回 并传递数据
            viewHandle.viewFire('caigou.html','productionBatchSetting',listSend)
            viewHandle.back('close');
        },

        initBatch(){
            let _this = this
            //在这里处理已经设置过批次的
            if(_this.item_info.product_production_batch_list &&_this.item_info.product_production_batch_list.length>0){
                //表示已经设置过批次了
                _this.production_date=_this.item_info.product_production_batch_list[0].production_date_str||''
                _this.production_batch_number=_this.item_info.product_production_batch_list[0].production_batch_number
                //还要处理到期日期
                if(_this.expire_date_ms&&_this.production_date!='') {
                    _this.finish_date = dateChange(production_batch_set_vm.expire_date, production_batch_set_vm.production_date, "+")
                }
            }
        },

        selectProductionBatchNumber(index){
            if(this.readOnly) return
            isSelectedProductionBatchNumber=true
            this.production_batch_number=this.list[index].production_batch_number;
            this.production_date=loadDates(this.list[index].production_date_timestamp);
            this.expire_date=getTimeUnitStampTODate(this.list[index].expire_date_ms,'天')
            this.finish_date=dateChange(getTimeUnitStampTODate(this.list[index].expire_date_ms,'天'),loadDates(this.list[index].production_date_timestamp),'+')
            mui("#popover").popover("hide");
        },
        blurProductionBatchNumber(){
            mui("#popover").popover("hide");
        },
        qryColorSizeIdByProductId(productId, depotId, colorId, sizeId) {
            return new Promise(function (resolve, reject){
                const loading = viewHandle.loading('请稍后...')
                $API.product.qryColorSizeIdsByProductIds({
                    'depot_id': depotId,
                    'product_ids': productId
                }).then(function(e) {
                    loading.close()
                    const temp = e.data.find(function (e){ return e.depot_id === depotId && e.product_id === productId && e.color_id === colorId && e.size_id === sizeId})
                    if(temp){
                        resolve(temp.product_color_size_id)
                    }else{
                        mui.toast('数据异常')
                        reject()
                    }
                }).catch(function(e) {
                    loading.close()
                    mui.toast('数据异常')
                    reject(e)
                })
            })
        },
    }
})

/**
 * 查询获取商品的保质期
 */
function getExpireDate(id, depotId, colorId, sizeId){
    let _this = production_batch_set_vm
    $API.product.qryProduct({'id': id}).then(function(res) {
        //处理保质期 还要处理商品没有设置保质期的情况
        if(res.data.expire_date_ms){
            _this.expire_date_ms = res.data.expire_date_ms
            _this.expire_date = getTimeUnitStampTODate(res.data.expire_date_ms,'天')
        }
        _this.qryColorSizeIdByProductId(id, depotId, colorId, sizeId).then(function (product_color_size_id) {
            _this.product_color_size_id = product_color_size_id
            _this.initBatch()
        })
    })
}
function loadNowDate(type) {
    var myDate = new Date();
    var Y = myDate.getFullYear()
    var M = (myDate.getMonth() + 1);
    var D = myDate.getDate();

    M >= 10 ? M = M : M = 0 + "" + M;
    D >= 10 ? D = D : D = 0 + "" + D;

    if (type == 1) {
        return Y + '-' + M + '-' + D;
    } else if (type == 2) {
        return Y + '-' + M + '-' + '01';
    }

}

var production_date = new mui.DtPicker({
    type: "date",
    labels: ['年', '月', '日']
});

var finish_date = new mui.DtPicker({
    type: "date",
    labels: ['年', '月', '日']
});

mui('body').on('tap', '.production_date', function () {
    if(production_batch_set_vm.readOnly) return
    var _self = this;
    production_date.show(function (e) {
        production_batch_set_vm.production_date = e.text;
        // sessionStorage.setItem("singleDateFirst",e.text)
        //生产日期与到期日期 知其一则知其二 在有保质期的前提下
        if(production_batch_set_vm.expire_date){
            production_batch_set_vm.finish_date=dateChange(production_batch_set_vm.expire_date,production_batch_set_vm.production_date,"+")
        }
    })
});

mui('body').on('tap', '.finish_date', function () {
    if(production_batch_set_vm.readOnly) return
    if(production_batch_set_vm.expire_date===''){
        //保质期为空时 禁用到期日期
        return false
    }
    var _self = this;
    finish_date.show(function (e) {
        production_batch_set_vm.finish_date = e.text;
        // sessionStorage.setItem("singleDateLast",e.text)
        //生产日期与到期日期 知其一则知其二
        if(production_batch_set_vm.expire_date){
            production_batch_set_vm.production_date=dateChange(production_batch_set_vm.expire_date,production_batch_set_vm.finish_date,"-")
        }
    })
});
// 扫码返回
function fn(color_id, size_id, barcode) {
    production_batch_set_vm.production_batch_number = String(barcode)
}
