var sns_choose_vm = new Vue({
    el: "#sns_choose_vm",
    data: {
		//全行业参数
		size_show: localStorage.getItem("size_show") || 1,
		color_show: localStorage.getItem("color_show") || 1 ,
		unit_show: localStorage.getItem("unit_show") || 0,
		origin_specification: localStorage.getItem("origin_specification") || 0,
        search_sn:'',
        item_info: [],
        args: {},
        choose_list: [],
        select_list: []
    },
    watch: {

    },
    computed:{
        select_list_check:function(){
            var _this = this;
            return _this.select_list.filter(function(sn){
                return sn.product_sn.indexOf(_this.search_sn) !=-1 || _this.search_sn == ''
            })
        }
    },
    methods:{
        select_all:function(e){ //全选
            var _this = this;
            if(e.target.checked){
                if(_this.args.can_choose < _this.select_list.length){
                    mui.toast("数量大于可选数量请手动选择")
                    e.target.checked = false
                }else{
                    var list = []
                    mui.each(_this.select_list,function(i,v){
                        list.push(v.product_sn)
                    })
                    _this.choose_list = list
                }
            }else{
                _this.choose_list = []
            }
        },
        select_check:function(e){//选择check
            var _this = this;
            if(_this.choose_list.length > _this.args.can_choose){
                mui.toast("超过选择数量,请返回修改")
                mui.each(_this.choose_list,function(i,v){
                    if(v == e.target.value){
                        return _this.choose_list.splice(i,1)
                    }
                })
            }
        },
        qryProductSNs:function(){ //可用序列号查询
            var _this = this,type;
            if(_this.item_info.type || _this.item_info.type === 0 ){
                type = _this.item_info.type
            }else{
                type = _this.item_info.ordertype
            }
            var data = {
                product_id: _this.args.product_id,
                color_id: _this.item_info.color_id,
                size_id: _this.item_info.size_id,
                depot_id: _this.args.depot_id,
                submit_status:(_this.args.qryPage != 'cai_order' && _this.args.qryPage !='xiao_order')?0:1, //0为开单，1为草稿
                ordertype:(_this.args.qryPage != 'cai' && _this.args.qryPage !='cai_order')?1:0, //0为进货，1为销售
                type:(_this.args.qryPage == 'db')?0:type //0为进货或销售，1为退货
            }
            mui.ajax(severUrl + 'scm/productsn/qryProductSNs.json', {
                data : data,
                headers : {
                    'Content-Type' : 'application/x-www-form-urlencoded'
                },
                xhrFields : {
                    withCredentials : true
                },
                dataType : 'json',
                type : 'post',
                timeout : 30000,
                success : function(res) {
                    if (res.success) {
                        _this.select_list = res.data
                        // 去除 当前被选中的序列号
                        if(Array.isArray(_this.args.product_sn_list_not) && _this.args.product_sn_list_not.length > 0){
                            let list = []
                            _this.select_list.forEach(function (item){
                                if(_this.args.product_sn_list_not.indexOf(item.product_sn) === -1 )list.push(item)
                            })
                            _this.select_list = list
                        }
                    }else{
                        mui.toast(res.msg)
                    }
                }
            });
        },
        confirm_select:function(){//确认选择
            var _this=this,listSend = {
                choose_list:_this.choose_list
            };
            if(_this.args.qryPage == 'db' || _this.args.qryPage == 'order_xiao' || _this.args.qryPage == 'order_cai'){
                listSend.type = _this.args.qryPage
                listSend.product_id = _this.args.product_id;
                listSend.item = _this.item_info;
                listSend.product_sn_list = _this.choose_list;
                if (_this.args.qryPageId) {
                    viewHandle.viewFire(_this.args.qryPageId, 'set_back',listSend);
                } else {
                    switch (_this.args.qryPage) {
                        case 'db':
                            viewHandle.viewFire('cun.html', 'set_back',listSend);
                            break;
                        case 'order_xiao':
                            viewHandle.viewFire('pinDraft.html', 'set_back',listSend);
                            break;
                        case 'order_cai':
                            viewHandle.viewFire('draft.html', 'set_back',listSend);
                            break;
                    }
                }
            }else{
                viewHandle.viewFire('sns_set.html', 'confirm_back',listSend);
            }
            viewHandle.back('close')
        }
    },
    created:function(){

    },
    mounted:function(){
        var _this = this;
        mui.plusReady(function(){ //ios
            var arg = plus.webview.currentWebview().arg;
            if(arg){
                arg = JSON.parse(arg);
                _this.item_info = arg.item;
                _this.args = arg.args
                if(_this.args.qryPage == 'db'){
                    _this.choose_list = _this.item_info.product_sn_list || []
                }
                $(".model").html(_this.args.model)
            }
            if(_this.args.qryPage== 'order_xiao' || _this.args.qryPage== 'order_cai'){
                var select_list = [];
                if(_this.args.qryPage== 'order_xiao'){
                    if(_this.item_info.ordertype == 0){
                        mui.each(_this.item_info.product_sn_list_old,function(i,v){
                            if(_this.item_info.product_sn_list_status[i] == 4){
                                select_list.push({
                                    product_sn:v
                                })
                            }
                        })
                    }else{
                        mui.each(_this.item_info.product_sn_list_old,function(i,v){
                            if(_this.item_info.product_sn_list_status[i] == 6){
                                select_list.push({
                                    product_sn:v
                                })
                            }
                        })
                    }
                }else{
                    if(_this.item_info.ordertype == 0){
                        mui.each(_this.item_info.product_sn_list_old,function(i,v){
                            if(_this.item_info.product_sn_list_status[i] == 0){
                                select_list.push({
                                    product_sn:v
                                })
                            }
                        })
                    }else{
                        mui.each(_this.item_info.product_sn_list_old,function(i,v){
                            if(_this.item_info.product_sn_list_status[i] == 2){
                                select_list.push({
                                    product_sn:v
                                })
                            }
                        })
                    }
                }
                _this.choose_list = _this.item_info.product_sn_list_vip;
                _this.select_list = select_list
            }else{
                _this.qryProductSNs()
            }
            mui('.mui-scroll-wrapper').scroll({
                deceleration: 0.0006
            });
        });
    }
});
mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
})