mui.init({});
mui.plusReady(function() {
	var arg = plus.webview.currentWebview().arg;
	if (arg) {
		arg = JSON.parse(arg);
		sns_info.product_sn = arg.product_sn ? arg.product_sn : arg.sn;
		if (!sns_info.product_sn) {
			mui.toast("请先设置序列号！！")
			setTimeout(function() {
				viewHandle.back('close')
			}, 1500)
			return
		} else {
			$("#snNum").html("序列号 " + sns_info.product_sn)
		}
	}
});

var sns_info = new Vue({
	el: '#sns_info',
	mixins: [jurisdictionMixin],
	data: {
		systemSetting: JSON.parse(localStorage.systemSetting),
		product_sn: '',
		product_sn_traking: [],

		//权限相关
		positionName: false,
		stockManager: false,
		purchaseManager: false,
		companySetIndustry: true,
		labelPprinter: false,
		faAccount: true,
		is_advanced: 0,
		company_name: '',
		company_id: '',
		user_id: '',
		jifenshow: false,
		bindDepot: -1,
		//--------------------
	},
	methods: {
		// 进价判定 item = 序列号详情 item
		isPurchasePrice(item){
			if(item.tracking_type === 0 && [0,1,2,3].indexOf(item.refer_type) !== -1){
				return true
			}else{
				return false
			}
		},
		getList: function() {
			var _this = this
			mui.ajax(severUrl + 'scm/productsn/qryProductSNTraking.json', {
				data: {
					product_sn: _this.product_sn
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 30000,
				success: function(res) {
					if (res.success) {
						_this.product_sn_traking = res.data || []
					} else {
						mui.toast(res.msg)
					}
				}
			});
		},
		format_type: function(type, item) {
			if (type == 'stock_status') {
				switch (item.stock_status) {
					case -1:
						return '未使用';
						break;
					case 0:
						return '待入库';
						break;
					case 1:
						return '在库';
						break;
					case 2:
						return '采购退货待出库';
						break;
					case 3:
						return '采购退货已出库';
						break;
					case 4:
						return '待出库';
						break;
					case 5:
						return '已出库';
						break;
					case 6:
						return '销售退货待入库';
						break;
					case 7:
						return '销售退货在库';
						break;
				}
			} else if (type == 'tracking_type') {
				switch (item.tracking_type) {
					case 0:
						return '开单';
						break;
					case 1:
						return '盘点';
						break;
					case 2:
						return '调出';
						break;
					case 3:
						return '调入';
						break;
					case 4:
						return '初始入库';
						break;
				}
			} else if (type == 'refer_type') {
				switch (item.refer_type) {
					case -1:
						return '未使用';
						break;
					case 0:
						return '待入库';
						break;
					case 1:
						return '在库';
						break;
					case 2:
						return '采购退货待出库';
						break;
					case 3:
						return '采购退货已出库';
						break;
					case 4:
						return '待出库';
						break;
					case 5:
						return '已出库';
						break;
					case 6:
						return '销售退货待入库';
						break;
					case 7:
						return '销售退货在库';
						break;
				}
			}
		},
		litsInfo: function(item) {
			let _this = this;
			if (item.tracking_type == 0) {

				var listSend = {};
				listSend.id = item.refer_id;
				listSend.type = 'auto';
				listSend.htmlType = 'sns_info';
				viewHandle.viewFire('customerDebets.html', 'customerDebets', listSend);
				viewHandle.openWindow('customerDebets.html', 'customerDebets.html', JSON.stringify(
					listSend));
			} else if (item.tracking_type == 2 || item.tracking_type == 3) {

				var listSend = {};
				listSend.alltDetail_id = item.refer_id;
				listSend.htmlType = 'sns_info';
				listSend.openType = 'show'
				viewHandle.viewFire('allocationXQ.html', 'allocationXQ', listSend);
				viewHandle.openWindow('allocationXQ.html', 'allocationXQ.html', JSON.stringify(listSend));
			} else if (item.tracking_type == 1) {

				var listSend = {};
				listSend.openType = 'show'
				listSend.histDetail_id = item.refer_id;
				listSend.htmlType = 'sns_info';
				viewHandle.viewFire('historyXQ.html', 'historyXQ', listSend);
				viewHandle.openWindow('historyXQ.html', 'historyXQ.html', JSON.stringify(listSend));
			}
		}
	},
	created: function() {

	},
	mounted: function() {
		var _this = this;
		mui.plusReady(function() {
			_this.getPurview()
			_this.getList()
		})
	}
});


mui('body').on('tap', '.muiBack', function() {
	viewHandle.back('close')
});
