var data = { //上拉加载参数
    num: 0,
    startY: '',
    moveEndY: '',
    isLoading: true,
    to_qry:false
};
var sns_list_vm = new Vue({
    el: "#sns_list_vm",
    data: {
		//全行业参数
		size_show: localStorage.getItem("size_show") || 1,
		color_show: localStorage.getItem("color_show") || 1 ,
		unit_show: localStorage.getItem("unit_show") || 0,
		origin_specification: localStorage.getItem("origin_specification") || 0,
		search_sn: '',
		choose_list: [],
		show_list: [],
		qry_page: 1,
		keyList: [] //打印参数
	},
	watch: {
		search_sn: function() {
			this.debounceSnsQry()
		}
	},
	computed: {
		stock_status: function() {
			var _this = this;
			return function(status) {
				switch (status) {
					case -1:
						return '未使用';
						break;
					case 0:
						return '待入库';
						break;
					case 1:
						return '在库';
						break;
					case 2:
						return '采购退货待出库';
						break;
					case 3:
						return '采购退货已出库';
						break;
					case 4:
						return '待出库';
						break;
					case 5:
						return '已出库';
						break;
					case 6:
						return '销售退货待入库';
						break;
					case 7:
						return '销售退货在库';
						break;
				}
			}
		}
	},
	methods: {
		snsQry: function() {
			this.qry_page = 1;
			this.get_sns_list()
		},
		select_all: function(e) { //全选
			var _this = this;
			if (e.target.checked) {
				var list = []
				mui.each(_this.show_list, function(i, v) {
					list.push(v)
				})
				_this.choose_list = list
			} else {
				_this.choose_list = []
			}
		},
		get_sns_list: function() {
			var _this = this;
			data.to_qry = false;
			mui.ajax(severUrl + 'scm/productsn/dataGrid.json', {
				data: {
					page: _this.qry_page,
					rows: 20,
					keyword: _this.search_sn,
					sort: 'create_date',
					sort_rule: 'desc',
					stock_status: -2,
					depot_id: ''
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 30000,
				success: function(res) {
					if (res.success) {
						var totalPage = res.data.totalPage;
						if (_this.qry_page == 1) {
							_this.show_list = [];
						}
						_this.show_list = _this.show_list.concat(res.data.list);
						mui(".mui-pull-caption")[0].style.display = "block";
						if (_this.qry_page < totalPage) {
							setTimeout(function() {
								data.isLoading = true;
								data.to_qry = true;
								$('.mui-pull-caption').text('上拉加载更多');
								_this.qry_page++;
							}, 1500)
						} else {
							data.isLoading = false;
							$('.mui-pull-caption').text('没有更多数据了')
						}
					} else {
						mui.toast(res.msg)
					}
				}
			});
		},
		sns_del: function() {
			var _this = this;
			if (_this.choose_list.length <= 0) {
				return mui.toast("请勾选需要删除的序列号")
			}
			mui.confirm('确定删除选中的序列号？', '提示', ["取消", "确定"], function(e) {
				if (e.index == 1) {
					var list = [];
					mui.each(_this.choose_list, function(i, v) {
						list.push(v.product_sn)
					})
					mui.ajax(severUrl + "scm/productsn/dels.json", {
						data: {
							product_sn: list,
							listlength: list.length
						},
						headers: {
							'Content-Type': 'application/x-www-form-urlencoded'
						},
						xhrFields: {
							withCredentials: true
						},
						dataType: 'json',
						type: 'post',
						success: function(res) {
							_this.snsQry()
							mui.toast(res.msg)
						}
					});
				}
			}, 'div')
			
		},
		sns_print: function() { //序列号打印
			var _this = this,
				qry_ids = [];
			if (_this.choose_list.length <= 0) {
				return mui.toast("请勾选需要打印的序列号！")
			}
			mui.ajax(severUrl + "sso/company/qry.json", {
				data: {
					id: ""
				},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 10000,
				success: function(res) {
					if (res.data.status != 1) {
						$comm.showLimitPrint({rootPath:'./'})
					} else {
						viewHandle.waiting("数据查询中...")
						mui.each(_this.choose_list, function(i, ch) {
							ch.otherAttrList = [];
							ch.pic_name = '';
							ch.pic_url = '';
							ch.keyList = _this.keyList;

							ch.barcode = ch.product_sn
							ch.id = ch.product_id
							ch.index = i
							ch.num = 1
							ch.origin_specification = _this.origin_specification
							ch.sale_price = ch.sale_price_a || 0
							ch.size = ch.size_name
							ch.color = ch.color_name

							qry_ids.push(ch.product_id)
						})
						qry_ids = _.uniq(qry_ids)
						let data = {product_ids: qry_ids.join(';')}
						$API.print.getProductOtherAttr(data).then(function(res){
							_this.choose_list.forEach(function(target){
								let attrs = res.data.find(function(_item){return target.product_id === _item.product_id})
								if(attrs){
									target.otherAttrList = [attrs]
								}
							})
							if(_this.parentPage != "cai_his_print"){
								return $API.print.getProductPicture(data)
							}else{
								_this.to_print()
							}
						}).then(function(res){
							_this.choose_list.forEach(function(target){
								let pic = res.data.find(function(_item){return target.product_id === _item.product_id})
								if(pic){
									target.pic_name = pic.name
									target.pic_url = img_url
								}
							})
							_this.to_print()
						}).catch(function(){
							viewHandle.close();
						})
					}
				}
			});
		},
		to_print(){
			viewHandle.close();
			if (mui.os.ios === true) {
				printCode_i(this.choose_list)
			} else if (mui.os.android === true) {
				printCode(this.choose_list)
			}
		},
		get_print_parameter: function() { //获取打印参数
			var _this = this;
			mui.ajax(severUrl + 'scm/productother/dataGrid.json', { //keyList
				// scm/productotherattr/qryOp.json otherAttrLiat
				data: {},
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				xhrFields: {
					withCredentials: true
				},
				dataType: 'json',
				type: 'post',
				timeout: 30000,
				success: function(res) {
					if (res.success) {
						_this.keyList = res.data.list;
					}
				}
			});
		},
		sweepCode:function(index,item) {
			var sendUrl = 'zhijianjxcapp://barcodescan/param?color_id=-1&size_id=-1';
			var cookie = 'ecp_cookie=' + localStorage.getItem("HF");
			if (mui.os.ios == true) {
				sweepCode_i(cookie, sendUrl, 777)
			} else if (mui.os.android == true) {
				sweepCode(cookie, sendUrl, 777)
			}
		},
		snInfo:function(listSend){
			var _this=this
			viewHandle.openWindow('sns_info.html','sns_info.html',JSON.stringify(listSend))
		}
	},
	created: function() {
		this.debounceSnsQry = _.debounce(this.snsQry, 180)
	},
	mounted: function() {
		var _this = this;
		mui.plusReady(function() { //ios
			_this.get_sns_list();
			_this.get_print_parameter();
			mui('.mui-scroll-wrapper').scroll({
				deceleration: 0.0006
			});
		});
	}
});
// 上拉加载
$(document).on('touchstart','#upFresh', function(e) {
    // e.preventDefault();
    data.startY = e.originalEvent.changedTouches[0].pageY;
});
$(document).on('touchmove', '#upFresh',function(e) {
    // e.preventDefault();
    data.moveEndY = e.originalEvent.changedTouches[0].pageY
    Y = data.startY - data.moveEndY;
    if(Y>80){
        upLoading()
    }
});
function upLoading(){
    var scroll = mui('#pullrefresh').scroll();
    var scrollTop = scroll.y;
    //判断滚动到底部之下
    if(scrollTop < scroll.maxScrollY){
        if(data.isLoading === false || data.to_qry == false){
            return false
        }else{
            $('.mui-pull-caption').text('玩命加载中...');
            //请求数据
            sns_list_vm.get_sns_list()
        }
    }
}

mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
});