var sns_set_vm = new Vue({
    el:"#sns_set_vm",
    data:{
		//全行业参数
		size_show: localStorage.getItem("size_show") || 1,
		color_show: localStorage.getItem("color_show") || 1 ,
		unit_show: localStorage.getItem("unit_show") || 0,
		origin_specification: localStorage.getItem("origin_specification") || 0,
        item_info:[],
        product_info:[],
        show_list:[],
        args:{
            //depot_id:xiaoVM.selectedDepot,
            //parentPage:'xiao'
        },
    },
    computed:{
        page_show:function(){
            var _this = this;
            switch (_this.args.parentPage) {
                case 'cai_order':
                case 'pd':
				case 'pd_order':
                case 'xiao_his':
                case 'cai_his':
                case 'goods':
				case 'goods_change':
                    return false; break;
                case 'cai':
                    if(_this.item_info.ordertype == 1){
                        return true
                    }else{
                        return false
                    }
                    break;
                default:
                    return true; break;
            }
        }
    },
    methods:{
        choose_all:function(event){ //全选
            var _this = this;
            if(event.target.checked){
                mui.each(_this.show_list,function(i,v){
                    if(!v.old){
                        v.check = true
                    }
                })
            }else{
                mui.each(_this.show_list,function(i,v){
                    if(!v.old) {
                        v.check = false
                    }
                })
            }
        },
        batch_del:function(){//删除
            var _this = this,has_old = false,his_list = [];
            mui.each(_this.show_list,function(i,v){
                if(v.old){
                    has_old = true
                }
                if(v.his_old && v.check){
                    his_list.push(v.sn)
                }
                if(v.check && !v.old && !v.his_old){
                    v.sn = ''
                }
            })
            if(his_list.length > 0){
                _this.his_del(his_list)
            }
            if(has_old){
				if(_this.args.parentPage=='goods_change'){
					mui.toast("初始库存已有序列号无法删除")
				}else{
					mui.toast("订单已有序列号无法删除")
				}  
            }
        },
        his_del:function(arr){
            var _this = this, ordertype = 1;
            if(_this.args.parentPage == 'cai_his'){
                ordertype = 0
            }
            mui.ajax(severUrl + 'scm/productsn/delOrderProductSNs.json', {
                data: {
                    product_sns: arr.toString(),
                    order_id: _this.item_info.id,
                    color_id: _this.item_info.color_id,
                    size_id: _this.item_info.size_id,
                    product_id:_this.item_info.product_id,
                    submit_status: 0, //0为订单，1为草稿
                    ordertype: ordertype,//0为进货，1为销售
                    op_id: _this.item_info.op_id||'',
                    type: _this.item_info.type //0为进货或销售，1为退货
                },
                headers : {
                    'Content-Type' : 'application/x-www-form-urlencoded'
                },
                xhrFields : {
                    withCredentials : true
                },
                dataType : 'json',
                type : 'post',
                timeout : 30000,
                success : function(res) {
                    mui.toast(res.msg)
                    if (res.success) {
                        mui.each(_this.show_list,function(i,v){
                            mui.each(arr,function(index,rem){
                                if(v.sn == rem){
                                    v.sn = '';
                                    v.his_old = false
                                }
                            })
                        })
                        if(_this.args.parentPage === 'xiao_his'){
                            viewHandle.viewFire('H576E5848', 'updateSN')
                        }
                        else if(_this.args.parentPage === 'cai_his'){
                            viewHandle.viewFire('caigou.html', 'updateSN')
                        }
                    }
                }
            });
        },
        his_save:function(){
            var _this = this, ordertype = 1;
            if(_this.args.parentPage == 'cai_his'){
                ordertype = 0
            };
            var arr = [];
            mui.each(_this.show_list,function(i,v){
                if(v.check && v.sn !=''){
                    arr.push(v.sn)
                }
            })
            mui.ajax(severUrl + 'scm/productsn/saveProductSNsToOrder.json', {
                data: {
                    product_sns: arr.toString(),
                    order_id: _this.item_info.id,
                    color_id: _this.item_info.color_id,
                    size_id: _this.item_info.size_id,
                    product_id:_this.item_info.product_id,
                    submit_status: 0, //0为订单，1为草稿
                    ordertype: ordertype,//0为进货，1为销售
                    type: _this.item_info.type, //0为进货或销售，1为退货
                    depot_id: _this.item_info.depot_id ,
                    amt: _this.item_info.amt,
                    customer_name: _this.item_info.customer_name,
					op_id: _this.item_info.op_id||'',
					checkIndex:-1
                },
                headers : {
                    'Content-Type' : 'application/x-www-form-urlencoded'
                },
                xhrFields : {
                    withCredentials : true
                },
                dataType : 'json',
                type : 'post',
                timeout : 30000,
                success : function(res) {
                    mui.toast(res.msg)
                    if(res.status === 222 || res.status === 200){ // 保存部分成功 / 成功
                        if(_this.args.parentPage === 'xiao_his'){
                            viewHandle.viewFire('H576E5848', 'updateSN')
                        }
                        else if(_this.args.parentPage === 'cai_his'){
                            viewHandle.viewFire('caigou.html', 'updateSN')
                        }
                    }
                    if(res.success){
                        _.delay(viewHandle.back('close'), 1000, 'later');
                    }
                }
            });
        },
        batch_sn:function(){ //批量按钮
            var _this = this,has_sn = false, has_old = false, has_his = false;
            var batch_list = _this.show_list.filter(function(v){
                if(v.check && v.sn !='' && !v.old && !v.his_old){
                    has_sn = true
                }
                if(v.old){
                    has_old = true
                }
                if(v.his_old){
                    has_his = true
                }
                return v.check && !v.old && !v.his_old
            })
            if(batch_list.length>0){
                if(has_sn){
                    var btn = ["取消","确定"];
                    mui.confirm('已有序列号将被覆盖是否继续？', '提示', btn, function (e) {
                        if (e.index == 1) {
                            _this.batch_sn_set()
                        }
                    },'div');
                }else{
                    _this.batch_sn_set()
                }
            }else{
                if(has_old){
					if(_this.args.parentPage=='goods_change'){
						mui.toast("初始库存已有序列号无法修改！")
					}else{
						 mui.toast("订单已有序列号无法修改！")
					} 
                }else if(has_his){
                    mui.toast("请先删除历史单据已有序列号")
                }else{
                    mui.toast("请至少勾选一个！")
                }
            }
        },
        batch_sn_set:function () { //批量写数据
            var _this= this,code = new Date().getTime(),count = -1,increment = 0,sns = [];;
            for(var i = 0 ;i<_this.show_list.length; i++){
                if(_this.show_list[i].check && !_this.show_list[i].old && !_this.show_list[i].his_old){
                    count++;
                    var rand = Math.floor(Math.random()*9+1);
                    _this.show_list[i].sn = code+''+count+''+rand;
                    if(count%10 == 9){
                        increment++;
                        code = code+increment
                    }
                }
            }
        },
        batch_ch:function(){ //选择
            var _this = this,has_sn = false,has_old = false;
            var batch_list = _this.show_list.filter(function(v){
                if(v.check && v.sn !='' && !v.old){
                    has_sn = true
                }
                if(v.old){
                    has_old = true
                }
                return v.check && !v.old
            });
            if(batch_list.length <=0){
                if(has_old){
                    return mui.toast("订单已有序列号无法修改！")
                }else{
                    return mui.toast("请至少勾选一个！")
                }
            }
            if(has_sn){
                var btn = ["取消","确定"];
                mui.confirm('勾选中已有序列号将被清除是否继续？', '提示', btn, function (e) {
                    if (e.index == 1) {
                        mui.each(_this.show_list,function(i,v){
                            if(v.check){
                                v.sn = ''
                            }
                        })
                        to_choose()
                    }
                },'div');
            }else{
                to_choose()
            }
            function to_choose(){
                var listSend = {
                    item:_this.item_info,
                    args:{
                        can_choose:batch_list.length,
                        product_id:_this.product_info.id,
                        depot_id:_this.args.depot_id,
                        model:_this.product_info.model,
                        name:_this.product_info.name,
                        qryPage:_this.args.parentPage,
                        // product_sn_list_not 相同的其它单品被选中的sn
                        product_sn_list_not: _this.args.product_sn_list_not,
                    }
                };
                viewHandle.openWindow("sns_choose.html","sns_choose.html",JSON.stringify(listSend))
            }
        },
        sns_set:function () {//确认按钮
            var _this = this;
            var sns_list = [],send_list = {};
            mui.each(_this.show_list,function(i,v){
                if(v.sn !=''){
                    sns_list.push(v.sn)
                }
            })
            let duplicateSN = this.snCheckDuplicate(sns_list)
            if(duplicateSN){
                mui.toast('序列号' + duplicateSN + '重复')
                return
            }
            send_list.product_id = _this.product_info.id;
            send_list.item = _this.item_info;
            send_list.product_sn_list = sns_list
            switch (_this.args.parentPage) {
                case 'xiao':
                    viewHandle.viewFire('H576E5848','set_back',send_list)
                    break;
                case 'cai':
                    viewHandle.viewFire('caigou.html','set_back',send_list)
                    break;
                case 'cai_order':
                    viewHandle.viewFire('draft.html','set_back',send_list)
                    break;
                case 'xiao_order':
                    viewHandle.viewFire('pinDraft.html','set_back',send_list)
                    break;
                case 'pd':
                    send_list.type = 'pd';
					var list=[]
					mui.each(_this.show_list,function(i,v){
					    if(v.check&&v.sn !=''){
					        list.push(v.sn)
					    }
					})
					send_list.product_sn_list=list
                    viewHandle.viewFire('cun.html', 'set_back',send_list);
                    break;
				case 'pd_order':
					send_list.type = 'pd_order';
					var list=[]
					mui.each(_this.show_list,function(i,v){
						if(v.check&&v.sn !=''){
							list.push(v.sn)
						}
					})
					send_list.product_sn_list=list
					viewHandle.viewFire('panDraft.html', 'set_back',send_list);
					break;
                case 'xiao_his':
                case 'cai_his':
                    _this.his_save()
                    break;
                case 'goods':
                    viewHandle.viewFire('initialInventory.html', 'set_back',send_list);
                    break;
				case 'goods_change':
					viewHandle.viewFire('initialInventory.html', 'set_change_back',send_list);
					break;
            }
            viewHandle.back('close')
        },
        tap_show:function(sn){//点击提示
            var _this = this;
            if((_this.args.parentPage == 'xiao_his' || _this.args.parentPage == 'cai_his') && sn != ''){
                mui.toast("已有序列号，请先删除！")
            }
        },
		sweepCode:function(index,item) {
			if(item.old ||item.his_old){
				return;
			}
			var sendUrl = 'zhijianjxcapp://barcodescan/param?color_id=-1&size_id=-1';
			var cookie = 'ecp_cookie=' + localStorage.getItem("HF");
			this.checkIndex=index
			if (mui.os.ios == true) {
				sweepCode_i(cookie, sendUrl, 777)
			} else if (mui.os.android == true) {
				sweepCode(cookie, sendUrl, 777)
			}
		},
        qryProductSNsByOrder:function(){ //历史查询
            var _this = this;
            mui.ajax(severUrl + 'scm/productsn/qryProductSNsByOrder.json', {
                data: {
                    product_id: _this.item_info.product_id,
                    order_id:_this.item_info.id,
                    color_id: _this.item_info.color_id,
                    size_id: _this.item_info.size_id,
                    type:_this.item_info.type,
                    op_id: _this.item_info.op_id // 单品id
                },
                headers : {
                    'Content-Type' : 'application/x-www-form-urlencoded'
                },
                xhrFields : {
                    withCredentials : true
                },
                dataType : 'json',
                type : 'post',
                timeout : 30000,
                success : function(res) {
                    if (res.success) {
                        var sn_list = []
                        mui.each(res.data,function(i,v){
                            sn_list.push({
                                sn:v.product_sn,
                                check:true,
                                old:false,
                                his_old:true
                            })
                        })
                        _this.show_list = sn_list;
                        var add = parseInt(_this.item_info.amount) - Number(_this.show_list.length);
                        for(var i = 0; i< add; i++){
                            _this.show_list.push({
                                sn:'',
                                check:false,
                                old:false,
                                his_old:false
                            })
                        }
                    }else{
                        mui.toast(res.msg)
                    }
                }
            });
        },
		snInfo:function(listSend){
			var _this=this
			if(_this.args.parentPage=='xiao'){
				viewHandle.openWindow('sns_info.html','sns_info.html',JSON.stringify(listSend))
			}
		},
        /**
         * 序列号列表查重 返回重复的序列号
         * @param snList
         * @return {*}
         */
        snCheckDuplicate(snList){
            if(Array.isArray(snList) && snList.length > 0){
                let list = JSON.parse(JSON.stringify(snList))
                while (list.length !== 0){
                    let item = list.pop()
                    if(list.indexOf(item) >= 0 ){
                        return item
                    }
                }
            }
        }
    },
    created:function(){
        window.addEventListener("confirm_back",function(e){ //选择返回
            var choose_list = e.detail.choose_list,count = 0;
            if(choose_list.length > 0){
                mui.each(sns_set_vm.show_list,function(i,v){
                    if(v.check && !v.old){
                        v.sn = choose_list[count];
                        count++
                    }
                    if(count == choose_list.length){
                        return false
                    }
                })
            }
        });
    },
    mounted:function(){
        var _this = this;
        mui.plusReady(function(){ //ios
            var arg = plus.webview.currentWebview().arg;
            if(arg){
                arg = JSON.parse(arg);
                _this.item_info = arg.item;
                _this.product_info = arg.product;
                _this.args = arg.args;
				if(_this.args.parentPage=='goods_change'){
					mui.each(_this.item_info.product_sn_list,function(i,v){
					    _this.show_list.push({
					        sn:v,
					        check:true,
					        his_old:false,
							old:true
					    })
					});
					let notSaveSnsList = arg.notSaveSnsList || []
                    notSaveSnsList.forEach(function(item){
                        _this.show_list.push({
                            sn: item,
                            check:false,
                            his_old:false,
                            old:false
                        })
                    })
					var add = parseInt(_this.item_info.init_stock) - Number(_this.show_list.length) - notSaveSnsList.length;
					for(var i = 0; i< add; i++){
					    _this.show_list.push({
					        sn:'',
					        check:false,
					        his_old:false,
					        old:false
					    })
					}
					
					$(".model").html(_this.product_info.model)
					mui('.mui-scroll-wrapper').scroll({
					    deceleration: 0.0006
					});
					return
				}
                if(_this.args.parentPage == 'xiao_his' || _this.args.parentPage == 'cai_his'){
                    _this.qryProductSNsByOrder()
                    _this.product_info = {
                        model: _this.item_info.product_model,
                        name: _this.item_info.product_name
                    }
                }else{
                    if(_this.item_info.product_sn_list && _this.item_info.product_sn_list.length > 0){
                        var sn_list = [];
                        mui.each(_this.item_info.product_sn_list,function(i,v){
                            sn_list.push({
                                sn:v,
                                check:true,
                                his_old:false
                            })
                        });
                        if(_this.args.parentPage == 'xiao_order' || _this.args.parentPage == 'cai_order'){
                            mui.each(sn_list,function(i,v){
                                mui.each(_this.item_info.product_sn_list_old,function(j,k){
                                    if(v.sn == k){
                                        return v.old = true
                                    }
                                })
                            })
                        }
                        _this.show_list = sn_list;
                    }
                    if(~['pd','pd_order'].indexOf(_this.args.parentPage)){
                        var old = _.difference(_this.item_info.product_sn_list_old,_this.item_info.product_sn_list);
                        mui.each(old,function(i,v){
                            _this.show_list.push({
                                sn:v,
                                check:false,
                                his_old:false
                            })

                        });
                    }
                    var add = parseInt(_this.item_info.count || _this.item_info.inventoryTotal) - Number(_this.show_list.length);
                    for(var i = 0; i< add; i++){
                        _this.show_list.push({
                            sn:'',
                            check:false,
                            his_old:false,
                            old:false
                        })
                    }
                }
                $(".model").html(_this.product_info.model)
            }
            mui('.mui-scroll-wrapper').scroll({
                deceleration: 0.0006
            });
        });
    }
});
mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
})