mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
});
// 仓库选择弹窗
const Picker = new mui.PopPicker()
// 用户配置
const systemSetting = JSON.parse(localStorage.systemSetting)
/**
 * 创建一个防抖函数
 * @param fn 异步执行函数
 * @param minInterval 最小执行间隔
 * @return {(function(): void)|*} // 防抖函数
 */
const createAntiShake = function(fn, minInterval) {
    minInterval = minInterval || 500
    let timer
    return function () {
        clearTimeout(timer)
        timer = setTimeout(fn, minInterval)
    }
}
const VM = new Vue({
    el: '#VM',
    data: {
        companyId: localStorage.getItem('company_id'),
        searchText: undefined,
        // 当前查询上下限的类型 0 min 1 max 2 center
        queryLimitType: 0,
        // 下限
        limitMin:{
            pageSize: 20,
            pageCode: 1,
            // 总页数
            pageLength: undefined,
            // 低于下限合计
            allLimitListLength: undefined,
            // 请求 page 中
            loading: false,
            // 数据列表
            list: [],
            // 加载文本
            loadingText:'',
            // 开单选择id列表 key id value 选择框的状态
            checkboxCache: {},
            filter: {
                // 当前选择的字段
                depotId: '-1',
                categoryId: '-1',
                childCategoryId: '-1',
                categoryLevel: undefined,
                // 渲染数据
                depotList: [],
                categoryParentList: [],
                categoryChildList: [],
            },
        },
        // 上限
        limitMax:{
            pageSize: 20,
            pageCode: 1,
            // 总页数
            pageLength: undefined,
            // 低于上限合计
            allLimitListLength: undefined,
            // 请求 page 中
            loading: false,
            // 数据列表
            list: [],
            loadingText:'',
            filter: {
                // 当前选择的字段
                depotId: '-1',
                categoryId: '-1',
                childCategoryId: '-1',
                categoryLevel: undefined,
                // 渲染数据
                depotList: [],
                categoryParentList: [],
                categoryChildList: [],
            },
        },
        show: {
            // 控制筛选显示
            filter: false,
            // 控制遮罩显示
            mask: false,
            // 控制多选框状态
            checkbox: false,
            // 仓库折叠
            depotFold: false,
            // 最外层分类折叠
            categoryFold: false,
            // 跳转采购开单页面按钮
            goPurchasePageButton: false,
        },
        loading: {
            getProductsInfo: false,
        },
        bindDepot: localStorage.getItem('bindDepot')

    },
    computed:{
        /**
         * 下一页加载下限限制
         * @return {boolean} false禁止加载 | true 可以加载
         */
        isMinPageNext() {
            return this.limitMin.pageLength > this.limitMin.pageCode && !this.limitMin.loading
        },
        /**
         * 下一页加载上限限限制
         * @return {boolean} false禁止加载 | true 可以加载
         */
        isMaxPageNext() {
            return this.limitMax.pageLength > this.limitMax.pageCode && !this.limitMax.loading
        },
        /**
         * 当前状态下的limit
         */
        limit() {
            let limit
            if (this.queryLimitType === 0) {
                limit = this.limitMin
            } else if (this.queryLimitType === 1) {
                limit = this.limitMax
            }
            return limit
        },
        // 筛选按钮状态
        isFilter(){
                return (this.limit.filter.depotId !== '-1' && this.bindDepot === '-1') || this.limit.filter.categoryId !== '-1' || this.limit.filter.childCategoryId !== '-1'
        }
    },
    methods: {
        /**
         * 初始化列表
         * @param queryLimitType 初始化那个列表 0 min 1 max *2 center
         */
        initPage(queryLimitType) {
            let limit = this.getTargetLimit(queryLimitType)
            limit.pageCode = 1
            limit.list = []
            if(queryLimitType !== 0){
                queryLimitType = queryLimitType ? queryLimitType : this.queryLimitType
            }
            let stock_warn_type = queryLimitType
            // this.searchText = undefined
            this.queryPageList(stock_warn_type,'init')
        },
        /**
         * 请求页面 失败时会自动重新加载 最多10次
         * @param stock_warn_type 请求哪一个列表页面 0 min 1 max *2 center
         * @param type init时 不判断当前的加载状态 nextPage 增加页码
         */
        queryPageList(stock_warn_type, type) {
            let retryCount = 0
            // 防抖
            let limit = this.getTargetLimit(stock_warn_type)
            if(type !== 'init'){
                let isPageNext = limit === this.limitMin ? this.isMinPageNext : this.isMaxPageNext
                if(!isPageNext){
                    if(limit.loading){
                        // mui.toast('正在加载中！')
                        return
                    }else{
                        limit.loadingText = '已全部加载'
                        mui.toast('已全部加载！')
                        return
                    }
                }
            }
            if(limit.loading)return
            limit.loading = true
            limit.loadingText = '加载中...'
            if(type === 'nextPage')limit.pageCode++
            let data = {
                company_id: this.companyId,
                status: 1, // 默认：2查询所有商平；1：查询非禁用商品；2：禁用商品
                keyword: this.searchText || '',
                stock_warn_type: stock_warn_type, // 0 min 1 max 2 center
                depot_id: limit.filter.depotId === '-1' ? '' : limit.filter.depotId,
                category: getCategory(),
                category_level: limit.filter.categoryLevel || '',
                rows: limit.pageSize,
                page: limit.pageCode,
                sort: limit === this.limitMin ? 'stock_warn_min' : 'stock_warn_max' ,
                sort_rule: 'desc'
            }
            function getCategory(){
                // 判断子类id 没有被选择 使用父类id
                return limit.filter.childCategoryId === '-1' ? (limit.filter.categoryId === '-1' ? '' : limit.filter.categoryId) : limit.filter.childCategoryId
            }
            getPage()
            // 请求
            function getPage(){
                retryCount++
                mui.ajax(severUrl + "scm/stock/stockWarnDataGrid.json", {
                    data,
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    xhrFields: {
                        withCredentials: true
                    },
                    dataType: 'json',
                    type: 'post',
                    timeout: 10000,
                    success: function(res) {
                        if (res.status === 200) {
                            // console.log(res)
                            limit.pageLength = res.data.totalPage
                            limit.allLimitListLength = res.data.totalRow
                            if(res.data.totalPage === 0){
                                limit.loadingText = '已全部加载'
                                // mui.toast('已全部加载！')
                            }
                            else if(res.data.totalPage === res.data.pageNumber){
                                limit.loadingText = '已全部加载'
                                mui.toast('已全部加载！')
                            }else{
                                limit.loadingText = ''
                            }
                            res.data.list.map(function (item) {
                                limit.list.push(item)
                            })
                            // mui.toast(res.msg)

                        }else {
                            mui.toast(res.msg)
                        }
                    },
                    error: function (err) {
                        if(retryCount <= 10){
                            getPage()
                        } else {
                            mui.toast('加载失败！')
                            if(limit.pageCode){
                                limit.pageCode--
                            }
                        }
                    },
                    complete: function (){
                        limit.loading = false
                    }
                });
            }

        },
        /**
         * 初始化筛选
         * @param {0|1|undefined} type 0 下限 1上限 undefined 全部
         */
        initFilter(type) {
            let limit
            if(type === 0){
                limit = this.limitMin
            }else if(type === 1){
                limit = this.limitMax
            }else{
                this.limitMin.filter.depotId = '-1'
                this.limitMin.filter.categoryId = '-1'
                this.limitMin.filter.categoryLevel = undefined
                limit = this.limitMax
            }
            limit.filter.depotId = '-1'
            limit.filter.categoryId = '-1'
            limit.filter.categoryLevel = undefined
            // 员工绑定了仓库
            if(this.bindDepot !== '-1'){
                this.limitMin.filter.depotId = this.bindDepot
                this.limitMax.filter.depotId = this.bindDepot
            }
        },
        /**
         * 加载下一页 已包含防抖
         * @param queryLimitType 请求哪一个列表页面 0 min 1 max *2 center
         */
        nextPage(queryLimitType) {
            if(queryLimitType !== 0){
                queryLimitType = queryLimitType ? queryLimitType : this.queryLimitType
            }
            let stock_warn_type = queryLimitType
            if(queryLimitType === 0){
                // this.limitMin.pageCode ++
                if(!this.isMinPageNext) return
            }else if(queryLimitType === 1){
                // this.limitMax.pageCode ++
                if(!this.isMaxPageNext) return
            }
            this.queryPageList(stock_warn_type, 'nextPage')
        },
        /**
         * 触摸过滤按钮
         */
        tapFilter() {
            getLevelOneCategory(this)
            this.show.filter = true
            this.show.mask = true
        },
        /**
         * 触摸mask
         */
        tapMask() {
            this.show.filter = false
            this.show.mask = false
        },
        /**
         * 选择指定仓库
         * @param event
         */
        tapFilterDepot(event) {
            this.limit.filter.depotId = event.currentTarget.dataset.select_depot
        },
        /**
         * 触摸一级分类展开二级分类 选择一级分类
         * @param ParentId 要展开的父级id
         */
        tapCategoryOpenFoldId(ParentId){
            this.limit.filter.childCategoryId = '-1'
            this.limit.filter.categoryLevel = 1
            // 屏蔽重复选择更新子分类列表
            if(this.limit.filter.categoryId === ParentId){
                return
            }
            this.limit.filter.categoryId = ParentId
            this.limit.filter.categoryChildList = []
            ParentId !== '-1' && getLevelTwoCategory(this, ParentId)
        },
        /**
         * 选择二级分类
         * @param event
         */
        tapFilterChildCategory(event) {
            this.limit.filter.categoryLevel = event.currentTarget.dataset.cun_category_id === '-1' ? 1 : 2
            this.limit.filter.childCategoryId = event.currentTarget.dataset.cun_category_id
        },
        /**
         * 重置筛选
         */
        tapFilterReset() {
            this.limit.filter.depotId = '-1'
            this.limit.filter.categoryId = '-1'
            this.limit.filter.childCategoryId = '-1'
            this.limit.filter.categoryLevel = undefined
            this.show.depotFold = false
            this.show.categoryFold = false
            this.show.checkbox && this.changeListCheckboxStatus('close')
            this.tapFilterEnter()
        },
        /**
         * 确定筛选
         */
        tapFilterEnter() {
            if (this.limit.filter.depotId === '-1'){
                this.changeListCheckboxStatus('close')
            }else if (this.show.checkbox) {
                for (const checkboxCacheKey in this.limitMin.checkboxCache) {
                    this.limitMin.checkboxCache[checkboxCacheKey] = false
                }
            }
            this.tapMask()
            this.initPage()
        },
        /**
         * 获得当前状态下的Limit 如果不需要指定 可以使用 this.limit 计算属性
         * @param {0|1|undefined} type 0 下限 1上限 可选参数
         * @return {limitMin|limitMax}
         */
        getTargetLimit(type){
            if(type !== 0){
                type = type || this.queryLimitType
            }
            let limit
            if (type === 0) {
                limit = this.limitMin
            } else if (type === 1) {
                limit = this.limitMax
            }
            return limit
        },
        /**
         * scroll 事件函数 还剩下小于 50 高度时 加载下一页
         * @param typeKey 选择滚动的元素 scroll键 类型
         */
        scrollUpLoading(typeKey){
            const scroll =this.scroll[typeKey]
            // 还剩下 50 高度时 自动加载下一页
            if (scroll.y - scroll.maxScrollY < 80 ) {
                // console.log('触发加载下一页')
                this.nextPage()
            }
        },
        /**
         * 点击生成进货单 -> 判断当前指定仓库筛选 -> 是 展开选择框 | 否 弹窗选择仓库 -> 确定选择 更新列表 展开选择框
         */
        clickSelectList() {
            if (this.limitMin.filter.depotId !== '-1') {
                // 已经筛选了仓库
                this.changeListCheckboxStatus('open')
            } else {
                // 弹出指定仓库
                const _this = this
                getAllDepot(this, undefined ,function (depotList) {
                    const PickerDataList = []
                    for (const depotListKey in depotList) {
                        PickerDataList.push({value: depotList[depotListKey].id, text: depotList[depotListKey].name})
                    }
                    Picker.setData(PickerDataList)
                    Picker.show( _this.selectPickerDepot )
                })
            }
        },
        /**
         * 选择弹窗中的仓库对象 处理它
         * @param PickerSelectValueList 对象 {value: depot_id, text: depot_name}
         */
        selectPickerDepot(PickerSelectValueList) {
            this.limitMin.filter.depotId = PickerSelectValueList[0].value
            this.tapFilterEnter()
            this.clickSelectList()
        },
        /**
         * 切换选中元素显示状态 -> 展开选择框后 -> 显示去采购按钮 （进货单变取消 不刷新数据 清空选择框数据）
         * @param type close|open|undefined undefined取反
         */
        changeListCheckboxStatus(type) {
            const _this = this
            type === 'close' && close()
            type === 'open' && open()
            if(!type){
                if (this.show.checkbox) {
                    close()
                } else {
                    open()
                }
            }
            function open() {
                _this.show.checkbox = true
                _this.show.goPurchasePageButton = true
            }
            function close() {
                _this.show.checkbox = false
                for (const checkboxCacheKey in _this.limitMin.checkboxCache) {
                    _this.limitMin.checkboxCache[checkboxCacheKey] = false
                }
                _this.show.goPurchasePageButton = false
            }
        },
        /**
         * 点击 去采购 请求商品数据
         */
        clickGoPurchase() {
            const depot_id = this.limitMin.filter.depotId
            const product_id_list = []
            for (const checkboxCacheKey in this.limitMin.checkboxCache) {
                this.limitMin.checkboxCache[checkboxCacheKey] && product_id_list.push(checkboxCacheKey)
            }
            this.getProductsInfo(depot_id, product_id_list, this.formDataProductsInfo)
        },
        /**
         * 获取商品数据
         * @param depot_id 必须指定仓库
         * @param product_id_list 商品id数组
         * @param cbFn 成功回调 形参返回的res
         */
        getProductsInfo(depot_id, product_id_list, cbFn) {
            if ( this.loading.getProductsInfo ) return
            // const data = {}
            this.loading.getProductsInfo = true
            let product_ids = product_id_list.join(';')
            const _this = this
            mui.ajax({
                url: severUrl + "scm/product/qyrLessStockWarnByIds.json" + '?depot_id=' + depot_id + '&product_ids=' + product_ids,
                // data,
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                xhrFields: {
                    withCredentials: true
                },
                dataType: 'json',
                type: 'get',
                timeout: 10000,
                success: function(res) {
                    if (res.status === 200) {
                        // console.log(res)
                        cbFn && cbFn(res.data||[])
                    }else {
                        mui.toast(res.msg)
                    }
                },
                error: function (err) {
                        mui.toast('获取数据失败,请稍后重试！')
                },
                complete: function (){
                    _this.loading.getProductsInfo = false
                }
            })
        },
        /**
         * 数据组装 内部组装完成后调用了跳转采购页
         * @param {Array} ProductsInfo 获取到的商品数据 数组
         */
        formDataProductsInfo(ProductsInfo) {
            // 预加载采购页面
            JumpPage.preloading('caigou.html','caigou.html')
            // console.log(ProductsInfo)
            // 通过商品id 查询所有商品所有单品 中低于下限的所有单品 count 低于下限商品数量
            const selProductList = []
            // 商品id : [所有该商品索引]
            // 变量商品id 将索引数据加入该单品list
            const productIdCache = {}
            ProductsInfo.map(function (item, index) {
                if(productIdCache[item.product_id]){
                    productIdCache[item.product_id].push(index)
                }else{
                    productIdCache[item.product_id] = [index]
                }
            })
            // productIdCacheKey 商品id
            for (const productIdCacheKey in productIdCache) {
                // 拿到本商品的第一个单品
                const currOneSingleProduct = ProductsInfo[productIdCache[productIdCacheKey][0]]
                const currProduct = {
                    type: CONSTANT.PURCHASE,
                    amt: currOneSingleProduct.purchase_price, // 采购价
                    depot_id: currOneSingleProduct.depot_id,
                    id: productIdCacheKey,
                    list: [],
                    model: currOneSingleProduct.model,
                    name: currOneSingleProduct.product_name,
                    product_id: currOneSingleProduct.product_id,
                    product_name: currOneSingleProduct.product_name,
                    purchase_price: currOneSingleProduct.purchase_price,
                    sale_price: currOneSingleProduct.sale_price,
                    status: currOneSingleProduct.status, // 禁用状态
                    unitChooseId: currOneSingleProduct.unitchooseid,
                    unitChooseName: currOneSingleProduct.unitchoosename,
                    unitChooseRatio: currOneSingleProduct.unitchooseratio,
                }
                selProductList.push(currProduct)
                productIdCache[productIdCacheKey].map(function(ProductsInfoIndex) {
                    const currSingleProduct = ProductsInfo[ProductsInfoIndex]
                    currProduct.list.push({
                        amount: 0,
                        barcode: "",
                        color_id: currSingleProduct.color_id,
                        color_name: currSingleProduct.color_name,
                        count: currSingleProduct.stock_warn_min - currSingleProduct.amount,
                        depot_id: currSingleProduct.depot_id,
                        ordertype: CONSTANT.PURCHASE, // 写死 采购0 采购退货 1
                        product_id: currSingleProduct.product_id,
                        size_id: currSingleProduct.size_id,
                        size_name: currSingleProduct.size_name,
                        type: CONSTANT.PURCHASE,
                        __id__: productListIdUtil.getNext()
                    })
                })
            }
            this.jumpPurchase(selProductList, selProductList[0].depot_id)
        },
        /**
         * copy->采购列表 跳转后关闭当前页面
         * @param selProductList 组装好的数据
         * @param depot_id 采购页使用那个库房的库房id
         */
        jumpPurchase(selProductList, depot_id) {
            // 此处使用的将数据转变成销售单据的复制 传递给采购页
            var data = {name: 'copyProductListByStockWranList', result: { selProductList, depot_id }}
            JumpPage.jump('caigou.html','caigou.html',function(){
                viewHandle.viewFire('caigou.html', data.name, data.result)
                plus.webview.close('stockWarnList')
            },'none')
        },
        /**
         * 点击列表进入商品预警详情
         * @param type min|max 详情页显示类型
         * @param productId 商品id
         * @param model 商品货号
         * @param name 商品名称
         */
        tapProductListItem(type, productId, model, name) {
            const depotList = this.limit.filter.depotList
            const depotId = this.limit.filter.depotId
            const data = {name: 'stockWarnProductInfoResult', result: { productId, type, depotList, model, name, depotId }}
            JumpPage.jump('stockWarnProductInfo.html','stockWarnProductInfo',function(){
                viewHandle.viewFire('stockWarnProductInfo', data.name, data.result)
            })
        },
        /**
         *  搜索货号/商品名称
         */
        inputSearchText: createAntiShake(function (){
            VM.initPage()
        }, 500)
    },
    created () {
        this.initFilter(undefined)
    },
    mounted () {
        // 区域滚动
        mui('.mui-scroll-wrapper').scroll({
            deceleration: 0.0005 //flick 减速系数，系数越大，滚动速度越慢，滚动距离越小，默认值0.0006
        });
        const scroll = mui('.mui-scroll-wrapper').scroll();
        this.scroll = {
            min: scroll[0],
            max: scroll[1]
        }
        bindEventListener(this)
        const _this = this
        mui.plusReady(function(){
            getAllDepot(_this)
            _this.initPage()
        })
    }
})

function bindEventListener(VM){
    // 列表更新
    mui(".mui-slider")[0].addEventListener('slide', function(e) {
        VM.queryLimitType = e.detail.slideNumber
        // VM.$set(VM, 'queryLimitType', e.detail.slideNumber)
        // 首次更新上限列表
        if(e.detail.slideNumber === 1){
            if(!VM.limitMax.list.length){
                VM.limitMax.loadingText = '加载中...'
                VM.initPage(1)
            }
        }
    });
}

/**
 * 获得所有仓库 优先在storage缓存中获得
 * @param VM VM
 * @param notAsync true 同步获取
 * @param cbFn 成功回调函数 实参仓库数据
 */
function getAllDepot(VM, notAsync, cbFn){
    const storageData = sessionStorage.getItem("depotList")
    if(storageData) {
        const depotList = JSON.parse(storageData)
        VM.limitMin.filter.depotList = depotList
        VM.limitMax.filter.depotList = depotList
        cbFn && cbFn(depotList)
        return
    }
    mui.ajax(severUrl + "scm/depot/list.json", {
        data: {},
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded'
        },
        async: !notAsync, // 需要仓库信息时可以传true 同步获取
        xhrFields: {
            withCredentials: true
        },
        dataType: 'json',
        type: 'post',
        timeout: 10000,
        success: function(res) {
            if (res) {
                if (res.success) {
                    sessionStorage.setItem("depotList", JSON.stringify(res.data))
                    VM.limitMin.filter.depotList = res.data /*depotList仓库列表*/
                    VM.limitMax.filter.depotList = res.data
                    cbFn && cbFn(res.data)
                } else if (res.status == 10101 || res.status == 10102) { // 登录失效
                    logOut(res.msg)
                }
            }
        }
    });
}

/**
 * 获得一级分类
 * @param VM 获得数据后数据的存储目标
 */
function getLevelOneCategory(VM) {
    mui.ajax(severUrl + "scm/productcategory/qryAllLevelOneCategory.json", {
        data: {},
        type: 'POST',
        timeout: 10000, //超时时间设置为10秒；
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded'
        },
        xhrFields: {
            withCredentials: true
        },
        success: function(res) {
            if (res.success) {
                VM.limit.filter.categoryParentList = res.data;
            }
        }
    });
}

/**
 * 获得二级分类
 * @param VM 获得数据后数据的存储目标
 * @param categoryParentId 一级分类id
 */
function getLevelTwoCategory(VM, categoryParentId) {
    mui.ajax(severUrl + "scm/productcategory/qryAllLevelTwoCategory.json", {
        data: {
            parent_id: categoryParentId
        },
        type: 'POST',
        timeout: 10000, //超时时间设置为10秒；
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded'
        },
        xhrFields: {
            withCredentials: true
        },
        success: function(res) {
            if (res.success) {
                VM.limit.filter.categoryChildList = res.data;
            }
        }
    })
}
