mui('body').on('tap','.muiBack',function(){
    viewHandle.back('close')
});
let RES
const systemSetting = JSON.parse(localStorage.systemSetting)
window.addEventListener('stockWarnProductInfoResult', function(event) {
    RES = event.detail
    console.log(RES)
})
mui.plusReady(function() {
    getRES()
    function getRES(){
        if(RES){
            VM.type = RES.type
            VM.productId = RES.productId
            if(RES.type === 'min') {
                VM.typeText = '下限'
                VM.stockWranText = '低于下限'
            } else if (RES.type === 'max'){
                VM.typeText = '上限'
                VM.stockWranText = '高于上限'
            }
            getProductStockWranInfo(RES.productId, RES.depotId, function(res){
                VM.renderData = formDataShow(res.data, RES.type)
            })
            VM.$mount('#VM')
        }else{
            setTimeout(getRES,20)
        }
    }
})
const VM = new Vue({
    // el: '#VM',
    data: {
        type: undefined,
        productId: undefined, // 商品id
        typeText: undefined,
        stockWranText: undefined,
        // 列表渲染数据
        renderData: [],
        // size 显示控制 size_show === '1' 尺码
        size_show: localStorage.getItem("size_show") || 1,
        // color 显示控制 color_show === '1' 显示
        color_show: localStorage.getItem("color_show") || 1,
        // 单位显示控制
        unit_show: localStorage.getItem("unit_show") || 0,
        // 原产地显示控制 {0，1... 字符串} origin_specification === '3' 产地 else 规格  优先显示 size_show
        origin_specification: localStorage.getItem("origin_specification") || 0,
    },
    created(){
        if(this.size_show === '1'){
            DefaultSizeText = '尺码'
        }else if(this.origin_specification === '3'){
            DefaultSizeText = '产地'
        }else if(this.origin_specification > 0){
            DefaultSizeText = '规格'
        }else{
            // DefaultSizeText = undefined // 用来不显示 size 栏
            DefaultSizeText = '规格'
        }
    }
})

/**
 * 获取商品预警详情
 * @param {string} product_id
 * @param {string} depot_id '-1' 所有仓库
 * @param {function} cbFn 回调函数 实参返回的数据
 */
function getProductStockWranInfo(product_id,depot_id ,cbFn) {
    let retryCount = 0
    let depotParams = ''
    if(depot_id !== '-1'){
        depotParams = '&depot_id=' + depot_id
    }
    getInfo()
    function getInfo() {
        retryCount++
        mui.ajax({
            url: severUrl + 'scm/stock/qryStockWarnOp?product_id=' + product_id + depotParams,
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
            },
            xhrFields: {
                withCredentials: true
            },
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(res) {
                if (res.status === 200) {
                    cbFn && cbFn(res)
                    // mui.toast(res.msg)
                }else {
                    mui.toast(res.msg)
                }
            },
            error: function (err) {
                if(retryCount <= 10){
                    getInfo()
                } else {
                    mui.toast('加载失败！')
                }
            }
        })
    }
}

/**
 * 返回VM渲染的列表数据
 * @param resData 请求的结果
 * @param type 当前的页面查询类型 min max
 * @return {*[]}
 */
function formDataShow(resData, type){
    let res = []
    if (resData) {
        const depotIndexCache = {}
        resData.map(function(item, index) {
            if(depotIndexCache[item.depot_id]){
                depotIndexCache[item.depot_id].push(index)
            }else{
                depotIndexCache[item.depot_id] = [index]
            }
        })
        for (const depotIndexCacheKey in depotIndexCache) {
            const currOneSingleProduct = resData[depotIndexCache[depotIndexCacheKey][0]]
            const currDeoptInfo = {
                list: [],
                depot_name: RES.depotList.find(function(item){return item.id === currOneSingleProduct.depot_id}).name,
                depot_id: currOneSingleProduct.depot_id,
                inStockAmount: 0, // 库存合计
                stockWarnAmount: 0 // 库存预警合计
            }
            res.push(currDeoptInfo)
            depotIndexCache[depotIndexCacheKey].map(function (resDataIndex) {
                const currSingleProduct = resData[resDataIndex]
                const item = {
                    size_name: currSingleProduct.size_name,
                    color_name: currSingleProduct.color_name,
                    amount: numToCur(currSingleProduct.amount, systemSetting.amount_decimals_setting), // 库存
                }
                currDeoptInfo.inStockAmount += item.amount
                if(type === 'min'){
                    if(currSingleProduct.stock_warn_min || currSingleProduct.stock_warn_min === 0) {
                        const stock_warn_min = numToCur(currSingleProduct.stock_warn_min, systemSetting.amount_decimals_setting)
                        const min = numToCur(stock_warn_min - currSingleProduct.amount, systemSetting.amount_decimals_setting)
                        item.min = min < 0 ? '-' : min
                        item.stock_warn_min = stock_warn_min
                        item.color = min > 0 ? '#dc3c4e' : '#555'
                        min > 0 && (currDeoptInfo.stockWarnAmount += item.min)
                    }else{
                        item.min = '-'
                        item.stock_warn_min = '-'
                    }
                    item.type = 'min'
                }else if(type === 'max') {
                    if(currSingleProduct.stock_warn_max || currSingleProduct.stock_warn_min === 0){
                        const stock_warn_max = numToCur(currSingleProduct.stock_warn_max, systemSetting.amount_decimals_setting)
                        const max = numToCur(currSingleProduct.amount - stock_warn_max, systemSetting.amount_decimals_setting)
                        item.max = max < 0 ? '-' : max
                        item.stock_warn_max = stock_warn_max
                        item.color = max > 0 ? '#38ade1' : '#555'
                        max > 0 && (currDeoptInfo.stockWarnAmount += item.max)
                    }else{
                        item.max = '-'
                        item.stock_warn_max = '-'
                    }
                    item.type = 'max'
                }
                currDeoptInfo.list.push(item)
            })
            // 合计小数处理
            // currDeoptInfo.inStockAmount = numToCur(currDeoptInfo.inStockAmount, systemSetting.amount_decimals_setting)
            // currDeoptInfo.stockWarnAmount = numToCur(currDeoptInfo.stockWarnAmount, systemSetting.amount_decimals_setting)
        }
        // 否则当前是指定了仓库的 无需处理顺序
        if(RES.depotId === '-1'){
            const sortList = []
            RES.depotList.map(function(item) {
                sortList.push(res.find(function(resItem) { return item.id === resItem.depot_id}))
            })
            res = sortList
        }
    }
    return res
}