window.addEventListener('set_back', function (e){ // SN
	if (setProduct) {
		setProduct.product_sn_list_vip = e.detail.product_sn_list
	}
})
window.addEventListener('productionBatchSetting', function (e){ //BN
	if (setProduct) {
		setProduct.production_amount = Number(( setProduct.num * setProduct.display_unit_ratio).toFixed(4))
		setProduct.production_batch_id = e.detail.production_batch_id
		setProduct.production_batch_number = e.detail.production_batch_number
		setProduct.production_date_str = e.detail.production_date_str
		setProduct.production_date_timestamp = e.detail.production_date_timestamp
	}
})

window.addEventListener('productionBatchSelect', function (e){ //BN
	if (setProduct) {
		setProduct.production_amount = e.detail.production_amount
		setProduct.production_batch_id = e.detail.production_batch_id
		setProduct.production_batch_number = e.detail.production_batch_number
		setProduct.production_date_str = e.detail.production_date_str
		setProduct.product_expire_date_ms = e.detail.expire_date_ms
		setProduct.production_date_timestamp = e.detail.production_date_timestamp
	}
})

let VM = null
let setProduct = null
mui.plusReady(function(){
	/**
	 * arg
	 * orderType:
	 * // 开单-销售
	 * PRESENT_SALES: 1,
	 * // 开单-采购
	 * PRESENT_PURCHASE: 0,
	 */

	const currentWebview = plus.webview.currentWebview()
	const args = currentWebview.args
	const pageId = currentWebview.id

	let orderTypeStr = '采购'
	let productTypeZeroStr = '入'
	let productTypeOneStr = '出'
	if(args.orderType === CONSTANT.PRESENT_SALES){
		orderTypeStr = '销售'
		productTypeZeroStr = '出'
		productTypeOneStr = '入'
	}

	document.querySelector('.contentPage-title').innerHTML = orderTypeStr + productTypeZeroStr + '库'

	VM = new Vue({
		el: '#vm',
		data(){
			function getShowData() {
				const zeroTypeList = []
				const oneTypeList = []

				const extraMap = {}
				// 价格 主单位价格 或 辅单位价格 使用的单位数量
				function setUsePrice (p){
					// 是否是辅单位
					p.isRatio = false
					if (p.display_unit_ratio && p.display_unit_ratio !== 1) { //辅单位
						p.isRatio = true
					} else if (p.display_unit_ratio && p.display_unit_ratio === 1) {//主单位

					} else {
						p.display_unit_ratio = 1
					}
					// 操作数量 与 当前使用单位的单价
					p.usePrice = Number((p.amt * p.display_unit_ratio).toFixed(4))
					p.useAmount = Number((p.amount / p.display_unit_ratio).toFixed(4))
					p.useUsedAmount = Number((p.used_amount / p.display_unit_ratio).toFixed(4))
					p.maxNum = Number(( p.useAmount - p.useUsedAmount).toFixed(4))
				}
				let previousProductId_0 = null,
					previousProductId_1 = null
				args.data.productlist.forEach(function (product, index){
					product.key = index
					// 注意！这里的ordertype是序列号选择页的ordertype为单品的type，而不是单据的 orderType
					product.ordertype = product.type
					product.product_sn_list_vip = []
					// BN 没有序列号列表
					if(product.product_sn_list && product.product_sn_list.length !== 0){
						product.product_sn_list_old = product.product_sn_list.split(',')
						product.product_sn_list_status = product.product_sn_list_status.split(',')
					}else{
						product.product_sn_list_old = []
						product.product_sn_list_status = []
					}

					setUsePrice(product)
					if (product.type === 0 && product.is_extra !== 1 ) {
						zeroTypeList.push(product)
						if(previousProductId_0 !== product.product_id){
							previousProductId_0 = product.product_id
							product.isShowProductTitle = true
						}
					} else if (product.type === 1 && product.is_extra !== 1) {
						oneTypeList.push(product)
						if(previousProductId_1 !== product.product_id){
							previousProductId_1 = product.product_id
							product.isShowProductTitle = true
						}
					} else if (product.is_extra === 1){
						if ( !extraMap[product.parent_op_id] ) extraMap[product.parent_op_id] = []
						extraMap[product.parent_op_id].push(product)
					}
				})
				function fillExtra(typeList) {
					for (let i = 0; i < typeList.length;) {
						const p = typeList[i]
						if(extraMap[p.op_id] && extraMap[p.op_id].length){
							const l = extraMap[p.op_id].length
							extraMap[p.op_id].forEach(function (item, index) {
								typeList.splice(i + index + 1, 0, item)
							})
							i += l
						}else{
							i++
						}
					}
				}
				fillExtra(oneTypeList)
				fillExtra(zeroTypeList)

				return [
					zeroTypeList,
					oneTypeList
				]
			}
			const systemSetting =  JSON.parse(localStorage.systemSetting)
			return {
				orderType: args.orderType,
				orderTypeStr,
				productTypeZeroStr,
				productTypeOneStr,
				productTypeList: [productTypeZeroStr, productTypeOneStr],
				systemSetting: systemSetting,
				statistics: {
					totalPrice: 0,
					typeZero: 0,
					typeOne: 0
				},
				show: {
					size: Boolean(localStorage.size_show || 1),
					color:  Boolean(localStorage.color_show || 1),
					unit:  Boolean(localStorage.unit_show || 0),
					origin_specification:  Number(localStorage.origin_specification || 0),
					SN: !!systemSetting.sn_setting,
					BN: !!systemSetting.production_batch_setting,
					openOrderModel: false
				},
				openOrderModelData: null,
				purchaseManager: !!args.purchaseManager,
				draftData: args.data,
				showData: args.oldData || getShowData()
			}
		},
		components: {
			'v-open-order': httpVueLoader('components/v-components/openOrder.vue')
		},
		watch: {
			'show.openOrderModel': function(v) {
				if (v && this.showData){
					this.openOrderModelData = {
						draft: this.generateOrder(),
						// printData: this.generatePrintData()
					}
				}else{
					this.openOrderModelData = null
				}
			}
		},
		computed: {

		},
		methods: {
			setSN(product) {
				if(!product.num || Number(product.num <=0)){
					return mui.toast("请先选择出库数量")
				}
				let listSend = {
					item: product,
					args:{
						can_choose:product.num,
						product_id:product.product_id,
						model:product.model,
						name:product.name,
						qryPage: 'order_cai',
						qryPageId: pageId
					}
				};
				if(this.orderTypeStr === '销售'){
					listSend.args.qryPage = 'order_xiao'
				}
				setProduct = product
				viewHandle.openWindow("../sns_choose.html","sns_choose.html",JSON.stringify(listSend))
			},
			setBN(product, index) {
				if(!product.num || Number(product.num <=0)){
					return mui.toast("请先选择出库数量")
				}
				setProduct = product
				if(this.orderTypeStr === '采购' && index === 0) {
					mui.openWindow("../production_batch_set.html","production_batch_set.html",{extras: {
							productModel: product.product_model,
							colorName: product.color_name,
							sizeName: product.size_name,
							productionDateTimestamp: product.production_date_timestamp,
							expireDateMs: product.product_expire_date_ms,
							productionBatchId: product.production_batch_id,
							productionBatchNumber: product.production_batch_number,
							setPageId: pageId,
						}})
				} else {
					//批次号选择
					/**
					 *
					 */

					let type
					// 非当前商品的同规格商品
					let productList = []
					if(this.orderTypeStr === '采购'){
						type = 'cai'
					}else{
						type = 'xiao'
					}
					if (index === 1){
						type += 'tui'
					}
					this.showData[index].forEach(function(p){
						if ( p.num && p !== product && p.product_id === product.product_id && p.color_id === product.color_id && product.size_id === product.size_id ) {
							productList.push(p)
						}
					})

					mui.openWindow("../production_batch_select.html","production_batch_select.html",{
						extras: {
							productModel: product.product_model,
							colorName: product.color_name,
							sizeName: product.size_name,

							productionDateTimestamp: product.production_date_timestamp,
							expireDateMs: product.product_expire_date_ms,
							productionBatchId: product.production_batch_id,
							productionBatchNumber: product.production_batch_number,
							productionAmount: Number(( product.num * product.display_unit_ratio).toFixed(4)),
							usageAmount: Number(( product.num * product.display_unit_ratio).toFixed(4)),

							unitChooseName: product.display_unit_name,
							unitChooseRatio: product.display_unit_ratio,
							unitChooseId: product.display_unit_id,
							depotId: this.draftData.depot_id,
							setPageId: pageId,
							productList: productList, // 其他product
							product: product, // 当前product
							type: type
						}
					})

				}

			},
			getBNStyle(product, index) {
				let active = false
				if(this.orderTypeStr === '采购' && index === 0) { // 设置 只要设置了 那么就高亮
					active = (!!product.production_date_timestamp || product.production_batch_number || product.production_batch_id) && product.num
				} else {
					// 选择
					// active = (product.production_amount && product.production_amount === Math.floor(product.num) && product.num)
					// 改为设置就高亮
					active = (product.production_amount && product.num)
				}
				return {'background-color': active ? '#ffb03b': '#ccc'}
			},
			change(target, product) {
				target = Number(target)
				if (target <= 0) {
					this.$set(product, 'num', null)
				} else {
					if ( target > product.maxNum) {
						target = product.maxNum
					}
					if (target < product.product_sn_list_vip.length){
						product.product_sn_list_vip = product.product_sn_list_vip.slice(0, target)
						mui.toast('移除部分序列号')
					}
					let amount = Number(numToCur(target, this.systemSetting.amount_decimals_setting))
					if (target < product.production_amount){
						product.production_amount =  amount
					}
					this.$set(product, 'num', amount)
				}
				if((!!product.production_date_timestamp || product.production_batch_number || product.production_batch_id) && product.num){
					product.production_amount = product.isRatio ? Number(( product.num * product.display_unit_ratio).toFixed(4)) : product.num
				}
				this.calculateTheTotal()
				this.$forceUpdate()
			},
			productNumFill() {
				let _this = this
				this.showData.forEach(function(item){
					item.forEach(function(p){
						_this.change(p.maxNum, p)
					})
				})
				this.calculateTheTotal()
			},
			calculateTheTotal() {
				let totalPrice = 0,
					typeZero = 0,
					typeOne = 0;
				this.showData.forEach(function(item, index){
					item.forEach(function(p){
						if(!p.num)return
						// 主单位数量
						let amount = Number((p.num * p.display_unit_ratio).toFixed(4))
						let price = Number((p.num * p.usePrice).toFixed(4))
						if(index === 0){
							typeZero += amount
							totalPrice += price
						}else{
							typeOne += amount
							totalPrice -= price
						}
					})
				})
				this.$set(this.statistics, 'totalPrice', totalPrice)
				this.$set(this.statistics, 'typeZero', typeZero)
				this.$set(this.statistics, 'typeOne', typeOne)
			},
			showOpenOrderModel() {
				let err = this.verifyListLength()
				if (err) {
					return mui.toast(err)
				}
				err = this.verifyAmountData()
				if (err) {
					return mui.toast(err)
				}
				if ((!err) && this.show.SN){
					err = this.verifyAmountDataSN()
				}
				if ((!err) && this.show.BN){
					err = this.verifyAmountDataBN()
				}
				if (err){
					let _this = this
					mui.confirm(err, '提示', ['取消', '确定'], function(e) {
						if (e.index === 1) {
							_this.show.openOrderModel = true
						}
					}, 'div')
				}else{
					this.show.openOrderModel = true
				}
			},
			// emitUpdateOpenOrderAmount() {
			// 	mui.fire(plus.webview.getWebviewById(args.pageId), 'updateOpenOrderAmount', {amountData: this.showData})
			// 	mui.back()
			// },
			openOrderSuccess(){
				mui.fire(plus.webview.getWebviewById(args.pageId), 'reload')
				let loading = viewHandle.loading('开单成功！')
				setTimeout(function (){
					loading.close()
					mui.back()
				},1000)
			},
			verifyAmountDataSN() {
				for (let i = 0; i < this.showData.length; i++) {
					const item = this.showData[i]
					for (let i = 0; i < item.length; i++) {
						const p = item[i]
						if(Math.floor(p.num) !== p.product_sn_list_vip.length){
							return '已选择数量与序列号不对应，继续？'
						}
					}
				}
				return false
			},
			verifyAmountDataBN() {
				return false
			},
			verifyAmountData() {
				let isNoNum = true
				for (let i = 0; i < this.showData.length; i++) {
					let allOutOfStockMap = {}
					let zeroOutOfStockMap = {}
					const item = this.showData[i]
					for (let i = 0; i < item.length; i++) {
						const p = item[i]
						if(p.num && isNoNum){
							isNoNum = false
						}
						// 这里要保证顺序 主商品在特殊商品之前
						if(p.is_extra){
							if (Number((p.maxNum - p.num).toFixed(4)) !== 0 && allOutOfStockMap[p.parent_op_id] === true) {
								return '特殊商品:' + p.product_name + '颜色:' + p.color_name + '规格:' + p.size_name + '未全部出库时主商品全部出库'
							} else if( p.num && zeroOutOfStockMap[p.parent_op_id] === true) {
								return '特殊商品:' + p.product_name + '颜色:' + p.color_name + '规格:' + p.size_name + '出库时不存在主商品'
							}
						} else {
							if (Number((p.maxNum - p.num).toFixed(4)) === 0) { // 主商品全部出库
								allOutOfStockMap[p.op_id] = true
							} else if(!p.num) {
								zeroOutOfStockMap[p.op_id] = true
							}
						}
					}
				}
				if(isNoNum){
					return '请选择数量'
				}
				return false
			},
			verifyListLength() {
				let order = this.generateOrder()
				if(order.productlistlength > 300){
					return '超过300行商品，无法保存！'
				}
				return false
			},
			generateOrder(){
				const productList = []
				let purchaseIn = this.orderTypeStr === '采购'
				let SN = this.show.SN
				let BN = this.show.BN
				let order_amt = this.statistics.totalPrice
				let amount = Number((this.statistics.typeZero - this.statistics.typeOne).toFixed(4))
				this.showData.forEach(function(i, index){
					i.forEach(function (p) {
						if(p.num){
							p = JSON.parse(JSON.stringify(p))
							if(p.isRatio){
								p.amount = Number((p.num * p.display_unit_ratio).toFixed(4))
							}else{
								p.amount = p.num
							}
							if(BN){
								if( purchaseIn && index === 0){ // 采购入库
									p.production_amount = p.amount
								}
								if(!p.production_date_str && p.production_date_timestamp){
									p.production_date_str = $comm.DATE_UTIL.formatDate(new Date(p.production_date_timestamp),false)
								}
								p.expire_date_ms = p.product_expire_date_ms
								if(p.expire_date_ms === null){
									delete p.expire_date_ms
								}
							}else{
								delete p.production_batch_number
								delete p.production_batch_id
								delete p.production_date_str
								delete p.product_expire_date_ms
								delete p.production_amount
							}
							if(SN){

							}else{

							}
							p.sale_price = p.amt
							p.unitChooseId = JSON.parse(JSON.stringify(p.display_unit_id))
							p.unitChooseName = JSON.parse(JSON.stringify(p.display_unit_name))
							p.unitChooseRatio = JSON.parse(JSON.stringify(p.display_unit_ratio))
							p.is_extra = p.is_extra ? 1 : 0
							p.product_sn_list = p.product_sn_list_vip ? p.product_sn_list_vip.slice(',') : []
							// 删除无用 属性
							delete p.display_unit_id
							delete p.display_unit_name
							delete p.display_unit_ratio
							delete p.product_sn_list_vip
							delete p.product_sn_list_status
							delete p.product_sn_list_old
							delete p.product_sn_used_list
							delete p.product_sn_used_list_status
							delete p.barcode
							delete p.changetimestamp
							delete p.company_id
							delete p.customer_id
							delete p.product_expire_date_ms
							delete p.isRatio
							delete p.isShowProductTitle
							delete p.key
							delete p.maxNum
							delete p.num
							delete p.ordertype
							delete p.ordertype_copy
							delete p.quoted_price
							delete p.sign_date_timestamp
							delete p.sn_filled
							delete p.sn_filled_amount
							delete p.submit_status_copy
							delete p.tax
							delete p.tax_rate
							delete p.unit
							delete p.useAmount
							delete p.usePrice
							delete p.useUsedAmount
							delete p.used_amount
							delete p.used_sn_filled
							delete p.used_sn_filled_amount
							delete p.zhamt
							delete p.zkl
							delete p.sale_price_a
							delete p.sale_price_b
							delete p.id
							delete p.sign_date
							delete p.material

							productList.push(p)

						}
					})
				})
				return {
					draft_order_id: this.draftData.id,
					ordersn: $comm.getOrderSn(),
					remark: this.draftData.remark,
					sign_date: null,
					customer_id: this.draftData.customer_id,
					depot_id: this.draftData.depot_id,
					rebate_amt: this.draftData.rebate_amt,
					order_amt: order_amt,
					amount: amount,
					ordertype: this.draftData.ordertype,
					submit_status: 0,
					productlistlength: productList.length,
					pay_status: this.draftData.pay_status || 1,
					account_id: this.draftData.account_id || 1,
					account_name: this.draftData.account_name,
					productlist: productList,
					logistics_number: this.draftData.logistics_number,
					consignee_address: this.draftData.consignee_address,
					address: this.draftData.address,
					delivery_company: this.draftData.delivery_company,
					debt_status: 0,
					debt_amt: 0,
					org_debt_amt: 0,
					deduction_amt: this.draftData.deduction_amt,
					delivery_status: this.draftData.delivery_status,
					delivery_type: this.draftData.delivery_type,
					delivery_date: this.draftData.delivery_date,
					other_cost_name: this.draftData.other_cost_name || '', //费用名称
					other_cost_price: this.draftData.other_cost_price || 0, //费用
					other_cost_purchase: this.draftData.other_cost_purchase || 0, //成本
					other_id: this.draftData.other_id || '' //费用id
				}
			}
		},
		beforeCreate(){
			console.log('beforeCreate')
		},
		created(){
			console.log('created')
		},
		beforeMount(){
			console.log('beforeMount')
			let _this = this
			if(args.oldData){
				this.calculateTheTotal()
			}
			let ids = []
			this.draftData.productlist.forEach(function(v){
				if(ids.indexOf(v.product_id) === -1)
					ids.push(v.product_id)
			})
			if(ids.length){
				const depot_id = _this.draftData.depot_id
				$API.product.qryColorSizeUnitByProductIds({product_ids: ids.join(';')}).then(function(e){
					let attrs = e.data
					function fillColorSizeId(l){
						l.forEach(function (v){
							let curr = attrs.find(function(a){
								return a.product_id === v.product_id
							})
							if(curr && curr.color_size_ids){
								let p = curr.color_size_ids.find(function(a){
									return a.color_id === v.color_id && a.size_id === v.size_id && a.depot_id === depot_id
								})
								if(p){
									v.product_color_size_id =  p.product_color_size_id
								}else{
									console.error('没有对应的商品product_color_size_id')
								}
							}else{
								console.error('没有对应的商品')
							}
						})
					}
					fillColorSizeId(_this.showData[0])
					fillColorSizeId(_this.showData[1])
				})
			}

		},
		mounted(){
			console.log('mounted')
		},
		beforeUpdate(){
			console.log('beforeUpdate')
		},
		updated(){
			console.log('updated')
		},
		beforeDestroy(){
			console.log('beforeDestroy')
		},
		destroyed(){
			console.log('destroyed')
		}

	})


})
